module.exports = function (grunt) {

    grunt.initConfig({
        pkg: grunt.file.readJSON('package.json'),
        compress: {
            main: {
                options: {
                    archive: '../xcontact-server-old.zip',
                    mode: 'zip'
                },
                files: [
                    { expand: true, cwd: 'dist/', src: ['**/*'], dest: 'xcontact-server/' },
                    { src: ['node_modules/**'], dest: 'xcontact-server/' }
                ]
            }
        },
        obfuscator: {
            all: {
                files: [
                    {
                        expand: true,
                        src: 'app.js',
                        dest: 'dist',
                        cwd: '.'
                    },
                    {
                        expand: true,
                        src: 'ami/*.js',
                        dest: 'dist',
                        cwd: '.'
                    },
                    {
                        expand: true,
                        src: 'ari/*.js',
                        dest: 'dist',
                        cwd: '.'
                    },
                    {
                        expand: true,
                        src: 'bots/**/*.js',
                        dest: 'dist',
                        cwd: '.'
                    },
                    {
                        expand: true,
                        src: 'csa/*.js',
                        dest: 'dist',
                        cwd: '.'
                    },
                    {
                        expand: true,
                        src: 'discador/*.js',
                        dest: 'dist',
                        cwd: '.'
                    },
                    {
                        expand: true,
                        src: 'email/*.js',
                        dest: 'dist',
                        cwd: '.'
                    },
                    {
                        expand: true,
                        src: 'mail_notifier/*.js',
                        dest: 'dist',
                        cwd: '.'
                    },
                    {
                        expand: true,
                        src: 'models/*.js',
                        dest: 'dist',
                        cwd: '.'
                    },
                    {
                        expand: true,
                        src: 'plugins/*.js',
                        dest: 'dist',
                        cwd: '.'
                    },
                    {
                        expand: true,
                        src: 'rest_api/**/*.js',
                        dest: 'dist',
                        cwd: '.'
                    },
                    {
                        expand: true,
                        src: 'util/*.js',
                        dest: 'dist',
                        cwd: '.'
                    },
                    {
                        expand: true,
                        src: 'webChat/*.js',
                        dest: 'dist',
                        cwd: '.'
                    },
                    {
                        expand: true,
                        src: 'webrtc/**/*.js',
                        dest: 'dist',
                        cwd: '.'
                    },
                    {
                        expand: true,
                        src: 'whatsApi/*.js',
                        dest: 'dist',
                        cwd: '.'
                    },
                    {
                        expand: true,
                        src: 'ws/*.js',
                        dest: 'dist',
                        cwd: '.'
                    }
                ]
            }
        }
    });
    //grunt.loadNpmTasks('grunt-contrib-uglify');
    //grunt.loadNpmTasks('grunt-contrib-clean');
    //grunt.loadNpmTasks('grunt-contrib-copy');
    grunt.loadNpmTasks('grunt-contrib-obfuscator');
    grunt.loadNpmTasks('grunt-contrib-compress');
    grunt.registerTask('default', ['uglify', 'compress']);
};