const dotenv = require('dotenv');
const config = require('./config.json');
dotenv.config();

if (process.env && process.env.DEV_HOST) {
    console.log(`DEV Host informado no arquivo .env ${process.env.DEV_HOST}`);
    config.database.host = process.env.DEV_HOST;
    config.asterisk.host = process.env.DEV_HOST;
}

const QueueCalls = require('./models/QueueCalls');
const QueueCallsTags = require('./models/QueueCallsTags');
const Tags = require('./models/Tags');


async function exec () {
    try {
        const q = QueueCalls.query;
        q.leftJoin(
            QueueCallsTags.query
                .leftJoin(Tags)
        );
        q.where(QueueCalls.where.between({ 'calldate': ['2023-07-01 00:00:00', '2023-09-26 23:59:59'] }))
        // q.orderBy('"queueChatMessages".id ASC');
        const ret = await q.require(false).fetch();
        console.log(JSON.stringify(ret,null,2))
    } catch (error) {
        console.log(`Deu m, erro = ${error}`);
        console.log(error)
    }
}

exec();