'use strict'
const config = require('../config');
const XClientes = require('../util/XClients');
const xc = new XClientes();
const moment = require('moment-timezone');
moment.tz.setDefault(config.servidor.timezone);
class Agente {

    constructor(ramal) {
        this.ramal = ramal;
        this.status = 0;
        this.ligacoes_ativas = [];
        this.chats_ativos = [];
        this.StatusMap = new Map();
        this.StatusMap.set(0, 'Desconhecido');
        this.StatusMap.set(1, 'Disponível');
        this.StatusMap.set(2, 'Ocupado');
        this.StatusMap.set(3, 'Ocupado');
        this.StatusMap.set(4, 'Inválido');
        this.StatusMap.set(5, 'Indiponível');
        this.StatusMap.set(6, 'Tocando');
        this.StatusMap.set(7, 'DEVICE_RINGINUSE');
        this.StatusMap.set(8, 'Aguardando');
        this.StatusMap.set(10, 'Pausa');
        this.max_chat_atende = 20;
    }

    async getChatFromDb(fullname) {

    }

    async getMaxChatAtendeFromDb(ramal) {
        var max = await xc.getMaxChatAtende(ramal);
        if (max && max !== null) {
            this.max_chat_atende = max;
        }
    }

    addOrUpdateLigacao(ligacao, fila) {
        let nova = true;
        for (let i = 0; i < this.ligacoes_ativas.length; ++i) {
            let l = this.ligacoes_ativas[i];
            if (l.uniqueid === ligacao.uniqueid) {
                nova = false;
                for (const co in ligacao) {
                    l[co] = ligacao[co];
                }
            }
        }
        if (nova) {
            if (ligacao.sentido === 'Sainte') {
                if (!this.efetuada) this.efetuada = 0;
                fila.efetuadas++;
                this.efetuada++;
            }
            this.ligacoes_ativas.push(ligacao);
        }
    }

    addChat(chat) {
        let nova = true;
        for (let i = 0; i < this.chats_ativos.length; i++) {

            let c = this.chats_ativos[i];
            if (c === chat.protocolo) {
                nova = false;
                for (const x in chat) {
                    c[x] = chat[x].protocolo;
                }
            }
        }
        if (nova) {
            this.chats_ativos.push(chat.protocolo);
        }
    }

    removeChat(chat) {
        for (let i = 0; i < this.chats_ativos.length; i++) {
            let c = this.chats_ativos[i];
            if (c == chat.protocolo) {
                this.chats_ativos.splice(i, 1);
            }
        }
    }

    removeLigacao(ligacao, callback) {
        for (let i = 0; i < this.ligacoes_ativas.length; ++i) {
            if (this.ligacoes_ativas[i].uniqueid === ligacao.uniqueid) {
                if (ligacao.fim === 'Cliente') {
                    this.finalizada++;
                }
                else if (ligacao.fim === 'Agente') {
                    this.finalizou++;
                }
                else if (ligacao.fim === 'NaoAtendeu') {
                    this.naoatendeu++;
                }
                else if (ligacao.fim === 'Dump') {
                    this.dump++;
                }
                else if (ligacao.fim === 'FilaAbandono') {
                    this.ligacoes--;
                }
                else {
                    this.transferiu++;
                }
                this.ligacoes_ativas.splice(i, 1);
                if (callback) callback(); else return true;
            }
        }
    }

    getLigacao(uniqueid, callback) {
        for (let i = 0; i < this.ligacoes_ativas.length; ++i) {
            let l = this.ligacoes_ativas[i];
            if (l.uniqueid === uniqueid) {
                if (callback) callback(l); else return l;
            }
        }
        if (callback) callback(null); else return null;
    }

    setStatusLigacao(ligacao) {
        for (let i = 0; i < this.ligacoes_ativas.length; ++i) {
            if (this.ligacoes_ativas[i].uniqueid === ligacao.uniqueid) {
                this.ligacoes_ativas[i].StatusNome = ligacao.StatusNome;
                this.ligacoes_ativas[i].DataStatus = moment.tz(config.servidor.timezone).format('DD-MM-YYYY HH:mm:ss');
                break;
            }
        }
    }

    getStatusNome() {
        return this.StatusMap.get(this.status);
    }

    getNome() {
        return this.nome;
    }

}

module.exports = Agente;
