const log = require('../util/Log');
const ws = require('../ws/index');

exports.FilaStatus = (filas) => {
    //console.log('Nivel do LOG:', log.getLevel());
    log.debug('[Ami:Events] Enviando evento FilasStatus');
    try {
        // Remove array de ligacoes_atendidas
        const newfila = JSON.parse(JSON.stringify(filas)).map(function (f) {
            f.ligacoes_atendidas = [];
            f.atendimentos = [];
            f.agentes = f.agentes.map(agente => {
                if (agente) agente.atendimentos = [];
                return agente;
            })
            return f;
        });


        const ret = { event: 'FilasStatus' };
        ret.filas = newfila;
        //  ws.broadcast(ret);
    } catch (ex) {
        log.error("[Ami:Events]: Falha ao enviar evento FilasStatus. ERRO: " + ex.toString());
    }
}

function AgenteEvent(event, agente) {
    log.debug(`[Ami:Events] Enviando evento ${event}`);
    try {
        const ret = { event: event };
        if (agente) agente.atendimentos = [];
        ret.agente = agente;
       // ws.broadcast(ret);
        ws.io.of('/omni').to(`Agente.${agente.nome}`).emit('message', ret);
        ws.wsEvento.emit(`${event}`, agente);
    } catch (ex) {
        log.error(`[Ami:Events]: Falha ao enviar evento ${event}. ERRO: ` + ex.toString());
    }
}

exports.AgenteAdicionado = (agente) => {
    AgenteEvent('AgenteAdicionado', agente);
}

exports.AgentePausa = (agente) => {
    AgenteEvent('AgentePausa', agente);
}

exports.AgenteStatus = (agente) => {
    AgenteEvent('AgenteStatus', agente);
}

exports.AgenteRemovido = (agente) => {
    AgenteEvent('AgenteRemovido', agente);
}

exports.AgenteCadastroUpdate = (agente) => {
    AgenteEvent('AgenteCadastroUpdate', agente);
}
