const ClienteAtendimento = require("../../models/ClienteAtendimento");
const AtendimentoMensagem = require("../../models/AtendimentoMensagem");
const Ami = require("../../ami/index");
const moment = require("moment");
const ws = require("../../ws/index");
const config = require("../../config.json");
const log = require("simple-node-logger").createSimpleLogger({
  logFilePath: "/var/log/xcontact.log",
  timestampFormat: "DD-MM-YYYY HH:mm:ss.SSS",
});
log.setLevel(config.log ? config.log : "error");
moment.locale("pt-br");
const cron = require("node-cron");
const schedule = require('node-schedule');
process.on('SIGINT', function () { 
  schedule.gracefulShutdown()
  .then(() => process.exit(0))
})
const EventEmitter = require("events");
const event = new EventEmitter();

var timer = [];
var timer_transbordos = [];

event.on("job_completed", (atendimento) => {
  let index = timer.findIndex((t) => t.id === atendimento.id);
  if (index !== -1) {
    //clearTimeout(timer[index].countDown);
    // timer[index].countDown.stop();
  }
});
event.on("job_completed_transbordos", (atendimento) => {
  let index = timer_transbordos.findIndex((t) => t.id === atendimento.id);
  if (index !== -1) {
    //clearTimeout(timer[index].countDown);
    // timer_transbordos[index].countDown.stop();
  }
});
module.exports = class autoEncerramento {
  processaTimersCliente(fila, atendimento, lastMsg, time) {
    const OmniManager = require("../../xc_modules/omni/index");
    let aux = {};
    aux.id = atendimento.id;
    aux.timer = time * 60000;
    aux.inOut = lastMsg.inOut;
    const now = new Date();
    const horaExecucao = new Date(now.getTime() + time * 60 * 1000);
    aux.countDown =  schedule.scheduleJob(horaExecucao, async () => {      
        let auxAtendimento = await ClienteAtendimento.fetchById(atendimento.id);
        //caso seja timer de preatendimento vamos verificar se ja na passou para uma fia de atendimento
        if (auxAtendimento.status === atendimento.status  && auxAtendimento.ultimoAgente === atendimento.ultimoAgente) {
          atendimento.status = "Encerrado";
          atendimento.dataFim = new Date(moment.tz(config.servidor.timezone));
          atendimento.save();
          // new ClienteAtendimento(atendimento).save({ require: false });
          // remover aguardando
          OmniManager.OmniEventos.emit("removeAguardando", {
            fila,
            atendimento,
          });
          OmniManager.OmniEventos.emit("removeAtendimentoNaFila", {
            fila: atendimento.queue,
            agente: atendimento.ultimoAgente,
            atendimentoId: atendimento.id,
            data: new Date(),
            tipo: "atendido",
          });
          OmniManager.autoReply(atendimento, undefined, 7);
          if (atendimento.ultimoAgente) {
            // var socketAgente = await ws.getSocketAgenteByFullName(atendimento.ultimoAgente);
            // socketAgente.emit('message', JSON.stringify({ id: atendimento.id, event: "RemoveAtendimento" }));
            let aux = {};
            aux.event = "getMeusAtendimentos";
            aux.agente = atendimento.ultimoAgente;
            aux.id = atendimento.id;
            OmniManager.OmniEventos.emit("removeAtendimentoClient", {
              atendimento: atendimento,
            });
            ws.broadcastEvent("RemoveAtendimento", aux);
           
          }
        } else {
          let index = timer.findIndex((t) => t.id === atendimento.id);
          if (index !== -1) {
            //clearTimeout(timer[index].countDown);
            timer.splice(index, 1);
          }
        }
      }
    );
    timer.push(aux);
  }
  processaTransbordo(fila, atendimento, time) {
    const OmniManager = require("../../xc_modules/omni/index");
    let aux = {};
    aux.id = atendimento.id;
    aux.timer = time * 60000;
    const now = new Date();
    const horaExecucao = new Date(now.getTime() + time * 60 * 1000);    
    aux.countDown =  schedule.scheduleJob(horaExecucao, async () => {
        event.emit(`job_completed`, atendimento);
        let auxAtendimento = await ClienteAtendimento.fetchById(atendimento.id);
        if (auxAtendimento.status !== atendimento.status) {
          let index = timer_transbordos.findIndex(
            (t) => t.id === atendimento.id
          );
          if (index !== -1) {
            //clearTimeout(timer[index].countDown);
            timer_transbordos.splice(index, 1);
          }
          return;
        }
        if (auxAtendimento.status === atendimento.status  && auxAtendimento.ultimoAgente === atendimento.ultimoAgente) {
          atendimento.status = "Entrou";
          atendimento.queueFrom = atendimento.queueFrom
            ? atendimento.queueFrom
            : atendimento.queue;
          atendimento.queue = fila.filaTransbordo;
          OmniManager.OmniEventos.emit("removeAguardando", {
            fila: atendimento.queueFrom,
            atendimento,
          });
          OmniManager.OmniEventos.emit("removeAtendimentoNaFila", {
            fila: atendimento.queueFrom,
            agente: atendimento.ultimoAgente,
            atendimentoId: atendimento.id,
            data: new Date(),
            tipo: "atendido",
          });
          new ClienteAtendimento(atendimento).save({ require: false });
          // add aguardando
          let filaaux = Ami.getFila(fila.filaTransbordo, atendimento);
          OmniManager.addAguardando(filaaux, atendimento);
          OmniManager.autoReply(atendimento, undefined, 4);
          if (atendimento.ultimoAgente) {
            var socketAgente = ws.getSocketAgenteByFullName(
              atendimento.ultimoAgente
            );
            OmniManager.OmniEventos.emit("removeAtendimentoClient", {
              atendimento: atendimento,
            });
            socketAgente.emit(
              "message",
              JSON.stringify({ id: atendimento.id, event: "RemoveAtendimento" })
            );
          }
        }      
      }
    );
    timer_transbordos.push(aux);
  }
  async addTransbordo(atendimento) {
    let fila = await Ami.getFila(atendimento.queue);
    let aux = {};
    aux.id = atendimento.id;
    if (fila.timerTransbordo && parseInt(fila.timerTransbordo) > 0) {
      this.processaTransbordo(
        fila,
        atendimento,
        parseInt(fila.timerTransbordo)
      );
    }
  }
  async removeTimerTransbordo(atendimento) {
    try {
      let index = timer_transbordos.findIndex((t) => t.id === atendimento.id);
      if (index !== -1) timer_transbordos[index].countDown.cancel();
      timer_transbordos.splice(index, 1);
    } catch (error) {
      console.error(error);
    }
  }
  async addTimer(socket, atendimento, lastMsg) {
    try {
      if (!timer) timer = [];
      let fila = await Ami.getFila(atendimento.queue);
      let aux = {};
      aux.id = atendimento.id;
      // Aqui verificamos o tipo da mensagem, caso seja 1 vamos apenas encerrar o atendimento apos o tempo, caso 2 iremos ecerrar o atendimento e disparar a mensagem automatica
      if (lastMsg.inOut !== 1) {
        //Caso a ultima menasgem seja do xcontact ou do agente
        // console.log("ADDTIMER VAMOS VER A FILA", fila);
        if (fila.timeout && fila.timeout > 0) {
          this.processaTimersCliente(fila, atendimento, lastMsg, fila.timeout);
        }
        if (
          fila.timerPreAtendimento &&
          parseInt(fila.timerPreAtendimento) > 0
        ) {
          console.log(`TINHA PRE ATENDIMENTO`);
          this.processaTimersCliente(
            fila,
            atendimento,
            lastMsg,
            parseInt(fila.timerPreAtendimento)
          );
        }
      } else {
        if (fila.maximo > 0 && atendimento.ultimoAgente) {
          aux.timer = fila.maximo * 60000;
          aux.inOut = lastMsg.inOut;
          const now = new Date();
          const horaExecucao = new Date(
            now.getTime() + parseInt(fila.maximo) * 60 * 1000
          );
          const OmniManager = require("../../xc_modules/omni/index");
          aux.countDown = schedule.scheduleJob(horaExecucao, async () => {
              event.emit(`job_completed_transbordos`, atendimento);
              console.log(`VAMOS REMOVER E MANDAR A MENSAGEM`);
              let auxAtendimento = await ClienteAtendimento.fetchById(
                atendimento.id
              );
              if (auxAtendimento.status === atendimento.status) {
                atendimento.status = "Encerrado";
                atendimento.dataFim = new Date(
                  moment.tz(config.servidor.timezone)
                );
                atendimento.save();
                OmniManager.OmniEventos.emit("removeAguardando", {
                  fila,
                  atendimento,
                });
                OmniManager.OmniEventos.emit("removeAtendimentoClient", {
                  atendimento: atendimento,
                });
                // ws.broadcastEvent(`RemoveAtendimento`,{agente:atendimento.ultimoAgente,id:atendimento.id});
                let aux = {};
                aux.event = "getMeusAtendimentos";
                aux.agente = atendimento.ultimoAgente;
                aux.id = atendimento.id;
                ws.broadcastEvent("RemoveAtendimento", aux);
              } else {
                let index = timer.findIndex((t) => t.id === atendimento.id);
                if (index !== -1) {
                  //clearTimeout(timer[index].countDown);
                  timer.splice(index, 1);
                }
              }
            }            
          );
          timer.push(aux);
        }
      }
    } catch (error) {
      console.log(error);
    }
  }

  async removeTimer(socket, atendimento, lastMsg) {
    try {
      
     timer.map((t) => {
        if (t.id === atendimento.id && lastMsg.inOut !== t.inOut) {         
         t.countDown.cancel();         
        }
      });
      timer = timer.filter( a => a.id !== atendimento.id)

     this.addTimer(socket, atendimento, lastMsg);
    } catch (error) {
      console.error(error);
    }
  }

  async verificaTimer(socket, atendimento) {
    let that = this;
    setTimeout(async () => {
      try {
        var lastMsg = await AtendimentoMensagem.query
          .require(true)
          .first()
          .where({ idAtendimento: atendimento.id })
          .orderBy(`id DESC`)
          .fetch();
        // console.log("ULTIMA MENSAGEM", lastMsg);
        if (timer.length > 0) {
          let data = timer.filter((t, i) => {
            if (t.id === atendimento.id && lastMsg.inOut !== t.inOut) {
              return t;
            }
          });
          if (data && data.length > 0) {
            console.log(`ACHAMOS O TIMER`);
            await that.removeTimer(socket, atendimento, lastMsg);
          } else {
            console.log(`NAO ACHAMOS O TIMER`);
            await that.addTimer(socket, atendimento, lastMsg);
          }
        } else {
          await that.addTimer(socket, atendimento, lastMsg);
        }
      } catch (error) {
        console.error(error);
        return;
      }
    }, 1000);
  }
};
