const Ami = require('../../ami/index')

let agentesPausados = [];
const MOTIVO_AUTO_PAUSA = "AutoPausa";

Ami.XCeventos.on('AgenteAtendeu', agente => {
    try {
        console.log(`Agente atendeu no meu novo modulo`)
        let agenteEncontrado = Ami.getAgenteLogadoByRamal(agente.ramal).find(x => x);

        if (agente.tempo_auto_pausa) {
            if (agente.status == 10) {
                console.log(`[AUTO-PAUSA] Ignorando o agente '${agente.nome}'... Já está em pausa!`);

            } else {
                pauseAgent(agente.ramal, MOTIVO_AUTO_PAUSA);
                agentesPausados.push(agenteEncontrado);
            }

        } else {
            console.log(`[AUTO-PAUSA] Ignorando o ramal '${agente.ramal}'... Não possui auto-pausa definida!`);
        }
    } catch (error) {
        console.log(`[AUTO-PAUSA-ERROR Agente Atendeu] ${error}`)
    }
})

Ami.XCeventos.on('Desliga', evento => {
    try {
        console.log('AGENTE DESLIGOU NO MEU NOVO MODULO')
        if (agentesPausados && agentesPausados.length > 0) {
            let ramal = evento.channel.split('-')[0];
            let agente = agentesPausados.find(x => x.ramal === ramal);

            if (agente) {
                agentesPausados.splice(agentesPausados.indexOf(agente), 1);
                let tempoPausa = parseInt(agente.tempo_auto_pausa) * 1000;
                setTimeout(scheduleAutomaticUnpause.bind(this, agente), tempoPausa);
                console.log(`[AUTO-PAUSA] O ramal '${ramal}'... iniciou o processo de finalização da auto-pausa!`);

            } else {
                console.log(`[AUTO-PAUSA] Ignorando o ramal '${ramal}'... Não iniciou o processo de auto-pausa!`);
            }
        }
    } catch (error) {
        console.log(`[AUTO-PAUSA-ERROR Desliga] ${error}`)
    }

})

function scheduleAutomaticUnpause (agente) {
    try {
        console.log(`[AUTO-PAUSA] Agente '${agente.nome}' saiu do estado de auto-pausa!`);
        if (agente.status !== 10 || agente.pausa_motivo !== MOTIVO_AUTO_PAUSA) {
            return console.log(`[AUTO-PAUSA] Ignorando o agente '${agente.nome}' porque não está em auto-pausa.`);
        } else {
            unpauseAgent(agente.ramal);
        }
    } catch (error) {
        console.trace(error);
        console.log(`[AUTO-PAUSA] Erro ao despausar agente '${agente.ramal}'!\n${error}`);
    }
}

function pauseAgent (ramal, motivo) {
    return new Promise((resolve, reject) => {
        let filas = Ami.getFilasLogadasDoAgente(ramal);
        filas.forEach(f => {
            let options = { ramal, fila: f.nome, motivo };

            // Envia o comando para o AMI
            Ami.QueuePause(options, e => {
                if (e.response === "Error") reject(e.message);
                else resolve(e.message);
            });
        });
    });
}

function unpauseAgent (ramal, motivo) {
    return new Promise((resolve, reject) => {
        let filas = Ami.getFilasLogadasDoAgente(ramal);
        filas.forEach(f => {
            let options = { ramal, fila: f.nome, motivo };

            // Envia o comando para o AMI
            Ami.QueueUnpause(options, e => {
                if (e.response === "Error") reject(e.message);
                else resolve(e.message);
            });
        });
    });
}