const FilaPreAtendimento = require('../../models/FilaPreAtendimento');
const FilaPreAtendimentoOpcoes = require('../../models/FilaPreAtendimentoOpcoes');
const ClienteAtendimento = require('../../models/ClienteAtendimento');
const AtendimentoMensagem = require('../../models/AtendimentoMensagem')
let MensagemAnexos = require('../../models/MensagemAnexos');
const Cliente = require('../../models/Cliente');
const Fila = require('../../models/Fila');
const FilaTemp = require('../../util/FilaTemp');
const Ami = require('../../ami/index');
const config = require('../../config.json');
const ws = require("../../ws/index");
const UraProcessor = require('./UraProcessor');
const UraTextoFilas = require('../../models/uraTextoFilas');
const UraTexto = require('../../models/uraTexto');
const db = require('../../util/db');
const moment = require('moment');
const Omni = require('../../xc_modules/omni/index');
var autoEncerramento = new (require('../../bots/autoEncerramento/index'));
var queue = require('queue');
var processaQueue = queue({
    autostart: true,
    concurrency: 1
});
const {Log} = require('../../util/LogNew')
const log = new Log('pre-atendimento-index', Log.levelDebug)

module.exports = class preAtendimento {

    constructor() {
    }
    //#region SET QUEUE
    async setQueue(data, metodo) {
        console.log(`ENTROU NO SET QUEUE ${metodo}=============================`)
        let that = this;
        let job = async function () {
            try {
                if (metodo === 'sendMsg') await that.sendMsgQueued(data);

            } catch (error) {
                console.log(error);

            }
        };
        //job.id = metodo;
        if (metodo === 'sendMsg') {
            processaQueue.push(job);
            console.log(processaQueue);
        }


    }
    //#endregion

    //#region EnviarMensagemTodasAsMidias
    async enviarMensagem() {

    }
    //#endregion

    async getTrocaVarTexto(texto, trocas) {
        if (typeof trocas === 'object') {
            Object.entries(trocas).forEach(([key, value]) => {
                texto = texto.split(key).join(value);
            });
            return texto;
        }
    }

    async checkUraDb(fila) {
        try {
            return await UraTextoFilas.query.require(true)
                .where({ fila: fila })
                .fetch();
        } catch (error) {
            // log.error(error);
            return false;
        }
    }

    /**
     * Verifica se a fila tem ura em arquivo
     * @param {String} fila
     */
    checkUraFile(fila) {
        if (!config.ura_arquivo) return false;

        let tem = false;
        config.ura_arquivo.forEach(ura => {
            if (ura.fila == fila) tem = ura;
        })
        return tem;
    }

    async _getPreAtendimentoAtivo(cliente, msg, fila) {
        try {
            const at = await ClienteAtendimento.query.require(true).first()
                .where({ idCliente: cliente.id })
                .where({ queue: fila })
                .where({ status: 'PreAtendimento' })
                .fetch();
            return at;
        } catch (error) {
            try {
                const atnew = await new ClienteAtendimento({ sentido: 'Entrante', fromID: msg.idCliente, fromName: cliente.nome, queue: fila, idCliente: cliente.id, ativo: false, status: 'PreAtendimento', queueTypeID: msg.queueTypeID, action: 'WhatsAppIn', dadosAdicionais: { "nome": msg.name, "remetente": msg.from } }).insert();
                Omni.OmniEventos.emit('filaNovoAtendimento', {fila:atnew.queue,   numero: cliente.numero, nome: cliente.nome,  atendimentoId: atnew.id, data:new Date()})

                return atnew;
            } catch (error) {
                console.error('------------- Erro ao criar novo atendimento ------------------', error);
            }
        }
    }

    async getAtendimentoFilasPorStatus(filas, cliente) {
        try {
            for (let fila of filas) {
                if (fila.status) {
                    log.info(`A fila ${fila.fila} de uraTextoID = ${fila.uraTextoID} tem status ${fila.status}`);
                    // Vamos ver se tem atendimento aberto com o status informado
                    const at = await ClienteAtendimento.query.require(false).first()
                        .where({ idCliente: cliente.id })
                        .where({ queue: fila.fila })
                        .where({ status: fila.status })
                        .fetch();
                    if (at) {
                        // Manda o ID da Ura no atendimento...Gambi!! Apague ele depois de usar!
                        at.uraID = fila.uraTextoID;
                        log.info(`Atendimento ${at.id} ativo com status = ${fila.status}`);
                        return at;
                    }
                }
            }
        } catch (error) {
            log.error(`[preAtendimento] ERRO - Falha ao obter o atendimento por status, erro: ${error}`);
            return undefined;
        }
    }
    async sendMsgQueued(data) {
        try {
            let socket = data.socket;
            let atendimento = data.atendimento;
            let dados = data.dados;
            console.log(`[sendMsgQueued] Atendimento ${atendimento.id} TIPO ${atendimento.queueTypeID} destino ${atendimento.fromID}`);
            console.log(`ENVIANDO Atendimento ${atendimento.id} TIPO ${atendimento.queueTypeID} destino ${atendimento.fromID}`);
            if (atendimento && atendimento.queueTypeID === 3) {
                console.log(`[TIPO 3] Atendimento ${atendimento.id} TIPO ${atendimento.queueTypeID} destino ${atendimento.fromID}`, socket);
                Omni.WhatsApp.socket.emit('newWhatsMsg', { instanceID: dados.route_data.instanceID, chatId: dados.idCliente, msg: dados.msg }, (retorno) => {
                    console.log(`URA_DEBUG: WhatsApi retornou ${retorno.msg || retorno.data}`);
                });
                // removi o async pq as msgs estavam ficando fora de ordem pro cliente.
                new AtendimentoMensagem({ idAtendimento: dados.route_data.atendimentoId, texto: dados.msg, inOut: 3, agente: 'Pré-Atendimento' }).save();
                return;
            }
            if (atendimento && atendimento.queueTypeID === 5) {
                var f = await Fila.query.require(true).first()
                    .where({ name: dados.route_data.instanceID })
                    .fetch();
                let confige = f.emailConfig;
                if (dados.opcoes && dados.tipo == 'botao') {
                    objMessage = {};
                    objMessage.type = 'button';
                    objMessage.header = { type: 'text', text: dados.header };
                    objMessage.body = dados.msg;
                    objMessage.footer = dados.footer;
                    objMessage.buttons = dados.opcoes.map(op => {
                        return { id: op.texto, title: op.texto }
                    });
                }
                if (dados.opcoes && dados.tipo == 'lista') {
                    objMessage = {};
                    objMessage.type = 'list';
                    objMessage.header = dados.header;
                    objMessage.body = dados.msg;
                    objMessage.footer = dados.footer;
                    objMessage.sections = [{title:dados.header,
                        rows: dados.opcoes.map(op => {
                        return { id: op.texto, title: op.texto }
                    })}]                  
                }
                Omni.Zenvia.socket.emit('newWhatsMsgZenvia', { zenviaID: confige.zenviaID, from: confige.from, to: dados.idCliente, text: dados.msg }, (retorno) => {
                });
                // removi o async pq as msgs estavam ficando fora de ordem pro cliente.
                new AtendimentoMensagem({ idAtendimento: dados.route_data.atendimentoId, texto: dados.msg, inOut: 3, agente: 'Pré-Atendimento' }).save();
                return;
            }
            if (atendimento && atendimento.queueTypeID === 6) {
                var f = await Fila.query.require(true).first()
                    .where({ name: dados.route_data.instanceID })
                    .fetch();
                let confige = f.emailConfig;
                Omni.Infobip.socket.emit('newWhatsMsgInfobip', { baseurl: confige.baseurl, authorization: confige.authorization, to: dados.idCliente, text: dados.msg }, (retorno) => {
                });
                // removi o async pq as msgs estavam ficando fora de ordem pro cliente.
                new AtendimentoMensagem({ idAtendimento: dados.route_data.atendimentoId, texto: dados.msg, inOut: 3, agente: 'Pré-Atendimento' }).save();
                return;
            }
            if (atendimento && atendimento.queueTypeID === 7) {
                console.log(`[TIPO 7] Atendimento ${atendimento.id} TIPO ${atendimento.queueTypeID} destino ${atendimento.fromID}`, socket);

                var f = await Fila.query.require(true).first()
                    .where({ name: dados.route_data.instanceID })
                    .fetch();
                let confige = f.emailConfig;
                let objMessage = null;
                if (dados.opcoes && dados.tipo == 'botao') {
                    objMessage = {};
                    objMessage.type = 'quick_reply';
                    objMessage.msgid = 'botaomenu';
                    objMessage.content = { type: 'text', header: dados.header, text: dados.msg, caption: dados.footer };
                    objMessage.options = dados.opcoes.map(op => {
                        return { type: 'text', title: op.texto }
                    });
                }
                if (dados.opcoes && dados.tipo == 'lista') {
                    objMessage = {};
                    objMessage.type = 'list';
                    objMessage.msgid = 'listamenu';
                    objMessage.title = dados.header;
                    objMessage.body = dados.msg;
                    objMessage.globalButtons = [{ type: "text", title: dados.footer }];
                    objMessage.items = [];
                    objMessage.items.push({
                        options: dados.opcoes.map(op => {
                            return { type: 'text', title: op.texto, postbackText: op.texto }
                        })
                    });
                }
                Omni.Gupshup.socket.emit('newWhatsMsgGupshup', { apikey: confige.apikey, source: confige.source, to: dados.idCliente, text: dados.msg, message: objMessage }, (retorno) => {
                });
                // removi o async pq as msgs estavam ficando fora de ordem pro cliente.
                new AtendimentoMensagem({ idAtendimento: dados.route_data.atendimentoId, texto: dados.msg, inOut: 3, agente: 'Pré-Atendimento' }).save();
                return;
            }
            if (socket && atendimento && atendimento.queueTypeID === 2) {
                let msgAux = await new AtendimentoMensagem({ idAtendimento: dados.route_data.atendimentoId, texto: dados.msg, inOut: 3, agente: 'Pré-Atendimento' }).save();
                Omni.WebChat.socket.emit('sendMsgChat', { queue: dados.route_data.instanceID, uid: atendimento.fromID, msg: msgAux, clientID: config.csa.id, protocolo: atendimento.id, });
                return;
            }
            if (socket && atendimento && atendimento.queueTypeID === 10) {
                var f = await Fila.query.require(true).first()
                .where({ name: dados.route_data.instanceID })
                .fetch();
                let configGup = f.emailConfig;
                let msgAux = await new AtendimentoMensagem({ idAtendimento: dados.route_data.atendimentoId, texto: dados.msg, inOut: 3, agente: 'Pré-Atendimento' }).save();
                Omni.Connectus.socket.emit('sendMsgConnectus', {
                    dst_number: atendimento.fromID,
                    src_number: configGup.dst_number,
                    id_client: configGup.id_client, 
                    sms_content: dados.msg
                  });
                return;
            }
        } catch (error) {
            console.error(error);
            // console.error(`[sendMsgQueuedError] Atendimento ${data.atendimento.id} TIPO ${data.atendimento.queueTypeID} destino ${data.atendimento.fromID}`, error)

        }


    }
    async sendMsg(socket, atendimento, dados) {
        let data = {};
        data.socket = socket;
        data.atendimento = atendimento;
        data.dados = dados;
        console.log(`[sendMsg] Atendimento ${atendimento.id} TIPO ${atendimento.queueTypeID} destino ${atendimento.fromID}`);
        this.sendMsgQueued(data);
    }
    async routerUraFile(urafileConf, socket, msg, cliente) {
        let atendimento = undefined;
        let uraDbID = undefined;

        // Se for Ura no banco pode ter vários status pra ver se tem atendimento ativo
        if (urafileConf.db) {
            atendimento = await this.getAtendimentoFilasPorStatus(urafileConf.db_filas, cliente);
            // Se não tem atendimento com o status especifico pega ou cria o atendimento normal
            if (!atendimento) {
                const fila_sem_status = urafileConf.db_filas.find(fila => !fila.status);
                // Se tem configuração pra fila sem status do atendimento
                if (fila_sem_status) {
                    atendimento = await this._getPreAtendimentoAtivo(cliente, msg, fila_sem_status.fila);
                    // Pega o ID da ura
                    uraDbID = fila_sem_status.uraTextoID;
                }
                // Caso não tenha ura pra fila sem nenhum status é por que não tem ura pra ela :)
                else {
                    console.log(`Não tem ura para essa fila sem um status`);
                    return true;
                }
            }
            else {
                // Pega o id da ura e tira a gambi
                uraDbID = atendimento.uraID;
                delete atendimento.uraID;
            }
        }
        else {
            atendimento = await this._getPreAtendimentoAtivo(cliente, msg, urafileConf.fila);
        }

        console.log(`URA_DEBUG: ** routerUraFile **, Atendimento: ${atendimento.id}, Fila: ${atendimento.queue}`);

        if (!this.urafile) {
            this.urafile = new UraProcessor();
            // Se for Ura no banco 
            if (uraDbID) {
                this.urafile.loadFromDb(uraDbID);
            }
            else {
                this.urafile.loadFile(urafileConf.arquivo);
                this.urafile.setTimeExpire(urafileConf.expirar);
                this.urafile.setTimeExpireMsg(urafileConf.sessao_expirada);
                this.urafile.setFilaTransbordo(urafileConf.filaTransbordo);
                // this.urafile.startContador(msg.idCliente, { instanceID: msg.instanceID, atendimentoId: atendimento.id });
            }

            // Envia uma mensagem para o usuário
            this.urafile.on('UraMsg', async dados => {
                try {
                    log.info(`URA_DEBUG: ENVIANDO: Msg: ${dados.msg}, Destino: ${dados.idCliente}, Fila: ${dados.route_data.instanceID}, Atendimento: ${dados.route_data.atendimentoId}`);
                    let atendimento = await ClienteAtendimento.fetchById(dados.route_data.atendimentoId);
                    log.info(`[UraMsg] Atendimento ${atendimento.id} TIPO ${atendimento.queueTypeID} destino ${atendimento.fromID}`);
                    this.sendMsg(socket, atendimento, dados);
                } catch (error) {
                    log.error(`[UraMsgError] Atendimento ${atendimento.id} TIPO ${atendimento.queueTypeID} destino ${atendimento.fromID}`, error)
                }
                //console.log(atendimento);



            });

            // Envia o usuário para uma fila
            this.urafile.on('UraGotoFila', async dados => {
                log.info('URA_DEBUG: UraGotoFila');
                if (dados.msg) {
                    //console.log(`GOTO =================`)
                    // this.sendMsg(socket, atendimento, dados)
                    // await new AtendimentoMensagem({ idAtendimento: dados.route_data.atendimentoId, texto: dados.msg, inOut: 3, agente: 'Pré-Atendimento' }).save();
                }

                const preatendimento = await FilaPreAtendimento.query.require(false).first().where({ queueName: dados.fila }).fetch();
                const temurafile = this.checkUraFile(dados.fila);

                log.info(`URA_DEBUG: UraGotoFila, preatendimento = ${preatendimento}, urafila = ${temurafile}`);

                try {
                    const at = new ClienteAtendimento();
                    at.id = dados.route_data.atendimentoId;
                    at.queue = dados.fila;
                    at.queueFrom = dados.route_data.instanceID;
                    at.status = (preatendimento || temurafile) ? 'PreAtendimento' : 'Entrou';
                    at.action = 'WhatsRedirByURAFile';
                    at.ativo = preatendimento ? false : true;// Quando tem pré atendimento na fila destino, ativo deve estar false
                    at.ultimoAgente = null;
                    await at.save();

                    if (temurafile) {
                        //let msgAux = await new AtendimentoMensagem({ idAtendimento: at.id, texto: `pré-atendimento redirecionou para fila ${dados.fila}`, inOut: 1, agente: null }).save();
                        let cliente = await Cliente.fetchById(at.idCliente);
                        let msgAux = {
                            texto: `pré-atendimento redirecionou para fila ${dados.fila}`,
                            inOut: 1,
                            idCliente: at.fromID,
                            dataHora: new Date(),
                            mailMessageID: null,
                            from: cliente.numero,
                            queueTypeID: at.queueTypeID,
                            instanceID: at.queueFrom
                        }
                        this.routerUraFile(temurafile, socket, msgAux, cliente);
                        return true;
                    }
                } catch (ex) {
                    log.error(ex);
                }


                if (preatendimento) {
                    const cliente = await Cliente.getClientFromMsg(dados);
                    const trocas = { "$NOME_CLIENTE": cliente.nome !== null ? cliente.nome : msg.nomeCliente };
                    const msgInicial = await this.getTrocaVarTexto(preatendimento.msgInicial, trocas);
                    dados.msg = msgInicial;
                    this.sendMsg(socket, atendimento, dados);
                    //socket.emit('newWhatsMsg', { instanceID: dados.route_data.instanceID, chatId: dados.idCliente, msg: msgInicial }, () => { });
                    return;
                } else {
                    log.info(`URA_DEBUG: VAMOS DAR A MENSAGEM INICIAL ${atendimento.queue}`);
                    let trocas = { "$NOME_CLIENTE": cliente.nome !== null ? cliente.nome : msg.nomeCliente, "$PROTOCOLO": dados.route_data.atendimentoId }
                    var Query = await db.query('SELECT texto FROM public."queueRespostasAutomaticas" where fila = $1 AND "idRespostaTipo" = $2', [dados.fila, 4]);
                    if (Query.rowCount > 0) {
                        var texto = Query.rows[0].texto;
                        if (trocas) {
                            if (typeof trocas === 'object') {
                                Object.entries(trocas).forEach(([key, value]) => {
                                    texto = texto.split(key).join(value);
                                });
                            }
                        }
                        dados.msg = texto;
                        this.sendMsg(socket, atendimento, dados)

                    }
                }

                try {
                    let fila = Ami.getFila(dados.fila);
                    if (!fila.ligacoes) fila.ligacoes = [];

                    fila.recebidas++;
                    const atfim = await ClienteAtendimento.fetchById(dados.route_data.atendimentoId);
                    fila.ligacoes.push(atfim);
                    autoEncerramento.addTransbordo(atfim);                    
                    ws.wsEvento.emit(`transferToQueueUra`, atfim);
                } catch (ex) {
                    log.error(ex);
                }
            });

            // Envia o usuário para um agente
            this.urafile.on('UraGotoAgente', async dados => {
                // console.log('URA_DEBUG: UraGotoAgente');

                // if (dados.msg) {
                //     console.log(`URA_DEBUG: ENVIANDO: Msg: ${dados.msg}, Destino: ${dados.idCliente}, Fila: ${dados.route_data.instanceID}, Atendimento: ${dados.route_data.atendimentoId}`);

                //     socket.emit('newWhatsMsg', { instanceID: dados.route_data.instanceID, chatId: dados.idCliente, msg: dados.msg }, (retorno) => {
                //         console.log(`URA_DEBUG: WhatsApi retornou ${retorno.msg || retorno.data}`);
                //     });

                //     await new AtendimentoMensagem({
                //         idAtendimento: dados.route_data.atendimentoId,
                //         texto: dados.msg,
                //         inOut: 3,
                //         agente: 'Pré-Atendimento'
                //     }).save();
                // }

                try {
                    const at = new ClienteAtendimento();
                    at.id = dados.route_data.atendimentoId;
                    at.queue = dados.fila;
                    at.queueFrom = dados.route_data.instanceID;
                    at.status = 'Entrou';
                    at.action = 'WhatsRedirByURAFile';
                    at.ativo = true;
                    at.ultimoAgente = dados.agente.nome;
                    await at.save();
                    ws.Omni.OmniEventos.emit('addAtendimento', at);

                } catch (ex) {
                    log.error(ex);
                }
            });

            // Encerra o atendimento
            this.urafile.on('UraFim', async dados => {
                // ### Atigamente quando finalizava registrava o atendimento aberto na fila, agora registra como encerrado.
                try {
                    const at = new ClienteAtendimento();
                    at.id = dados.route_data.atendimentoId;
                    at.status = 'Encerrado';
                    at.dataFim = new Date(moment.tz(config.servidor.timezone));
                    at.action = 'WhatsRedirByURAFile';
                    at.ativo = false;
                    at.ultimoAgente = null;
                    await at.save();
                } catch (ex) {
                    log.error(ex);
                }
            });

            // Mostra um log de erro
            this.urafile.on('UraErro', dados => {
                //console.error('Erro URAFile');
                //console.error(dados);
                log.error('URA_ERROR: ' + dados.msg);
            });

            // Mostra um log de debug
            this.urafile.on('UraDebug', dados => {
                let msg = dados.msg;
                if (typeof dados.msg === 'object') msg = JSON.stringify(dados.msg);
                if (dados.debug) msg = `[${dados.debug.toString()}] ${msg}`;
                log.info('URA_DEBUG: ' + msg);
            });
            let m = await new AtendimentoMensagem({ idAtendimento: atendimento.id, texto: msg.texto, inOut: 1, agente: 'Pré-Atendimento' }).save();
            if (msg.queueAnexos && msg.queueAnexos.length > 0) {
                for (let file of msg.queueAnexos) {
                    new MensagemAnexos({ idMensagem: m.id, caminho: file.caminho, mimeType: file.mimeType }).save();
                }

            }
            this.urafile.routeMsg(msg.idCliente, msg.texto, { instanceID: msg.instanceID, atendimentoId: atendimento.id, cliente: cliente }, msg.mimeType ? msg.mimeType : "text");
        }
        else {
            console.log(`URA_DEBUG: MENSAGEM`, msg);

            let m = await new AtendimentoMensagem({ idAtendimento: atendimento.id, texto: msg.texto, inOut: 1, agente: 'Pré-Atendimento' }).save();
            if (msg.queueAnexos && msg.queueAnexos.length > 0) {
                for (let file of msg.queueAnexos) {
                    new MensagemAnexos({ idMensagem: m.id, caminho: file.caminho, mimeType: file.mimeType }).save();
                }

            }
            // Se for Ura no banco 
            if (uraDbID) {
                this.urafile.loadFromDb(uraDbID);
            }
            else {
                this.urafile.loadFile(urafileConf.arquivo);
                this.urafile.setTimeExpire(urafileConf.expirar);
                this.urafile.setTimeExpireMsg(urafileConf.sessao_expirada);
                this.urafile.setFilaTransbordo(urafileConf.filaTransbordo);
            }

            // Roteia
            this.urafile.routeMsg(msg.idCliente, msg.texto, { instanceID: msg.instanceID, atendimentoId: atendimento.id, cliente: cliente }, msg.mimeType ? msg.mimeType : "text");
        }
    }

    async getPreAtendimentoFila(fila) {
        try {
            const ret = await FilaPreAtendimento.query
                .leftJoin(FilaPreAtendimentoOpcoes)
                .require(true)
                .where({ queueName: fila })
                .fetch();
            return ret[0];
        } catch (error) {
            return null;
        }
    }

    async routerUra(socket, msg) {
        try {
            let cliente = await Cliente.getClienteByMsg(msg);
            var trocas, msgInicial;

            // Verifica se já não passou pela URA
            const jaura = await ClienteAtendimento.query
                .require(false)
                .first()
                .where({ idCliente: cliente.id })
                .where({ queueFrom: msg.instanceID })
                .where(ClienteAtendimento.where.or(
                    ClienteAtendimento.where.equal({ status: 'Entrou' }),
                    ClienteAtendimento.where.equal({ status: 'Pesquisa' })
                ))
                .fetch();


            if (jaura) {
                log.info(`URA_DEBUG: ** jaUra **, Atendimento: ${jaura.id}, Fila: ${msg.instanceID}`);

                return false;
            }

            // Verifica se veio de outra URA
            const outraUra = await ClienteAtendimento.query
                .where({ idCliente: cliente.id })
                .where({ queueFrom: msg.instanceID })
                .where({ status: 'PreAtendimento' })
                .require(false)
                .first()
                .fetch();

            const BuscaUraFila = outraUra ? outraUra.queue : msg.instanceID;

            const urafile = this.checkUraFile(BuscaUraFila);
            if (urafile) {
                log.info(`URA_DEBUG: * routerUraFile *, Atendimento:${outraUra ? outraUra.id : 'SEM'}  Fila: ${msg.instanceID}, BuscaFila: ${BuscaUraFila}, Cliente: ${cliente.id} urafile: ${urafile}`);

                this.routerUraFile(urafile, socket, msg, cliente);
                return true;
            }

            const uradb = await this.checkUraDb(BuscaUraFila);
            if (uradb) {
                log.info(`URA_DEBUG: * routerUraFileDB *, Atendimento:${outraUra ? outraUra.id : 'SEM'} Fila: ${msg.instanceID}, BuscaFila: ${BuscaUraFila}, Cliente: ${cliente.id} urafile: ${urafile}`);

                log.info(`Temos URA em banco de dados para fila ${BuscaUraFila}`);
                const confDb = {
                    db_filas: uradb,
                    db: true
                };

                this.routerUraFile(confDb, socket, msg, cliente);
                return true;
            }


            let filaAux = await Ami.getFila(BuscaUraFila);
            // Cria uma fila temp
            let filaTemp = new FilaTemp(filaAux);

            // Verifica se tem URA para a fila
            const ura = await this.getPreAtendimentoFila(BuscaUraFila);
            if (ura) {
                trocas = { "$NOME_CLIENTE": cliente.nome !== null ? cliente.nome : msg.nomeCliente };
                msgInicial = await this.getTrocaVarTexto(ura.msgInicial, trocas);
                // Vamos ver se oq o cliente digitou esta nas opções
                const opcoes = ura.filaPreAtendimentoOpcoes;
                let opcao = opcoes.find(data => data.opcao === msg.texto);
                if (opcao) {
                    // Opcao Texto que printa e finaliza
                    if (opcao.app === 'TextoFinal') {
                        if (socket) {
                            trocas = { "$NOME_CLIENTE": cliente.nome !== null ? cliente.nome : msg.nomeCliente };
                            var msgFinal = await this.getTrocaVarTexto(opcao.pars, trocas);

                            if (msg.queueTypeID === 3) {
                                socket.emit('newWhatsMsg', { instanceID: msg.instanceID, chatId: cliente.numero, msg: msgFinal }, (retorno) => {
                                });
                            }

                            if (msg.queueTypeID === 5) {
                                var f = await Fila.query.require(true).first()
                                    .where({ name: msg.instanceID })
                                    .fetch();
                                let confige = f.emailConfig;
                                socket.emit('newWhatsMsgZenvia', { zenviaID: confige.zenviaID, from: confige.from, to: msg.from, text: msgFinal }, (retorno) => {
                                });

                            }

                            if (msg.queueTypeID === 6) {
                                var f = await Fila.query.require(true).first()
                                    .where({ name: msg.instanceID })
                                    .fetch();
                                let confige = f.emailConfig;
                                socket.emit('newWhatsMsgInfobip', { baseurl: confige.baseurl, authorization: confige.authorization, to: msg.from, text: msgFinal }, (retorno) => {
                                });

                            }
                            if (msg.queueTypeID === 7) {
                                var f = await Fila.query.require(true).first()
                                    .where({ name: msg.instanceID })
                                    .fetch();
                                let confige = f.emailConfig;
                                socket.emit('newWhatsMsgGupshup', { apikey: confige.apikey, source: confige.source, to: msg.from, text: msgFinal }, (retorno) => {
                                });

                            }


                        }
                        // Se ja está em pré-Atendimento finaliza o atendimento.
                        try {
                            const at = await ClienteAtendimento.query
                                .require(true)
                                .where({ idCliente: cliente.id })
                                .where({ queue: BuscaUraFila })
                                .where({ status: 'PreAtendimento' })
                                .update({ status: 'Encerrado', dataFim: new Date(moment.tz(config.servidor.timezone)), action: 'WhatsClosedByURA', ultimoAgente: null });
                            //Vamos salvar a mensagem final e mandar para webchat caso seja webchat
                            const msgAux1 = await new AtendimentoMensagem({ idAtendimento: at.id, texto: msgFinal, inOut: 3, agente: 'Pré-Atendimento', dataFim: new Date(moment.tz(config.servidor.timezone)) }).save();
                            if (socket && msg.queueTypeID === 2) {
                                return socket.emit('sendMsgChat', { queue: msg.instanceID, uid: at[0].fromID, msg: msgAux1, clientID: config.csa.id, protocolo: at[0].id, event: 'EncerrarAtendimento' });
                            }
                            // Salva msg enviada pelo cliente
                            const m1u = await new AtendimentoMensagem({ idAtendimento: at[0].id, texto: `Cliente digitou: ${msg.texto} e o pré-atendimento finalizou o atendimento com a mensagem ${opcao.pars}`, inOut: 1, agente: null }).save();
                            return true;
                        } catch (error) {
                            // Se não, cria um atendimento encerrado para registro.
                            const at = await new ClienteAtendimento({ fromID: msg.from, dataFim: new Date(moment.tz(config.servidor.timezone)), sentido: 'Entrante', fromName: cliente.nome, queue: BuscaUraFila, queueFrom: msg.instanceID, idCliente: cliente.id, ativo: false, status: 'Encerrado', queueTypeID: msg.queueTypeID, action: 'WhatsClosedByURA', dadosAdicionais: { "nome": msg.name, "remetente": msg.from } }).save();
                            //Vamos salvar a mensagem final e mandar para webchat caso seja webchat
                            const msgAux1 = await new AtendimentoMensagem({ idAtendimento: at.id, texto: msgFinal, inOut: 3, agente: 'Pré-Atendimento' }).save();
                            if (socket && msg.queueTypeID === 2) {
                                return socket.emit('sendMsgChat', { queue: msg.instanceID, uid: at.fromID, msg: msgAux1, clientID: config.csa.id, protocolo: at.id });
                            }
                            // Salva msg enviada pelo cliente
                            at.count++;
                            at.save();
                            const m2u = await new AtendimentoMensagem({ idAtendimento: at.id, texto: `Cliente digitou: ${msg.texto} e o pré-atendimento finalizou o atendimento com a mensagem ${opcao.pars}`, inOut: 1, agente: null }).save();
                            return true;
                        }
                    }
                    // Opcao Fila
                    if (opcao.app === 'Fila') {
                        // Busca se a nova fila tb tem URA
                        const NewUra = await this.getPreAtendimentoFila(opcao.pars);

                        const temurafile = this.checkUraFile(opcao.pars);
                        const NewStatus = (NewUra || temurafile) ? 'PreAtendimento' : 'Entrou';

                        // Se ja está em pré-Atendimento atualiza para a fila nova
                        try {
                            const at = await ClienteAtendimento.query
                                .require(true)
                                .where({ idCliente: cliente.id })
                                .where({ queue: BuscaUraFila })
                                .where({ status: 'PreAtendimento' })
                                .update({ status: NewStatus, action: 'WhatsRedirByURA', queue: opcao.pars, queueFrom: msg.instanceID, ultimoAgente: null });

                            // Adicionar o atendimento da listagem
                            filaTemp.adicionarAtendimentoNaListagem(at);

                            // Salva msg enviada pelo cliente
                            at[0].count++;
                            at[0].save();
                            const m1u = await new AtendimentoMensagem({ idAtendimento: at[0].id, texto: `Digitou: ${msg.texto}, pré-atendimento redirecionou para fila ${opcao.pars}`, inOut: 1, agente: null }).save();

                            if (temurafile) {
                                this.routerUraFile(temurafile, socket, msg, cliente);
                                return true;
                            }

                            if (NewUra) {

                                if (socket) {
                                    trocas = { "$NOME_CLIENTE": cliente.nome !== null ? cliente.nome : msg.nomeCliente };
                                    msgInicial = await this.getTrocaVarTexto(NewUra.msgInicial, trocas);
                                    let msgInicialNewUra = await new AtendimentoMensagem({ idAtendimento: at[0].id, texto: msgInicial, inOut: 1, agente: null }).save();

                                    if (msg.queueTypeID === 3) {
                                        socket.emit('newWhatsMsg', { instanceID: msg.instanceID, chatId: cliente.numero, msg: msgInicial }, (retorno) => {
                                        });
                                    }

                                    if (msg.queueTypeID === 5) {
                                        var f = await Fila.query.require(true).first()
                                            .where({ name: msg.instanceID })
                                            .fetch();
                                        let confige = f.emailConfig;
                                        socket.emit('newWhatsMsgZenvia', { zenviaID: confige.zenviaID, from: confige.from, to: msg.from, text: msgInicial }, (retorno) => {
                                        });

                                    }

                                    if (msg.queueTypeID === 6) {
                                        var f = await Fila.query.require(true).first()
                                            .where({ name: msg.instanceID })
                                            .fetch();
                                        let confige = f.emailConfig;
                                        socket.emit('newWhatsMsgInfobip', { baseurl: confige.baseurl, authorization: confige.authorization, to: msg.from, text: msgInicial }, (retorno) => {
                                        });

                                    }
                                    if (msg.queueTypeID === 7) {
                                        var f = await Fila.query.require(true).first()
                                            .where({ name: msg.instanceID })
                                            .fetch();
                                        let confige = f.emailConfig;
                                        socket.emit('newWhatsMsgGupshup', { apikey: confige.apikey, source: confige.source, to: msg.from, text: msgInicial }, (retorno) => {
                                        });

                                    }
                                    if (msg.queueTypeID === 2) {
                                        socket.emit('sendMsgChat', { queue: msg.instanceID, uid: at[0].fromID, msg: msgInicialNewUra, clientID: config.csa.id, protocolo: at[0].id });

                                    }
                                }
                                return true;
                            }
                            else {
                                return false;
                            }
                        } catch (error) {
                            // Se não, registra pra nova fila. Casos em que o cliente já conhece a URA e já digita a opção direto.
                            const at = await new ClienteAtendimento({ fromID: msg.from, fromName: cliente.nome, queue: opcao.pars, queueFrom: msg.instanceID, idCliente: cliente.id, ativo: false, status: NewStatus, queueTypeID: msg.queueTypeID, action: 'WhatsRedirByURA', dadosAdicionais: { "nome": msg.name, "remetente": msg.from } }).save();

                            // Adicionar o atendimento da listagem
                            filaTemp.adicionarAtendimentoNaListagem(at);

                            // Salva msg enviada pelo cliente
                            at.count++;
                            at.save();
                            const m2u = await new AtendimentoMensagem({ idAtendimento: at.id, texto: `Digitou: ${msg.texto}, pré-atendimento redirecionou para fila ${opcao.pars}`, inOut: 1, agente: null }).save();
                            if (NewUra) {
                                if (socket) {
                                    trocas = { "$NOME_CLIENTE": cliente.nome !== null ? cliente.nome : msg.nomeCliente };
                                    msgInicial = await this.getTrocaVarTexto(NewUra.msgInicial, trocas);
                                    if (msg.queueTypeID === 3) {
                                        socket.emit('newWhatsMsg', { instanceID: msg.instanceID, chatId: cliente.numero, msg: msgInicial }, (retorno) => {
                                        });
                                    }


                                    if (msg.queueTypeID === 5) {
                                        var f = await Fila.query.require(true).first()
                                            .where({ name: msg.instanceID })
                                            .fetch();
                                        let confige = f.emailConfig;
                                        socket.emit('newWhatsMsgZenvia', { zenviaID: confige.zenviaID, from: confige.from, to: msg.from, text: msgInicial }, (retorno) => {
                                        });

                                    }
                                    if (msg.queueTypeID === 6) {
                                        var f = await Fila.query.require(true).first()
                                            .where({ name: msg.instanceID })
                                            .fetch();
                                        let confige = f.emailConfig;
                                        socket.emit('newWhatsMsgInfobip', { baseurl: confige.baseurl, authorization: confige.authorization, to: msg.from, text: msgInicial }, (retorno) => {
                                        });

                                    }
                                    if (msg.queueTypeID === 7) {
                                        var f = await Fila.query.require(true).first()
                                            .where({ name: msg.instanceID })
                                            .fetch();
                                        let confige = f.emailConfig;
                                        socket.emit('newWhatsMsgGupshup', { apikey: confige.apikey, source: confige.source, to: msg.from, text: msgInicial }, (retorno) => {
                                        });

                                    }
                                    if (msg.queueTypeID === 2) {
                                        socket.emit('sendMsgChat', { queue: msg.instanceID, uid: at.fromID, msg: m2u, clientID: config.csa.id, protocolo: at.id });

                                    }
                                }
                                return true;
                            }
                            else {
                                return false;
                            }
                        }
                    }
                }
                if (msg.queueTypeID === 2) {
                    // Não está em atendimento pela URA, registra...
                    const atendimento = await ClienteAtendimento.query
                        .require(false)
                        .first()
                        .where({ idCliente: cliente.id })
                        .where(ClienteAtendimento.where.or(
                            ClienteAtendimento.where.equal({ queue: msg.instanceID }),
                            ClienteAtendimento.where.equal({ queueFrom: msg.instanceID })
                        ))
                        .where({ status: 'PreAtendimento' })
                        .fetch();

                    // Salva msg enviada pelo cliente
                    atendimento.count++;
                    atendimento.save();
                    const m1 = await new AtendimentoMensagem({ idAtendimento: atendimento.id, texto: msg.texto, inOut: 1, agente: 'Pré-Atendimento' }).save();

                    // Salva msg enviada para o cliente
                    const m2 = await new AtendimentoMensagem({ idAtendimento: atendimento.id, texto: msgInicial, inOut: 3, agente: 'Pré-Atendimento' }).save();

                    if (socket) {
                        // Enviando Whats com opções da URA
                        var trocas = { $PROTOCOLO: atendimento.id };
                        if (typeof trocas === 'object') {
                            Object.entries(trocas).forEach(([key, value]) => {
                                msgInicial = msgInicial.split(key).join(value);
                            });
                        }
                        socket.emit('sendMsgChat', { queue: msg.instanceID, uid: atendimento.fromID, msg: m2, clientID: config.csa.id, protocolo: atendimento.id });
                        return true;
                    }
                }

                // Verifica se já está no menu
                var pre = await ClienteAtendimento.query.require(false).first()
                    .where({ idCliente: cliente.id })
                    .where({ queue: BuscaUraFila })
                    //.where(ClienteAtendimento.where.or(
                    //    ClienteAtendimento.where.equal({ queue: msg.instanceID }),
                    //    ClienteAtendimento.where.equal({ queueFrom: msg.instanceID })
                    //))
                    .where({ status: 'PreAtendimento' })
                    .fetch();
                if (pre) {
                    // Salva msg enviada pelo cliente
                    pre.count++;
                    pre.save();
                    const m1p = await new AtendimentoMensagem({ idAtendimento: pre.id, texto: msg.texto, inOut: 1, agente: 'Pré-Atendimento' }).save();

                    // Enviando Whats de opção errada
                    if (ura.msgOpcaoErrada) {
                        // Salva msg enviada para o cliente
                        const m2p = await new AtendimentoMensagem({ idAtendimento: pre.id, texto: ura.msgOpcaoErrada, inOut: 3, agente: 'Pré-Atendimento' }).save();

                        if (socket) {
                            if (msg.queueTypeID === 3) {
                                socket.emit('newWhatsMsg', { instanceID: msg.instanceID, chatId: cliente.numero, msg: ura.msgOpcaoErrada }, (retorno) => {
                                });
                            }

                            if (msg.queueTypeID === 5) {
                                var f = await Fila.query.require(true).first()
                                    .where({ name: msg.instanceID })
                                    .fetch();
                                let confige = f.emailConfig;
                                socket.emit('newWhatsMsgZenvia', { zenviaID: confige.zenviaID, from: confige.from, to: msg.from, text: ura.msgOpcaoErrada }, (retorno) => {
                                });

                            }
                            if (msg.queueTypeID === 6) {
                                var f = await Fila.query.require(true).first()
                                    .where({ name: msg.instanceID })
                                    .fetch();
                                let confige = f.emailConfig;
                                socket.emit('newWhatsMsgInfobip', { baseurl: confige.baseurl, authorization: confige.authorization, to: msg.from, text: ura.msgOpcaoErrada }, (retorno) => {
                                });

                            }
                            if (msg.queueTypeID === 7) {
                                var f = await Fila.query.require(true).first()
                                    .where({ name: msg.instanceID })
                                    .fetch();
                                let confige = f.emailConfig;
                                socket.emit('newWhatsMsgGupshup', { apikey: confige.apikey, source: confige.source, to: msg.from, text: ura.msgOpcaoErrada }, (retorno) => {
                                });

                            }
                            if (msg.queueTypeID === 2) {
                                socket.emit('sendMsgChat', { queue: msg.instanceID, uid: pre.fromID, msg: ura.msgOpcaoErrada, clientID: config.csa.id, protocolo: pre.id });

                            }
                        }
                    }
                    // Se o Pré-atendimento estiver configurado para repetir o menu inicial.
                    if (ura.repetirMsgInicial) {
                        // Salva msg enviada para o cliente

                        const m3p = await new AtendimentoMensagem({ idAtendimento: pre.id, texto: msgInicial, inOut: 3, agente: 'Pré-Atendimento' }).save();

                        if (socket) {
                            // Enviando Whats
                            var trocas = { $PROTOCOLO: pre.id };
                            if (typeof trocas === 'object') {
                                Object.entries(trocas).forEach(([key, value]) => {
                                    msgInicial = msgInicial.split(key).join(value);
                                });
                            }

                            if (msg.queueTypeID === 3) {
                                socket.emit('newWhatsMsg', { instanceID: msg.instanceID, chatId: cliente.numero, msg: msgInicial }, (retorno) => {
                                });
                            }
                            if (msg.queueTypeID === 2) {
                                socket.emit('sendMsgChat', { queue: msg.instanceID, uid: pre.fromID, msg: m3p, clientID: config.csa.id, protocolo: pre.id, });

                            }

                            if (msg.queueTypeID === 5) {
                                var f = await Fila.query.require(true).first()
                                    .where({ name: msg.instanceID })
                                    .fetch();
                                let confige = f.emailConfig;
                                socket.emit('newWhatsMsgZenvia', { zenviaID: confige.zenviaID, from: confige.from, to: msg.from, text: msgInicial }, (retorno) => {
                                });

                            }
                            if (msg.queueTypeID === 6) {
                                var f = await Fila.query.require(true).first()
                                    .where({ name: msg.instanceID })
                                    .fetch();
                                let confige = f.emailConfig;
                                socket.emit('newWhatsMsgInfobip', { baseurl: confige.baseurl, authorization: confige.authorization, to: msg.from, text: msgInicial }, (retorno) => {
                                });

                            }
                            if (msg.queueTypeID === 7) {
                                var f = await Fila.query.require(true).first()
                                    .where({ name: msg.instanceID })
                                    .fetch();
                                let confige = f.emailConfig;
                                socket.emit('newWhatsMsgGupshup', { apikey: confige.apikey, source: confige.source, to: msg.from, text: msgInicial }, (retorno) => {
                                });

                            }
                        }
                    }
                    return true;
                } else {
                    // Não está em atendimento pela URA, registra...
                    const atendimento = await new ClienteAtendimento({ fromID: msg.from, fromName: cliente.nome, queue: BuscaUraFila, idCliente: cliente.id, ativo: false, sentido: 'Entrante', status: 'PreAtendimento', queueTypeID: msg.queueTypeID, action: 'WhatsAppIn', dadosAdicionais: { "nome": msg.name, "remetente": msg.from } }).save();
                    Omni.OmniEventos.emit('filaNovoAtendimento', {fila:atendimento.queue, numero: cliente.numero, nome: cliente.nome,  atendimentoId: atendimento.id, data:new Date()})
                    // Salva msg enviada pelo cliente
                    atendimento.count++;
                    atendimento.save();
                    const m1 = await new AtendimentoMensagem({ idAtendimento: atendimento.id, texto: msg.texto, inOut: 1, agente: 'Pré-Atendimento' }).save();

                    // Salva msg enviada para o cliente
                    const m2 = await new AtendimentoMensagem({ idAtendimento: atendimento.id, texto: msgInicial, inOut: 3, agente: 'Pré-Atendimento' }).save();
                    //vamos colocar o atendimento no array de ligacoes_atendidas
                    let fila = await Ami.getFila(BuscaUraFila);
                    if (fila) {
                        if (!fila.atendimentos) fila.atendimentos = [];
                        fila.atendimentos.push(atendimento);
                        ws.wsEvento.emit(`transferToQueueUra`);
                    }
                    if (socket) {
                        // Enviando Whats com opções da URA
                        var trocas = { $PROTOCOLO: atendimento.id };
                        if (typeof trocas === 'object') {
                            Object.entries(trocas).forEach(([key, value]) => {
                                msgInicial = msgInicial.split(key).join(value);
                            });
                        }
                        if (msg.queueTypeID === 3) {
                            socket.emit('newWhatsMsg', { instanceID: msg.instanceID, chatId: cliente.numero, msg: msgInicial }, (retorno) => {
                            });
                        }
                        if (msg.queueTypeID === 2) {
                            socket.emit('sendMsgChat', { queue: msg.instanceID, uid: atendimento.fromID, msg: msgInicial, clientID: config.csa.id, protocolo: atendimento.id, });
                        }
                        if (msg.queueTypeID === 5) {
                            var f = await Fila.query.require(true).first()
                                .where({ name: msg.instanceID })
                                .fetch();
                            let confige = f.emailConfig;
                            socket.emit('newWhatsMsgZenvia', { zenviaID: confige.zenviaID, from: confige.from, to: msg.from, text: msgInicial }, (retorno) => {
                            });

                        }
                        if (msg.queueTypeID === 6) {
                            var f = await Fila.query.require(true).first()
                                .where({ name: msg.instanceID })
                                .fetch();
                            let confige = f.emailConfig;
                            socket.emit('newWhatsMsgInfobip', { baseurl: confige.baseurl, authorization: confige.authorization, to: msg.from, text: msgInicial }, (retorno) => {
                            });

                        }
                        if (msg.queueTypeID === 7) {
                            var f = await Fila.query.require(true).first()
                                .where({ name: msg.instanceID })
                                .fetch();
                            let confige = f.emailConfig;
                            socket.emit('newWhatsMsgGupshup', { apikey: confige.apikey, source: confige.source, to: msg.from, text: msgInicial }, (retorno) => {
                            });

                        }
                    }
                    return true;
                }
            }
            else {
                return false;
            }

        } catch (error) {
            log.error(error);
        }
    }

}