var AssistantV2 = require('ibm-watson/assistant/v2');
var { IamAuthenticator } = require('ibm-watson/auth');
var request = require('request');
var sessions;
var assistant = {};

module.exports = class Watson {
    constructor(config) {
        assistant = new AssistantV2({
            authenticator: new IamAuthenticator({ apikey: config.apikey }),
            url: config.url,
            version: '2018-09-19'
        });
    }
    async criarSessao(protocolo, config) {
        await assistant.createSession(
            {
                assistantId: config.assistantId,
            },
            function (error, response) {
                if (error) {
                } else {
                    if (!sessions) sessions = [];
                    sessions.push({ session_id: response.result.session_id, protocolo: protocolo });
                }
            }
        );
    }
    async getSessionIdFromProtocolo(protocolo) {
        if (!sessions) sessions = [];
        var s = await sessions.filter((dados) => {
            if (dados.protocolo === protocolo) {
                return dados.session_id;
            }
        });
        if (s.length > 0) {
            return s[0];
        } else {
            return undefined;
        }
    }
    async enviarMensagem(msg, session, config) {
        return await assistant.message(
            {
                input: { text: msg },
                assistantId: config.assistantId,
                sessionId: session,
            })
            .then(response => {
                let aux = response.result.output.generic.length > 0 ? response.result.output.generic[0].text : undefined
                return { error: false, response: aux, data: response };
            })
            .catch(err => {
                return { code: err.code, error: true };
            });
    }

    async deleteSession(protocolo) {
        let aux;
        for (let i = 0; i < sessions.length; i++) {
            let s = sessions[i];
            if (s.protocolo === protocolo) {
                aux = s;
            }
        }
        if (aux) {
            sessions.splice(aux, 1);
            return true;
        }
    }

}
