/**
 * Definições de cache para balanceamento de distribuição de atendimentos.
 * A lógica para balancear a distribuição de atendimentos será baseada em um cache pelo timestamp da última distribuição que será resetada todo dia as 23:59
 * O cache será por fila sendo assim a distribuíção em uma fila não afeta o outra.
 */
const cron = require('node-cron')

module.exports = class CacheDiario {
    constructor() {
        this.cache = new Map()
        console.log(`- Cache criado com reset às 23:59:59`)
        cron.schedule('59 59 23 * * *', () => {
            console.log('Rodando RESET de cache diário')
            this.cache.clear()
        })
    }
    get(key) {
        return this.cache.get(key)
    }
    set(key, value) {
        return this.cache.set(key, value)
    }
    has(key) {
        return this.cache.has(key)
    }
    reset() {
        this.cache.clear()
    }
    size() {
        return this.cache.size
    }    
}