const {OmniEventos} = require('../xc_modules/omni/index')
const CanaisDeTexto = require('../models/CanaisDeTexto')
const MensagensCanaisDeTexto = require('../models/MensagensCanaisDeTexto')
const UsuariosCanaisDeTexto = require('../models/UsuariosCanaisDeTexto')



exports.enviarMensagemCanal = async (texto, idCanal, agente) => {
        try {
            const canalDeTexto = await CanaisDeTexto.fetchById(idCanal)
            const mensagemCanalDeTexto = await MensagensCanaisDeTexto.save({idCanal:idCanal, dataHora:new Date(), texto:texto, usuario: agente})
            OmniEventos.emit('newMessageCanalDeTexto',{message:mensagemCanalDeTexto, canal:canalDeTexto})
            return mensagemCanalDeTexto
        } catch (error) {
            console.error('[Canais-Texto-Error] Erro ao enviar mensagem: ', error)
        }    
    }
    exports.getMensagensCanal = async (idCanal, pagina, porPagina) => { 
        try {        
            console.log('ENTROU AQUI', idCanal)   
            const mensagens = await MensagensCanaisDeTexto.query
                .where({idCanal: idCanal})
                .fetch({ page: pagina, perPage: porPagina})
            return mensagens
        } catch (error) {
            console.error('[Canais-Texto-Error] Erro get Mensagens Canal De Texto: ', error)
        }
    }
    exports.getCanais = async () => {
        try {
            const canaisDeTexto = await CanaisDeTexto.query           
            .fetch()
            return canaisDeTexto
        } catch (error) {
            console.error('[Canais-Texto-Error] Erro get canais publicos: ', error)
        }
    }

    exports.criarCanalDeTexto = async (nome, agentes, tipo = 'privado' ) => {
        try {
            const canalDeTexto = await CanaisDeTexto.save({nome:nome, data:new Date(), tipo:tipo})
            console.log('CANAL DE TEXTO', canalDeTexto)
            for(const agente of agentes) {
                await this.addUsuarioCanalDeTexto(agente, canalDeTexto[0].id)
            }
            return canalDeTexto
        } catch (error) {
            console.error('[Canais-Texto-Error] Erro ao criar CanalDeTexto: ', error)
        }    
    }
    exports.addUsuarioCanalDeTexto = async (agente, id, tipo = 'agente') => {
        try {
            console.log('ADD USER', id)
            console.log('agente', agente)
            const usuarioCanalDeTexto = await UsuariosCanaisDeTexto.save({idCanal:parseInt(id), tipo:tipo, usuario: agente})
            const canalDeTexto = await CanaisDeTexto.fetchById(id)
            OmniEventos.emit('usuarioAdicionadoCanalDeTexto',{agente:agente, canal:canalDeTexto})
            return usuarioCanalDeTexto
        } catch (error) {
            console.error('[Canais-Texto-Error] Erro ao add UsuarioCanalDeTexto: ', error)
        }    
    }

    exports.deleteCanalDeTexto = async (idCanal) => {
        try {
            const retorno = await CanaisDeTexto.query
            .require(false)
            .where({ id: idCanal })
            .delete()
            return retorno
        } catch (error) {
            console.error('[Canais-Texto-Error] Erro ao delete CanalDeTexto: ', error)
        }
    }

    exports.getUsuariosCanalDeTexto = async (id) => {
        try {
            console.log('getUsuariosCanalDeTexto', id)
            const retorno = await UsuariosCanaisDeTexto.query
            .where({idCanal: id})
            .fetch()
            return retorno
        } catch (error) {
            console.error(error)
        }
    }
    

  


