const readline = require('readline');
const xserver = process.argv[2] ? process.argv[2] : "http://localhost:8000/admin";

// Apenas para fins de teste
const rl = readline.createInterface({
    input: process.stdin,
    output: process.stdout,
    prompt: 'Supervisor CLI> '
});

console.log(`Abrindo conexão para ${xserver}`);

const client = require("socket.io-client")(xserver, {
    "rejectUnauthorized": false
});

client.on('connect', () => {
    console.log('Bem vindo ao Supervisor client, você está conectado.');
    client.emit(`Login`, { token: 'SuperAdmin8934rndsvc89yawd32ry89asdhbo3iu2r8yasfbdefJuca' }, response => {
        console.log(`Retorno de login ${JSON.stringify(response, null, 2)}`);
        rl.prompt();
    })
    rl.prompt();
});

client.on('disconnect', (e) => {
    console.log(e);
    console.log('Desconectou do servidor');
    rl.prompt();
});

client.on('connect_timeout', (timeout) => {
    console.log('Desconectado, connection timeout.');
    rl.prompt();
});
client.on('error', (error) => {
    console.log('Desculpe, algo deu errado.');
    console.log(error);
    rl.prompt();
});
client.on('connect_error', (error) => {
    console.log('Erro de conexão. Tem certeza que o serviço do Xcontact está ativo?');
    console.log(error);
    rl.prompt();
});
client.on('reconnecting', (attemptNumber) => {
    console.log(`Estou tentando reconectar. Tentativa: ${attemptNumber}`);
    rl.prompt();
});
client.on('reconnect_failed', () => {
    console.log('Não estou conseguindo reconectar. Tem certeza que o serviço do Xcontact está ativo?');
    rl.prompt();
});
client.on('unauthorized', (err) => {
    console.log("Falha na autenticação:", err.message);
    rl.prompt();
});

client.on('log', (msg) => {
    console.log(msg);
    rl.prompt();
});

rl.on('line', (line) => {
    let pars = line.trim().split(' ');

    switch (pars[0]) {
        case 'sair':
        case 'quit':
        case 'q':
            rl.close();
            break;
        case '':
            break;
        case 'fklogin':
            client.emit(`Login`, { user: 'admin', senha: 'master' }, response => {
                console.log(`Retorno de login ${JSON.stringify(response, null, 2)}`);
                rl.prompt();
            })
            break;
        case 'getAdmins':
            client.emit('getAdmins', null, resposta => {
                console.log(`getAdmins resposta: ${JSON.stringify(resposta, null, 2)}`);
                rl.prompt();
            });
            break;
        default:
            break;
    }
    rl.prompt();
}).on('close', () => {
    console.log('Até logo!');
    process.exit(0);
});