const XClientes = require('../util/XClients');
const xc = new XClientes();
const ws = require('../ws');
exports.register = (server, options, next) => {

    if (options.config.csa.ativado) {
        const socket = require('socket.io-client')(options.config.csa.host);
        const Xws = require('../ws/handlers');
        var auxPendentes = false;
        socket.on('connect', () => {
            socket.emit('authentication', JSON.stringify({ token: options.config.csa.id }));
        });
        socket.on('authenticated', () => {

        });
        socket.on('disconnect', () => {
            console.error('Desconectou do CSA');
        });
        socket.on('connect_timeout', (timeout) => {
            console.error('Desconectado do CSA, connection timeout.');
        });
        socket.on('error', (error) => {
            console.error('Desculpe, algo deu errado.');
        });
        socket.on('connect_error', (error) => {
            console.error('Erro de conexão. Tem certeza que o serviço do CSA está ativo?');
        });
        socket.on('reconnecting', (attemptNumber) => {
            console.error('Estou tentando reconectar no CSA.');
        });
        socket.on('reconnect_failed', () => {
            console.error('Não estou conseguindo reconectar. Tem certeza que o serviço do CSA está ativo?');
        });
        socket.on('unauthorized', (err) => {
            console.error("Falha na autenticação no CSA:", err.message);
        });
        socket.on('authentication', function (data) {
            try {
                Xws['OnAuthentication'](socket, data);
            } catch (ex) {
                console.error('Falha ao tratar authentication', ex);
            }
        });
        exports.sendMsg = (event) => {
            var msg = JSON.stringify(event);
            try {
                socket.emit('message', msg);
            } catch (ex) {
                console.error('Nao consegui enviar msg pro CSA, motivo: ', ex);
            }
        };

        exports.getMsgPendentesFromBd = async () => {
            try {
                var msg = [];
                var aux = await xc.getChatSemAgente();
                if (aux) {
                    var XCliente = socket.XCliente;
                    for (let i = 0; i < aux.length; i++) {

                        msg.push({
                            "socketID": aux[i].socketID,
                            "message": aux[i].texto,
                            "ClientID": null,
                            "fromID": aux[i].fromID,
                            "toID": null,
                            "id": aux[i].fromID,
                            "nome": aux[i].fromName,
                            "queue": aux[i].queue,
                            "dados_adicionais": aux[i].dados_adicionais,
                            "protocolo": aux[i].idQueueChat,
                            "data_hora": aux[i].dataHora,
                            "messageID": aux[i].messageID,
                            "action": aux[i].queueTypeID == 4 ? 'mailMessage' : 'webChatMessage',
                            "anexo": aux[i].caminho,
                            "inOut": aux[i].inOut,
                            "ativo": aux[i].ativo,
                            "assunto": aux[i].assunto,
                            "email": aux[i].queueTypeID == 4 ? aux[i].fromName : null,
                            'mailMessageID': aux[i].mailMessageID,
                            'agente': aux[i].ultimoAgente,
                            "queueTypeID": aux[i].queueTypeID,
                            "flag": true
                        });
                    }

                    for (let i = 0; i < msg.length; i++) {
                        if (msg[i].email === null) {
                            if (msg[i].message && msg[i].messageID) {

                                ws.sendMsg(JSON.stringify(msg[i]));
                                // XCliente.MensagensNaoEntregues.push(msg[i]);                                                 
                            }

                        } else {

                        }
                    }

                }
            } catch (error) {
                console.error('ERRO AO BUSCAR MENSAGENS NAO ENTREGUES DO BANCO', error);
            }

        }

        exports.getAllSocketsCsa = async () => {
            if (socket.XCliente) {
                var xcliente = socket.XCliente;
                return xcliente;
            }

        };
    }
    next();
};

exports.register.attributes = {
    name: 'xcontact-csa'
};