const axios = require("axios");

exports.initEventsOmni = async (OmniEventos) => {
  try {
    const OMNIEVENTS_PORT = process.env.OMNIEVENTS_PORT || 3000;
    const url = `http://localhost:${OMNIEVENTS_PORT}/online`;
    const socket = require("socket.io-client")(url, {
      rejectUnauthorized: false,
    });

    socket.on("connect", () => {
      socket.emit(
        "login",
        { token: "sdfrf89hwe4983hrdslkfh34809y5r" },
        (retorno) => {
          console.log("[Omni-Events-Connect]", retorno);
        }
      );
    });
    socket.on("disconnect", (e) => {
      console.log("[Omni-Events-Connect-Error] Disconnect: ", e);
    });

    socket.on("connect_timeout", (e) => {
      console.log("[Omni-Events-Connect-Error] Timeout: ", e);
    });
    socket.on("error", (e) => {
      console.log("[Omni-Events-Connect-Error] Error: ", e);
    });
    socket.on("connect_error", (e) => {
      console.log("[Omni-Events-Connect-Error] Connection Error: ", e);
    });
    socket.on("reconnecting", (e) => {
      console.log("[Omni-Events-Connect-Error] Reconnectiong: ", e);
    });
    socket.on("reconnect_failed", () => {
      console.log("[Omni-Events-Connect-Error] Reconnect Fail");
    });
    OmniEventos.on("updateAtendimentoAgente", (dados) => {});
    OmniEventos.on("agenteTransferenciaAddAtendimento", (dados) => {});
    OmniEventos.on("novaMensagemAgente", (dados) => {
      console.log("[Omni-Events-novaMensagemAgente]", dados);
      socket.emit("novaMensagemAgente", dados);
    });
    OmniEventos.on("removeAtendimentoNaFila", (dados) => {
      console.log("[Omni-Events-removeAtendimentoNaFila]", dados);
      socket.emit("removeAtendimentoNaFila", dados);
    });
    OmniEventos.on("FilaInviteAtendimento", (dados) => {
      console.log("[Omni-Events-inviteAtendimento]", dados);
      socket.emit("FilaInviteAtendimento", dados);
    });
    OmniEventos.on("agenteAceitouAtendimento", (dados) => {
      console.log("[Omni-Events-agenteAceitouAtendimento]", dados);
      socket.emit("agenteAceitouAtendimento", dados);
    });
    OmniEventos.on("filaAddAtendimento", (dados) => {
      console.log("[Omni-Events-filaAddAtendimento]", dados);
      socket.emit("filaAddAtendimento", dados);
    });
    OmniEventos.on("agenteAddAtendimento", (dados) => {
      try {
        console.log("[Omni-Events-agenteAddAtendimento]", dados);
        socket.emit("agenteAddAtendimento", dados);

        const headers = {
          headers: {
            Accept: "application/json",
            "Content-Type": "application/json",
            Authorization: `Bearer 1e5a475b7421c20cf0edb60543b20d406a2e55fd2619f5f04ee10dbdc41a007b`,
          },
        };
        axios.put(
          `http://localhost:8001/api/v4/campanha/${dados.numero}/sucesso`,
          null,
          headers
        );
      } catch (error) {
        console.error(error);
      }
    });
    OmniEventos.on("filaNovaMensagem", (dados) => {
      console.log("[Omni-Events-filaNovaMensagem]", dados);
      socket.emit("filaNovaMensagem", dados);
    });
    OmniEventos.on("filaNovoAtendimento", (dados) => {
      console.log("[Omni-Events-filaNovoAtendimento]", dados);
      socket.emit("filaNovoAtendimento", dados);
    });
  } catch (error) {
    console.error("[Omni-Events-Error] Erro geral no módulo: ", error);
  }
};
