const db = require('./util/db');
const { format } = require("fast-csv");
const fs = require("fs");
const ftp = require("basic-ftp");
const d = new Date();
const enviar = false;
const local = 'BAURU';

const dataIni = `${d.getFullYear()}-${d.getMonth() + 1}-${d.getDate()}`;
const dataFim = `${d.getFullYear()}-${d.getMonth() + 1}-${d.getDate()}`;
const myFile = `${local}_Parcial_clientes_${d.getDate()}_${d.getMonth() + 1}_${d.getFullYear()}_${d.getHours()}_${d.getMinutes()}.csv`;
const myFtpDir = "Departamentos/Televendas";
const ftpConf = {
    host: "ftpintra.jbs.com.br",
    user: "UserDashTelevendasX5",
    password: "G*p4m3?CN&",
    secure: false
};

async function run() {
    try {
        const file = fs.createWriteStream(myFile);
        const csvStream = format({ headers: true, delimiter: ',' });
        csvStream.pipe(file);

        let dados = await db.knex.raw(`WITH filas_discador(fila, campanha) AS (
            select distinct b.fila, b.nome from campanhas_registro a join campanhas b on a.id_campanha = b.id where a.data_status::date between '${dataIni}' and '${dataFim}'
        )
        SELECT a.*, TO_CHAR("dataIni",'DD/MM/YYYY') as "data", "dataIni"::time as "Horainicio", "dataFim"::time as "Horafim", b.campanha,
        CASE 
            WHEN b.campanha IS NOT NULL THEN 'Discador'
            WHEN a.canal = 'chat' THEN 'WhatsApp'
        ELSE 'Fora de rota' END as rota
        FROM atendimentos_omnichannel a
        LEFT JOIN filas_discador b on a.fila = b.fila
        WHERE "dataIni"::date = '${dataIni}' AND a.agente IS NOT NULL
        ORDER by a."dataIni"
        `);

        for (let i = 0; i < dados.rows.length; i++) {
            let row = dados.rows[i];
            csvStream.write({
                data: row.data,
                vendedor: row.agente,
                cliente: row.cliente,
                telefone: row.numero,
                classificacao: row.classificacao,
                hora_inicio: row.Horainicio,
                hora_fim: row.Horafim,
                canal: row.rota,
                tipo: (row.rota == 'Discador') ? 'Sainte' : row.sentido
            });
        }

        csvStream.end();

        csvStream.on('end', async () => {
            console.log(`Arquivo gerado com sucesso.`);
            if (enviar) {
                console.log(`Enviando ${myFile} por FTP`);
                const client = new ftp.Client()
                await client.access(ftpConf);
                await client.ensureDir(myFtpDir);
                await client.uploadFrom(myFile, myFile);
                client.close();
                fs.unlinkSync(myFile);
                console.log(`Arquivo enviado com sucesso.`);
            }
            process.exit();
        });
    } catch (error) {
        console.log(`Falha ao gerar o arquivo`);
        console.log(error);
        process.exit(1);
    }
}

run();