var moment = require('moment-timezone');
moment.tz('America/Sao_Paulo');
var mdf = require("moment-duration-format");

const _ = require('underscore');
const axios = require('axios');
const { format } = require("fast-csv");
const fs = require("fs");
const ftp = require("basic-ftp");
const d = new Date();
const enviar = false;
const local = 'BAURU';

const myFile = `${local}_Parcial_vendedores_${d.getDate()}_${d.getMonth() + 1}_${d.getFullYear()}_${d.getHours()}_${d.getMinutes()}.csv`;
const myFtpDir = "Departamentos/Televendas";
const ftpConf = {
    host: "ftpintra.jbs.com.br",
    user: "UserDashTelevendasX5",
    password: "G*p4m3?CN&",
    secure: false
};


axios.defaults.headers.common['Authorization'] = 'Bearer 1e5a475b7421c20cf0edb60543b20d406a2e55fd2619f5f04ee10dbdc41a007b';
axios.defaults.baseURL = 'http://localhost:8001/api';

const data_ini = `${moment().format('YYYY-MM-DD')} 00:00:00`;
const data_fim = `${moment().format('YYYY-MM-DD')} 23:59:59`;

function getPercentual(feito, total) {
    if (feito == total) return 100;
    if (!feito || feito == 0) return 0;
    let perc = (feito * 100) / total;
    return perc < 100 ? perc.toFixed(2) : 100;
}

function padTime(time) {
    time = parseInt(time);
    return (time < 10 ? "0" : "") + time;
}

function diffDate(inicio, fim) {
    var timeElapsed = moment(fim - inicio).toDate(),
        hour = timeElapsed.getUTCHours(),
        min = timeElapsed.getUTCMinutes(),
        sec = timeElapsed.getUTCSeconds();

    return padTime(hour) + ":" + padTime(min) + ":" + padTime(sec);
}

function diffDateInSeconds(inicio, fim) {
    let a = moment(inicio);
    let b = moment(fim);
    return b.diff(a, 'seconds');
}

function timeElapsed(time) {
    var timeElapsed = moment(time).toDate,
        hour = timeElapsed.getUTCHours(),
        min = timeElapsed.getUTCMinutes(),
        sec = timeElapsed.getUTCSeconds();

    return padTime(hour) + ":" + padTime(min) + ":" + padTime(sec);
}

function SecToTime(seconds) {
    if (!seconds) return '00:00:00';
    let duration = moment.duration(seconds, 'seconds');
    // if (seconds < 3600) { return `00:${duration.format('hh:mm:ss')}` }
    // else { return duration.format('hh:mm:ss') }
    return duration.format('h:mm:ss', { trim: false, useGrouping: false })
};

function TimeTosec(time) {
    if (!time) return 0;
    var tt = time.split(":");
    return parseInt(tt[0]) * 3600 + parseInt(tt[1]) * 60 + parseInt(tt[2]) * 1;
};

function MilSecToTime(mili) {
    if (!mili) return '00:00:00';
    var date = moment().toDate();
    date.setMilliseconds(mili);
    return padTime(date.getHours()) + ":" + padTime(date.getMinutes()) + ":" + padTime(date.getSeconds());
    //return date.toTimeString().replace(/.*(\d{2}:\d{2}:\d{2}).*/, "$1");
};

function getTimeInEvent(eventos) {
    if (eventos.length == 0) return;
    let timeline = eventos[0];
    timeline.tempo = diffDateInSeconds(timeline.event_start, timeline.event_end);

    for (let i = 1; i < eventos.length; i++) {
        if (eventos[i].event_start > timeline.event_end) {
            //console.log(`Caiu no if pro agente ${timeline.agent} com ${MilSecToTime(timeline.tempo)}`);
            timeline.tempo += diffDateInSeconds(eventos[i].event_start, eventos[i].event_end);
            timeline.event_end = eventos[i].event_end;
        }
        else if (eventos[i].event_end > timeline.event_end) {
            //console.log(`Caiu no else pro agente ${timeline.agent}, evento ${eventos[i].event_start} até ${eventos[i].event_end}, timeline ${timeline.event_start} até ${timeline.event_end}`);
            timeline.tempo += diffDateInSeconds(timeline.event_end, eventos[i].event_end);
            timeline.event_end = eventos[i].event_end;
        }
    }
    return timeline.tempo;
}

async function run() {
    let atual = moment().toDate();
    let $scope = {};
    $scope.registros = [];
    $scope.pausas_nr17 = ["ALMOCO", "LANCHE_MANHA", "LANCHE_TARDE"];

    try {
        let query = `max=-1`;
        query += `&data_ini=${data_ini}`;
        query += `&data_fim=${data_fim}`;

        let geteventos = await axios.get(`/v2/agentes/eventos?${encodeURI(query)}`);
        let eventos = geteventos.data.dados.map(item => {
            item.event_start = moment(item.event_start).toDate();
            item.event_end = item.event_end ? moment(item.event_end).toDate() : atual;
            return item;
        });

        let getcampanhareg = await axios.get(`/v2/campanhas/registros?${encodeURI(query)}`);
        $scope.campanhareg = getcampanhareg.data.dados.map(item => {
            item.data_status = moment(item.data_status).toDate();
            item.duracao_sec = TimeTosec(item.duracao);
            return item;
        });

        let qc = `max=-1`;
        qc += `&data_start_ini=${data_ini}`;
        qc += `&data_start_fim=${data_fim}`;
        let getcampanhas = await axios.get(`/v2/campanhas?${encodeURI(qc)}`);
        $scope.campanhas = getcampanhas.data.dados;

        let ql = `${query}&status=["Atendida"]`
        let getfilaligacoes = await axios.get(`/v2/filas/ligacoes?${encodeURI(ql)}`);
        $scope.filaligacoes = getfilaligacoes.data.dados.map(item => {
            item.calldate = moment(item.calldate).toDate();
            item.duracao_sec = TimeTosec(item.duracao);
            return item;
        });

        let qchat = `max=-1`;
        qchat += `&dataIni=${data_ini}`;
        qchat += `&dataFim=${data_fim}`;
        qchat += `&status=["Entrou","Pesquisa","Encerrado"]`
        let getChats = await axios.get(`/v2/chats?${encodeURI(qchat)}`);
        $scope.chats = getChats.data.dados.map(item => {
            item.dataIni = moment(item.dataIni).toDate();
            item.dataFim = item.dataFim ? moment(item.dataFim).toDate() : atual;
            item.duracao = MilSecToTime(item.dataFim - item.dataIni);
            item.duracao_sec = TimeTosec(item.duracao);
            return item;
        });


        let ordenado = _.chain(eventos)
            .sortBy('event_start')
            .groupBy('agent')
            .map(function (value1) {
                let ob = {};
                ob.login = Object.assign([], value1.filter(item => item.event == 'Login'));
                // console.log(`${value1[0].agent} ${ob.login.length}`)
                // console.log(ob.login)
                if (!ob.login || ob.login.length <= 0) return;
                ob.agente = value1[0].agent;
                ob.login_geral = Object.assign([], value1.filter(item => item.event == 'Login'));
                ob.pausas = Object.assign([], value1.filter(item => item.event == 'Pause' && item.event_data1 != 'Classificando'));
                ob.pausas_geral = Object.assign([], value1.filter(item => item.event == 'Pause' && item.event_data1 != 'Classificando'));

                ob.pausas_nr17 = Object.assign([], ob.pausas.filter(item => $scope.pausas_nr17.includes(item.event_data1)));
                ob.outras_pausas = Object.assign([], ob.pausas.filter(item => !$scope.pausas_nr17.includes(item.event_data1)));

                ob.pausas_nr17_group = _.chain(ob.pausas_nr17).groupBy('event_data1').map(p => {
                    return {
                        nome: p[0].event_data1,
                        tempo: getTimeInEvent(p)
                    };
                }).value();

                ob.todas_as_outras_pausas = _.chain(ob.outras_pausas).groupBy('event_data1').map(p => {
                    return {
                        nome: p[0].event_data1,
                        tempo: SecToTime(getTimeInEvent(p))
                    };
                }).value();

                ob.lista_pausas = ob.todas_as_outras_pausas.map(p => `${p.nome}=${p.tempo}`).join(';');

                ob.pausas_desgroup = [];
                for (let i = 0; i < ob.pausas_nr17_group.length; i++) {
                    ob.pausas_desgroup[ob.pausas_nr17_group[i].nome] = SecToTime(ob.pausas_nr17_group[i].tempo);
                }
                ob.pausas_nr17_ob = Object.assign({}, ob.pausas_desgroup);


                let outras_pausas = (ob.outras_pausas && ob.outras_pausas.length > 0) ? getTimeInEvent(ob.outras_pausas) : 0;
                ob.total_outras_pausas = SecToTime(outras_pausas);

                if (ob.login && ob.login.length > 0) {
                    ob.primeiro_login = ob.login.reduce((a, b) => (a.event_start.getTime() < b.event_start.getTime() ? a : b)).event_start;
                    ob.ultimo_logoff = ob.login.reduce((a, b) => ((a.event_end ? a.event_end.getTime() : atual) > (b.event_end ? b.event_end.getTime() : atual) ? a : b)).event_end;
                }

                let logado = diffDateInSeconds(ob.primeiro_login, ob.ultimo_logoff);
                ob.total_logado = SecToTime(logado);

                let pausado = ob.pausas_geral.length > 0 ? getTimeInEvent(ob.pausas_geral) : '';
                ob.total_pausa = SecToTime(pausado);
                ob.qtd_pausa = ob.pausas.length;


                ob.jornada_trabalho = pausado ? SecToTime(logado - pausado) : SecToTime(logado);

                ob.filas = [...new Set(_.pluck(value1, "queue"))];

                // Discador
                if ($scope.campanhas) {
                    ob.campanhas = $scope.campanhas.filter(c => ob.filas.includes(c.fila));
                    if (ob.campanhas) {
                        ob.campanhas_nome = [...new Set(_.pluck(ob.campanhas, "nome"))];
                        ob.filas_discador = [...new Set(_.pluck(ob.campanhas, "fila"))];
                        ob.meta_mailing = ob.campanhas.map(l => { return parseInt(l.total_contatos) }).reduce((a, b) => a + b, 0);

                        if ($scope.campanhareg && $scope.campanhareg.length > 0) {
                            ob.campanha_registros = $scope.campanhareg.filter(c => ob.campanhas_nome.includes(c.campanha));
                            ob.ligacoes_completadas = ob.campanha_registros.filter(item => item.status == 'Completou');

                            ob.real_mailing = [...new Set(_.pluck(ob.campanha_registros, "id_contato"))].length;

                            ob.aderencia_discador = ob.meta_mailing ? ((ob.real_mailing * 100) / ob.meta_mailing).toFixed(2) : 0;

                            ob.prineira_ligacao = ob.campanha_registros.reduce((a, b) => (a.data_status && a.data_status.getHours() < b.data_status.getHours() ? a : b), 0).data_status;

                            ob.ultima_ligacao = ob.campanha_registros.reduce((a, b) => (a.data_status && a.data_status.getHours() > b.data_status.getHours() ? a : b), 0).data_status;

                            ob.tempo_ligacoes = ob.ligacoes_completadas.map(l => { return parseInt(l.duracao_sec) }).reduce((a, b) => a + b, 0);
                            ob.tempo_medio_falado = ob.ligacoes_completadas.length ? SecToTime(ob.tempo_ligacoes / ob.ligacoes_completadas.length) : 0;

                            ob.logins_discador = ob.login.filter(item => ob.filas_discador.includes(item.queue));
                            if (ob.logins_discador.length > 0) { ob.primeiro_login_discador = ob.logins_discador.reduce((a, b) => (a.event_start.getHours() < b.event_start.getHours() ? a : b)).event_start };
                            ob.pausas_discador = ob.pausas.filter(item => ob.filas_discador.includes(item.queue));

                            let logado_discador = ob.logins_discador.length > 0 ? getTimeInEvent(ob.logins_discador) : 0;
                            ob.total_logado_discador = SecToTime(logado_discador);

                            let pausado_discador = ob.pausas_discador.length > 0 ? getTimeInEvent(ob.pausas_discador) : 0;
                            ob.total_pausa_discador = SecToTime(pausado_discador);
                            ob.jornada_trabalho_discador = logado_discador > 0 ? SecToTime(logado_discador - pausado_discador) : 0;

                            ob.presenca_discador = logado_discador ? getPercentual((logado_discador - pausado_discador), (logado - pausado)) : 0;
                        }
                    }
                }

                // Nao discador
                ob.total_ligacoes_fora = 0;
                ob.presenca_fora = 0;
                ob.total_logado_fora = 0;
                ob.total_pausa_fora = 0;
                ob.tempo_medio_falado_fora = 0;
                ob.jornada_fora = 0;

                if (ob.filas_discador && ob.filas_discador.length > 0) {
                    ob.ligacoes_fora_discador = $scope.filaligacoes.filter(e => e.agente == ob.agente && !ob.filas_discador.includes(e.fila));
                    ob.total_ligacoes_fora = ob.ligacoes_fora_discador.length;

                    if (ob.ligacoes_fora_discador && ob.ligacoes_fora_discador.length > 0) {
                        ob.primeira_ligacao_fora = ob.ligacoes_fora_discador.reduce((a, b) => (a.calldate && a.calldate.getHours() < b.calldate.getHours() ? a : b)).calldate;
                        ob.ultima_ligacao_fora = ob.ligacoes_fora_discador.reduce((a, b) => (a.calldate && a.calldate.getHours() > b.calldate.getHours() ? a : b)).calldate;

                        ob.logins_fora = ob.login.filter(item => !ob.filas_discador.includes(item.queue));
                        ob.pausas_fora = ob.pausas.filter(item => !ob.filas_discador.includes(item.queue));

                        let logado_fora = ob.logins_fora.length > 0 ? getTimeInEvent(ob.logins_fora) : 0;
                        ob.total_logado_fora = SecToTime(logado_fora);

                        let pausado_fora = ob.pausas_fora.length > 0 ? getTimeInEvent(ob.pausas_fora) : 0;
                        ob.total_pausa_fora = SecToTime(pausado_fora);

                        ob.jornada_fora = logado_fora > 0 ? SecToTime(logado_fora - pausado_fora) : 0;

                        ob.tempo_ligacoes_fora = ob.ligacoes_fora_discador.map(l => { return parseInt(l.duracao_sec) }).reduce((a, b) => a + b, 0);
                        ob.tempo_medio_falado_fora = ob.ligacoes_fora_discador.length ? SecToTime(ob.tempo_ligacoes_fora / ob.ligacoes_fora_discador.length) : 0;

                        ob.presenca_fora = logado_fora ? ((logado_fora - pausado_fora) * 100) / (logado - pausado) : 0;
                        ob.presenca_fora = ob.presenca_fora.toFixed(2);
                    }
                }

                // WhatsApp
                ob.total_chats = 0;
                ob.total_chats_entrantes = 0;
                ob.total_chats_entrantes_encerrados = 0;
                ob.total_chats_entrantes_abertos = 0;

                ob.total_chats_saintes = 0;
                ob.total_chats_saintes_ecerrados = 0;
                ob.total_chats_saintes_abertos = 0;

                ob.perc_chats_entrantes_encerrados = 0;
                ob.perc_chats_saintes_encerrados = 0;

                ob.chats = $scope.chats.filter(e => e.ultimoAgente == ob.agente);
                if (ob.chats && ob.chats.length > 0) {
                    ob.total_chats = ob.chats.length;


                    ob.chats_entrantes = ob.chats.filter(item => item.sentido == 'Entrante');
                    ob.chats_saintes = ob.chats.filter(item => item.sentido == 'Sainte');

                    ob.chats_entrantes_ecerrados = (ob.chats_entrantes && ob.chats_entrantes.length > 0) ? ob.chats_entrantes.filter(item => item.status == 'Encerrado') : [];
                    ob.chats_saintes_ecerrados = (ob.chats_saintes && ob.chats_saintes.length > 0) ? ob.chats_saintes.filter(item => item.status == 'Encerrado') : [];

                    ob.total_chats_entrantes = ob.chats_entrantes.length;

                    ob.total_chats_entrantes_encerrados = ob.chats_entrantes_ecerrados.length;

                    ob.total_chats_entrantes_abertos = ob.total_chats_entrantes > 0 ? ob.total_chats_entrantes - ob.total_chats_entrantes_encerrados : 0;

                    ob.perc_chats_entrantes_encerrados = ob.total_chats_entrantes_encerrados > 0 ? (ob.total_chats_entrantes_encerrados * 100) / ob.total_chats_entrantes : 0;
                    ob.perc_chats_entrantes_encerrados = ob.perc_chats_entrantes_encerrados.toFixed(2);

                    ob.total_chats_saintes = ob.chats_saintes.length;

                    ob.total_chats_saintes_ecerrados = ob.chats_saintes_ecerrados.length;

                    ob.total_chats_saintes_abertos = ob.total_chats_saintes > 0 ? ob.total_chats_saintes - ob.total_chats_saintes_ecerrados : 0;

                    ob.perc_chats_saintes_encerrados = ob.chats_saintes > 0 ? (ob.chats_saintes_ecerrados * 100) / ob.chats_saintes : 0;
                    ob.perc_chats_saintes_encerrados = ob.perc_chats_saintes_encerrados.toFixed(2);
                }

                return ob;
            })
            .value();

        const file = fs.createWriteStream(myFile);
        const csvStream = format({ headers: true, delimiter: ',' });
        csvStream.pipe(file);

        //console.log(JSON.stringify(ordenado, null, 2));

        for (reg of ordenado) {
            if (!reg) { continue };
            let ob = {
                data: moment(reg.primeiro_login).format('DD/MM/YYYY'),
                vendedor: reg.agente,

                primeiro_login: moment(reg.primeiro_login).format('HH:mm:ss'),
                ultimo_logoff: reg.ultimo_logoff && reg.ultimo_logoff != atual ? moment(reg.ultimo_logoff).format('HH:mm:ss') : '',
                total_logado: reg.total_logado,
                qtd_pausa: reg.qtd_pausa,
                tempo_total_pausas: reg.total_pausa,
                jornada_trabalho: reg.jornada_trabalho,

                meta_mailing: reg.meta_mailing,
                real_mailing: reg.real_mailing,
                aderencia_discador: `${reg.aderencia_discador}%`,
                primeiro_login_discador: reg.primeiro_login_discador ? moment(reg.primeiro_login_discador).format('HH:mm:ss') : '',
                primeira_ligacao_discador: reg.prineira_ligacao ? moment(reg.prineira_ligacao).format('HH:mm:ss') : '',
                ultima_ligacao_discador: reg.ultima_ligacao ? moment(reg.ultima_ligacao).format('HH:mm:ss') : '',
                total_logado_discador: reg.total_logado_discador ? reg.total_logado_discador : '00:00:00',
                total_pausado_discador: reg.total_pausa_discador ? reg.total_pausa_discador : '00:00:00',
                jornada_trabalho_discador: reg.jornada_trabalho_discador ? reg.jornada_trabalho_discador : '00:00:00',
                presenca_discador: `${reg.presenca_discador}%`,
                tempo_medio_falado: reg.tempo_medio_falado < 60 ? `00:${reg.tempo_medio_falado}` : reg.tempo_medio_falado,

                total_ligacoes_fora: reg.total_ligacoes_fora,
                primeira_ligacao_fora: reg.primeira_ligacao_fora ? moment(reg.primeira_ligacao_fora).format('HH:mm:ss') : '',
                ultima_ligacao_fora: reg.ultima_ligacao_fora ? moment(reg.ultima_ligacao_fora).format('HH:mm:ss') : '',
                total_logado_fora: reg.total_logado_fora ? reg.total_logado_fora : '00:00:00',
                total_pausa_fora: reg.total_pausa_fora ? reg.total_pausa_fora : '00:00:00',
                jornada_fora: reg.jornada_fora ? reg.jornada_fora : '00:00:00',
                presenca_fora: `${reg.presenca_fora}%`,
                tempo_medio_falado_fora: reg.tempo_medio_falado_fora < 60 ? `00:${reg.tempo_medio_falado_fora}` : reg.tempo_medio_falado_fora,

                total_chats: reg.total_chats,
                total_chats_entrantes: reg.total_chats_entrantes,
                total_chats_entrantes_encerrados: reg.total_chats_entrantes_encerrados,
                total_chats_entrantes_abertos: reg.total_chats_entrantes_abertos,
                perc_chats_entrantes_encerrados: `${reg.perc_chats_entrantes_encerrados}%`,
                total_chats_saintes: reg.total_chats_saintes,
                total_chats_saintes_ecerrados: reg.total_chats_saintes_ecerrados,
                total_chats_saintes_abertos: reg.total_chats_saintes_abertos,
                perc_chats_saintes_encerrados: `${reg.perc_chats_saintes_encerrados}%`,

                lanche_manha: reg.pausas_nr17_ob['LANCHE_MANHA'],
                almoco: reg.pausas_nr17_ob['ALMOCO'],
                lanche_tarde: reg.pausas_nr17_ob['LANCHE_TARDE'],
                outras_pausas: reg.lista_pausas
            }
            csvStream.write(ob);

            // Esses sao todos os campos que o relatorio exibe, ja deixo aqui pois vão pedir depois :)
            let result = [
                reg.agente,
                moment(reg.primeiro_login).format('HH:mm:ss'),
                moment(reg.ultimo_logoff).format('HH:mm:ss'),
                reg.total_logado,
                reg.qtd_pausa,
                reg.total_pausa,
                reg.jornada_trabalho,
                reg.meta_mailing,
                reg.real_mailing,
                reg.aderencia_discador,
                moment(reg.prineira_ligacao).format('HH:mm:ss'),
                moment(reg.ultima_ligacao).format('HH:mm:ss'),
                reg.total_logado_discador,
                reg.total_pausa_discador,
                reg.jornada_trabalho_discador,
                reg.presenca_discador,
                reg.tempo_medio_falado,
                reg.total_ligacoes_fora,
                moment(reg.primeira_ligacao_fora).format('HH:mm:ss'),
                moment(reg.ultima_ligacao_fora).format('HH:mm:ss'),
                reg.total_logado_fora,
                reg.total_pausa_fora,
                reg.jornada_fora,
                reg.presenca_fora,
                reg.tempo_medio_falado_fora,
                reg.total_chats,
                reg.total_chats_entrantes,
                reg.total_chats_entrantes_encerrados,
                reg.total_chats_entrantes_abertos,
                reg.perc_chats_entrantes_encerrados,
                reg.total_chats_saintes,
                reg.total_chats_saintes_ecerrados,
                reg.total_chats_saintes_abertos,
                reg.perc_chats_saintes_encerrados,
                reg.pausas_nr17_ob,
                reg.total_outras_pausas,
            ]
        }
        csvStream.end();

        csvStream.on('end', async () => {
            console.log(`Arquivo gerado com sucesso.`);

            if (enviar) {
                console.log(`Enviando ${myFile} por FTP`);
                const client = new ftp.Client()
                await client.access(ftpConf);
                await client.ensureDir(myFtpDir);
                await client.uploadFrom(myFile, myFile);
                client.close();
                fs.unlinkSync(myFile);
                console.log(`Arquivo enviado com sucesso.`);
            }
        });

    } catch (error) {
        console.error(error);
    }
}

run();