var moment = require('moment-timezone')
moment.tz('America/Sao_Paulo')
var mdf = require("moment-duration-format")
const _ = require('underscore')
const axios = require('axios')
const { format } = require("fast-csv")
const fs = require("fs")
const ftp = require("basic-ftp")
const enviar = true
let dataParam = process.argv.slice(2)
dataParam = dataParam[0]

const myFtpDirs = {
    eventos: "Departamentos/Televendas/Eventos",
    previsto: "Departamentos/Televendas/Previsto",
    realizado: "Departamentos/Televendas/Realizado"
}

const ftpConf = {
    host: "ftpintra.jbs.com.br",
    user: "UserDashTelevendasX5",
    password: "5K=HNXy>BY+hV]o",
    secure: false
}

axios.defaults.headers.common['Authorization'] = 'Bearer 1e5a475b7421c20cf0edb60543b20d406a2e55fd2619f5f04ee10dbdc41a007b'
axios.defaults.baseURL = 'http://localhost:8001/api'

const data_dia = moment(dataParam).startOf('day').format('YYYY-MM-DD')
const data_dia_sem_hifen = moment(dataParam).startOf('day').format('YYYYMMDD')
const data_ini = moment(dataParam).startOf('day').format('YYYY-MM-DD HH:mm:ss')
const data_fim_agendamento = moment(dataParam).add(1, 'day').startOf('day').format('YYYY-MM-DD HH:mm:ss')
const data_fim = moment(dataParam).endOf('day').format('YYYY-MM-DD HH:mm:ss')
const arquivos = {}

// const data_dia = moment('2023-03-03').startOf('day').format('YYYY-MM-DD')
// const data_ini = moment('2023-03-03').startOf('day').format('YYYY-MM-DD HH:mm:ss')
// const data_fim_agendamento = moment('2023-03-04').startOf('day').format('YYYY-MM-DD HH:mm:ss')
// const data_fim = moment('2023-03-03').endOf('day').format('YYYY-MM-DD HH:mm:ss')

function SecToTime (seconds) {
    if (!seconds) return '00:00:00'
    let duration = moment.duration(seconds, 'seconds')
    return duration.format('h:mm:ss', { trim: false, useGrouping: false })
}

function TimeTosec (time) {
    if (!time) return 0
    if (typeof time == 'object') time = `${time.getHours()}:${time.getMinutes()}:${time.getSeconds()}`
    var tt = time.split(":")
    return parseInt(tt[0]) * 3600 + parseInt(tt[1]) * 60 + parseInt(tt[2]) * 1
}

function MilSecToTime (mili) {
    if (!mili) return '00:00:00'
    var date = moment().toDate()
    date.setMilliseconds(mili)
    return padTime(date.getHours()) + ":" + padTime(date.getMinutes()) + ":" + padTime(date.getSeconds())
}

function padTime (time) {
    time = parseInt(time)
    return (time < 10 ? "0" : "") + time
}

function diffDateInSeconds (inicio, fim) {
    let a = moment(inicio)
    let b = moment(fim)
    return b.diff(a, 'seconds')
}

function getTimeInEvent (eventos) {
    if (eventos.length == 0) return

    let timeline = JSON.parse(JSON.stringify(eventos[0]))
    timeline.event_start = moment(timeline.event_start).toDate()
    timeline.event_end = timeline.event_end ? moment(timeline.event_end).toDate() : atual
    timeline.tempo = diffDateInSeconds(timeline.event_start, timeline.event_end)

    for (let i = 1; i < eventos.length; i++) {
        if (eventos[i].event_start > timeline.event_end) {
            timeline.tempo += diffDateInSeconds(eventos[i].event_start, eventos[i].event_end)
            timeline.event_end = eventos[i].event_end
        }
        else if (eventos[i].event_end > timeline.event_end) {
            timeline.tempo += diffDateInSeconds(timeline.event_end, eventos[i].event_end)
            timeline.event_end = eventos[i].event_end
        }
    }
    return timeline.tempo
}

function returnQtdMsg (chats) {
    let msgs = 0
    for (let i = 0; i < chats.length; i++) {
        msgs += chats[i].qtd_msg
    }
    return msgs
}

function returnTempoMedioFalado (ligacoes) {
    let ttf = 0
    if (ligacoes.length > 0) {
        for (let i = 0; i < ligacoes.length; i++) {
            ttf += ligacoes[i].duracao_sec
        }
        let tmf = parseFloat((ttf / ligacoes.length).toFixed(2))
        return tmf
    } else return 0
}

function getValueFromCampos (campos, chave) {
    const campo = campos && campos.length > 0 ? campos.find(c => c[chave]) : ''
    return campo ? campo[chave] : ''
}

function getValueFromNumeros (numeros, chave) {
    const numero = numeros && numeros.length > 0 ? numeros.find(n => n[chave]) : ''
    return numero ? numero[chave] : ''
}

function returnSentido (atendimento) {
    if (!atendimento.fila) return 'N/A'
    if (atendimento.fila.includes('Whatsapp')) return atendimento.sentido
    else return atendimento.sentido === 1 ? 'Entrante' : 'Sainte'
}

let queryCamp = `max=-1`
queryCamp += `&data_agendamento_ini=${data_ini}`
queryCamp += `&data_agendamento_fim=${data_fim_agendamento}`

let query = `max=-1`
query += `&data_ini=${data_ini}`
query += `&data_fim=${data_fim}`

let queryLig = `${query}&status=["Atendida"]`

let queryChat = `max=-1`
queryChat += `&dataIni=${data_ini}`
queryChat += `&dataFim=${data_fim}`
queryChat += `&status=["Entrou","Pesquisa","Encerrado"]`

async function generateFiles (campanhas, filaLigacoes, registros, chats, eventos, agentes, local) {
    return new Promise(async (resolve, reject) => {
        try {
            // Lógica para gerar os arquivos previsto, realizado e eventos
            await exportPrevisto(campanhas, local)
            await exportRealizado(campanhas, filaLigacoes, registros, chats, local)
            await exportEventos(eventos, agentes, filaLigacoes, registros, chats, local)

            resolve() // Resolva a promise quando a geração dos arquivos for concluída
        } catch (error) {
            reject(error) // Rejeite a promise em caso de erro
        }
    })
}

async function runExports () {
    try {
        // Aqui eu pego todas as informações
        let campanhas = (await axios.get(`/v2/campanhas?${encodeURI(queryCamp)}`)).data.dados

        // Tentei fazer uma rota que já trouxesse os contatos, porém colou o processamento.
        // Por mais incrível que pareça, essa forma foi a mais performática
        for (let i = 0; i < campanhas.length; i++) {
            const camp = campanhas[i]
            camp.contatos = (await axios.get(`v2/campanha/${camp.id}/contatos?max=-1&page=1`)).data.dados
        }

        // const camp = campanhas[0]
        // camp.contatos = (await axios.get(`v2/campanha/${camp.id}/contatos?max=-1&page=1`)).data.dados

        let agentes = (await axios.get(`/v2/agentes?max=-1&page=1`)).data.dados

        let eventos = (await axios.get(`/v2/agentes/eventos?${encodeURI(query)}`)).data.dados
        eventos = eventos.map(item => {
            item.event_start = moment(item.event_start).toDate()
            if (item.event === 'Login') item.deslogou = item.event_end ? true : false
            item.event_end = item.event_end ? moment(item.event_end).toDate() : data_fim
            return item
        })

        let registros = (await axios.get(`/v2/campanhas/registros?${encodeURI(query)}`)).data.dados
        registros = registros.map(item => {
            item.data_status = moment(item.data_status).toDate()
            item.dataIni = moment(item.data_status).toDate()
            item.duracao_sec = TimeTosec(item.duracao)
            item.agente = item.campos.Nome_Vendedor
            return item
        })

        let filaLigacoes = (await axios.get(`/v2/filas/ligacoes?${encodeURI(queryLig)}`)).data.dados
        filaLigacoes = filaLigacoes.map(item => {
            item.calldate = moment(item.calldate).toDate()
            item.dataIni = moment(item.calldate).toDate()
            item.duracao_sec = TimeTosec(item.duracao)
            return item
        })

        let chats = (await axios.get(`/v2/chats?${encodeURI(queryChat)}`)).data.dados
        chats = chats.map(item => {
            item.dataIni = moment(item.dataIni).toDate()
            item.dataFim = item.dataFim ? moment(item.dataFim).toDate() : data_fim
            item.duracao = MilSecToTime(item.dataFim - item.dataIni)
            item.duracao_sec = TimeTosec(item.duracao)
            return item
        })

        let local = (await axios.get(`/v3/licenca`)).data.dados
        local = local.cliente.match(/-(.*)/)[1]

        // Gere os arquivos
        await generateFiles(campanhas, filaLigacoes, registros, chats, eventos, agentes, local)

        // Realize o envio via FTP aqui
        if (enviar) {
            try {
                console.log(`EXPORT VIA FTP: Enviando arquivos por FTP`)

                const client = new ftp.Client()
                await client.access(ftpConf)

                // Enviar os arquivos gerados
                await client.ensureDir(myFtpDirs.previsto)
                const previsto = await client.uploadFrom(arquivos.previsto, arquivos.previstoD)
                console.log(previsto, `Prevista_${local}_${data_dia_sem_hifen}.csv`)

                await client.ensureDir(myFtpDirs.realizado)
                const realizado = await client.uploadFrom(arquivos.realizado, arquivos.realizadoD)
                console.log(realizado)

                await client.ensureDir(myFtpDirs.eventos)
                const eventos = await client.uploadFrom(arquivos.eventos, arquivos.eventosD)
                console.log(eventos)

                client.close()

                // Excluir os arquivos da máquina local
                fs.unlinkSync(arquivos.previsto)
                fs.unlinkSync(arquivos.previstoD)
                fs.unlinkSync(arquivos.realizado)
                fs.unlinkSync(arquivos.realizadoD)
                fs.unlinkSync(arquivos.eventos)
                fs.unlinkSync(arquivos.eventosD)

                console.log(`EXPORT VIA FTP: Arquivos enviados com sucesso.`)
            } catch (error) {
                console.log(`EXPORT VIA FTP: Erro ao enviar arquivos.`, error)
            }
        }
    } catch (error) {
        console.error('EXPORT VIA FTP: ', error)
    }
}

async function exportPrevisto (campanhas, local) {
    const csvFileName = `Prevista_${local}.csv`
    const csvFilePathWithData = `Prevista_${local}_${data_dia_sem_hifen}.csv`
    arquivos.previsto = csvFileName
    arquivos.previstoD = csvFilePathWithData

    // Criar o stream do CSV com headers
    const csvStream = format({ headers: true })

    // Criar os streams de escrita dos arquivos CSV
    const fileStreamWithData = fs.createWriteStream(csvFilePathWithData)
    const fileStreamWithoutData = fs.createWriteStream(csvFileName)

    // Pipe o stream do CSV para ambos os arquivos
    csvStream.pipe(fileStreamWithData)
    csvStream.pipe(fileStreamWithoutData)

    // Percorrer todas as campanhas
    for (let i = 0; i < campanhas.length; i++) {
        const campanha = campanhas[i]
        if (!campanha.contatos) campanha.contatos = []

        // Percorrer todos os contatos da campanha
        for (let j = 0; j < campanha.contatos.length; j++) {
            const contato = campanha.contatos[j]

            const codigoCliente = getValueFromCampos(contato.campos, 'Codigo')
            const nomeCliente = getValueFromCampos(contato.campos, 'Nome')
            const data = data_dia
            const telefonePrincipal = getValueFromNumeros(contato.numeros, 'TelefonePrincipal')
            const telefone1 = getValueFromNumeros(contato.numeros, 'Telefone1')
            const telefone2 = getValueFromNumeros(contato.numeros, 'Telefone2')
            const telefone3 = getValueFromNumeros(contato.numeros, 'Telefone3')
            const telefone4 = getValueFromNumeros(contato.numeros, 'Telefone4')
            const codigoVendedorERP = getValueFromCampos(contato.campos, 'Cod_vendedor_ERP')
            const vendedor = getValueFromCampos(contato.campos, 'Nome_Vendedor')

            // Escrever a linha do CSV com os valores do contato
            csvStream.write({
                FILIAL: local,
                'CODIGO CLIENTE': codigoCliente,
                'NOME DO CLIENTE': nomeCliente,
                DATA: data,
                TELEFONEPRINCIPAL: telefonePrincipal,
                TELEFONE1: telefone1,
                TELEFONE2: telefone2,
                TELEFONE3: telefone3,
                TELEFONE4: telefone4,
                'CODIGO VENDEDOR ERP': codigoVendedorERP,
                VENDEDOR: vendedor
            })
        }
    }

    // Finalizar a escrita do CSV
    csvStream.end()

    return new Promise((resolve, reject) => {
        csvStream.on('end', () => {
            console.log(`EXPORT VIA FTP: Arquivos de rota prevista gerados com sucesso.`)
            resolve()
        })

        csvStream.on('error', (error) => {
            console.log(`EXPORT VIA FTP: Erro ao gerar arquivos de rota prevista.`, error)
            reject(error)
        })
    })
}

async function exportRealizado (campanhas, filaLigacoes, registros, chats, local) {
    // Pegar um array com todos os contatos para o dia e dentro de cada contato, criar um array de todosNumeros
    const contatosDia = []
    campanhas.map((campanha) => {
        if (!campanha.contatos) campanha.contatos = []

        campanha.contatos.map((contato) => {
            const todosNumeros = []
            if (contato.numeros) {
                contato.numeros.map((numero) => {
                    const keys = Object.keys(numero)
                    keys.map((key) => {
                        todosNumeros.push(numero[key])
                    })
                })
            }
            contato.todosNumeros = todosNumeros

            // Prepara um array agora com todos os atendimentos
            const todosAtendimentos = []

            // Filtrar chats
            const chatsFiltrados = chats.filter((chat) =>
                todosNumeros.includes(chat.numero)
            )
            todosAtendimentos.push(...chatsFiltrados)

            // Filtrar registros de campanha
            const registrosCampanhas = registros.filter((registro) => todosNumeros.includes(registro.numero))
            const registrosID = registrosCampanhas.map(registro => registro.actionid)
            todosAtendimentos.push(...registrosCampanhas)

            // Filtrar ligações
            const filaLigacoesFiltradas = filaLigacoes.filter((ligacao) =>
                todosNumeros.includes(ligacao.numero) && !registrosID.includes(ligacao.callid)
            )
            todosAtendimentos.push(...filaLigacoesFiltradas)

            // Encontrar o primeiro atendimento
            const primeiroAtendimento = todosAtendimentos.reduce((primeiro, atendimento) => {
                if (!primeiro || atendimento.dataIni < primeiro.dataIni) {
                    return atendimento
                }
                return primeiro
            }, null)

            const ligacoesExtras = primeiroAtendimento && primeiroAtendimento.fila && primeiroAtendimento.fila.includes('Whatsapp')
                ? filaLigacoesFiltradas
                : filaLigacoesFiltradas.filter((ligacao) => ligacao.callid !== primeiroAtendimento.callid)

            const tempoFaladoExtra = ligacoesExtras.reduce((acumulador, ligacao) => acumulador + ligacao.duracao_sec, 0)

            contato.ligacoesExtras = ligacoesExtras
            contato.todosAtendimentos = todosAtendimentos
            contato.primeiroAtendimento = primeiroAtendimento
            contato.tempoFaladoExtra = tempoFaladoExtra

            if (contato.todosAtendimentos && contato.todosAtendimentos.length > 0) contatosDia.push(contato)
        })
    })

    const csvFileName = `Realizado_${local}.csv`
    const csvFilePathWithData = `Realizado_${local}_${data_dia_sem_hifen}.csv`
    arquivos.realizado = csvFileName
    arquivos.realizadoD = csvFilePathWithData

    // Criar o stream do CSV com headers
    const csvStream = format({ headers: true })

    // Criar os streams de escrita dos arquivos CSV
    const fileStreamWithData = fs.createWriteStream(csvFilePathWithData)
    const fileStreamWithoutData = fs.createWriteStream(csvFileName)

    // Pipe o stream do CSV para ambos os arquivos
    csvStream.pipe(fileStreamWithData)
    csvStream.pipe(fileStreamWithoutData)

    contatosDia.forEach((contato) => {
        csvStream.write({
            FILIAL: local,
            "CODIGO CLIENTE": getValueFromCampos(contato.campos, 'Codigo'),
            DATA: data_dia,
            "TELEFONE PRINCIPAL": getValueFromNumeros(contato.numeros, 'TelefonePrincipal'),
            "CODIGO VENDEDOR ERP": getValueFromCampos(contato.campos, 'Cod_vendedor_ERP'),
            "INICIO LIGACAO/MSG": moment(contato.primeiroAtendimento.dataIni).format('HH:mm:ss'),
            "TEMPO FALADO": !contato.primeiroAtendimento.fila || contato.primeiroAtendimento.fila.includes('Whatsapp') ? 'N/A' : contato.primeiroAtendimento.duracao,
            TIPO: returnSentido(contato.primeiroAtendimento),
            FILA: contato.primeiroAtendimento.fila || 'N/A',
            TABULAÇÃO: contato.primeiroAtendimento.classificacao || '',
            "LIGACOES EXTRAS": contato.ligacoesExtras.length,
            "TEMPO FALADO EXTRA": SecToTime(contato.tempoFaladoExtra),
        })
    })

    csvStream.end()

    return new Promise((resolve, reject) => {
        csvStream.on('end', () => {
            console.log(`EXPORT VIA FTP: Arquivos de rota realizada gerados com sucesso.`)
            resolve()
        })

        csvStream.on('error', (error) => {
            console.log(`EXPORT VIA FTP: Erro ao gerar arquivos de rota realizada.`, error)
            reject(error)
        })
    })
}

async function exportEventos (eventos, agentes, filaLigacoes, registros, chats, local) {
    const pausasValidas = ["LANCHE_MANHA", "ALMOCO", "LANCHE_TARDE", "CHECKLIST", "MATINAL", "SOLUCOES_FORA_MESA", "PESSOAL", "FEEDBACK_TREINAMENTO"]
    // Agrupo todos os dados por agente
    const eventosAgrupados = _.chain(eventos).sortBy('event_start').groupBy('agent').value()
    const agentesNomes = _.keys(eventosAgrupados)
    const ligacoesAgrupadas = _.chain(filaLigacoes).sortBy('dataIni').groupBy('agente').value()
    const registrosAgrupados = _.chain(registros).sortBy('dataIni').groupBy('agente').value()
    const chatsAgrupados = _.chain(chats).sortBy('dataIni').groupBy('ultimoAgente').value()

    // Agora eu monto todos os agentes com seus respectivos dados
    const agentesMontados = _.filter(agentes, (agente) => agentesNomes.includes(agente.nome))
    agentesMontados.forEach((agente) => {
        const eventosAg = _.groupBy(eventosAgrupados[agente.nome] || [], 'event')
        const pausasAg = (eventosAg['Pause'] || []).filter((pausa) => pausasValidas.includes(pausa.event_data1))
        const registrosIDAg = (registrosAgrupados[agente.nome] || []).map(registro => registro.actionid)

        agente.pausas = _.groupBy(pausasAg || [], 'event_data1')
        agente.logins = eventosAg['Login'] || []
        agente.logoffs = _.chain(eventosAg['Login'] || []).filter((login) => login.deslogou).sortBy('event_end').value()
        agente.loginsDiscador = (eventosAg['Login'] || []).filter((login) => login.queue.includes('DISCADOR'))
        agente.loginsExternos = (eventosAg['Login'] || []).filter((login) => login.queue.includes('EXTERNO'))
        agente.loginsWhatsapp = (eventosAg['Login'] || []).filter((login) => login.queue.includes('Whatsapp'))

        agente.ligacoesDiscador = (registrosAgrupados[agente.nome] || [])
        agente.ligacoesExternas = (ligacoesAgrupadas[agente.nome] || []).filter((ligacao) => !registrosIDAg.includes(ligacao.callid))

        agente.chatsDiscador = (chatsAgrupados[agente.nome] || []).filter((chat) => chat.queue.includes('DISCADOR'))
        agente.chatsExternos = (chatsAgrupados[agente.nome] || []).filter((chat) => !chat.queue.includes('DISCADOR'))
    })

    const csvFileName = `Eventos_${local}.csv`
    const csvFilePathWithData = `Eventos_${local}_${data_dia_sem_hifen}.csv`
    arquivos.eventos = csvFileName
    arquivos.eventosD = csvFilePathWithData

    // Criar o stream do CSV com headers
    const csvStream = format({ headers: true })

    // Criar os streams de escrita dos arquivos CSV
    const fileStreamWithData = fs.createWriteStream(csvFilePathWithData)
    const fileStreamWithoutData = fs.createWriteStream(csvFileName)

    // Pipe o stream do CSV para ambos os arquivos
    csvStream.pipe(fileStreamWithData)
    csvStream.pipe(fileStreamWithoutData)

    agentesMontados.forEach((agente) => {
        if (!agente.logins || agente.logins == 0) return
        csvStream.write({
            FILIAL: local,
            DATA: data_dia,
            "CODIGO VENDEDOR ERP": agente.nome.split('_')[1],
            "LIGACOES MAILING": agente.ligacoesDiscador.length,
            "TEMPO MEDIO FALADO MAILING": SecToTime(returnTempoMedioFalado(agente.ligacoesDiscador)),
            "LIGACOES EXTERNAS": agente.ligacoesExternas.length,
            "TEMPO MEDIO FALADO EXTERNO": SecToTime(returnTempoMedioFalado(agente.ligacoesExternas)),
            "MENSAGENS WHATSAPP FORA DO MAILING": returnQtdMsg(agente.chatsExternos),

            "PRIMEIRO LOGIN": agente.logins && agente.logins.length > 0 ? moment(agente.logins[0].event_start).format('HH:mm:ss') : 'N/A',
            "ULTIMO LOGOFF": agente.logoffs && agente.logoffs.length > 0 ? moment(agente.logoffs[agente.logoffs.length - 1].event_end).format('HH:mm:ss') : 'N/A',
            "QTD LOGIN": agente.logins.length,
            "QTD LOGOFF": agente.logoffs.length,

            "HORA INICIO DISCADOR": agente.loginsDiscador && agente.loginsDiscador.length > 0 ? moment(agente.loginsDiscador[0].event_start).format('HH:mm:ss') : 'N/A',
            "TEMPO NA FILA DISCADOR": agente.loginsDiscador && agente.loginsDiscador.length > 0 ? SecToTime(getTimeInEvent(agente.loginsDiscador)) : 'N/A',
            "HORA INICIO FILA EXTERNA": agente.loginsExternos && agente.loginsExternos.length > 0 ? moment(agente.loginsExternos[0].event_start).format('HH:mm:ss') : 'N/A',
            "TEMPO NA FILA EXTERNA": agente.loginsExternos && agente.loginsExternos.length > 0 ? SecToTime(getTimeInEvent(agente.loginsExternos)) : 'N/A',
            "HORA INICIO FILA WHATSAPP": agente.loginsWhatsapp && agente.loginsWhatsapp.length > 0 ? moment(agente.loginsWhatsapp[0].event_start).format('HH:mm:ss') : 'N/A',
            "TEMPO NA FILA WHATSAPP": agente.loginsWhatsapp && agente.loginsWhatsapp.length > 0 ? SecToTime(getTimeInEvent(agente.loginsWhatsapp)) : 'N/A',

            "LANCHE_MANHA": SecToTime(getTimeInEvent(agente.pausas['LANCHE_MANHA'] || [])),
            "ALMOCO": SecToTime(getTimeInEvent(agente.pausas['ALMOCO'] || [])),
            "LANCHE_TARDE": SecToTime(getTimeInEvent(agente.pausas['LANCHE_TARDE'] || [])),
            "CHECKLIST": SecToTime(getTimeInEvent(agente.pausas['CHECKLIST'] || [])),
            "MATINAL": SecToTime(getTimeInEvent(agente.pausas['MATINAL'] || [])),
            "SOLUCOES_FORA_MESA": SecToTime(getTimeInEvent(agente.pausas['SOLUCOES_FORA_MESA'] || [])),
            "PESSOAL": SecToTime(getTimeInEvent(agente.pausas['PESSOAL'] || [])),
            "FEEDBACK_TREINAMENTO": SecToTime(getTimeInEvent(agente.pausas['FEEDBACK_TREINAMENTO'] || [])),
        })
    })

    csvStream.end()

    return new Promise((resolve, reject) => {
        csvStream.on('end', () => {
            console.log(`EXPORT VIA FTP: Arquivos de eventos gerados com sucesso.`)
            resolve()
        })

        csvStream.on('error', (error) => {
            console.log(`EXPORT VIA FTP: Erro ao gerar arquivos de eventos.`, error)
            reject(error)
        })
    })
}

runExports()