const db = require('../util/db');
const ClienteAtendimento = require('./ClienteAtendimento');
const Classificacao = require('./Classificacao');
const Subclassificacao = require('./Subclassificacao');

class AtendimentoClassificacao extends db.orm.Model { }

AtendimentoClassificacao.table = 'queueChatClassificacao';
AtendimentoClassificacao.fields = {
    id: {
        primary: true,
        type: 'integer',
        updated: false,
        methods: true
    },
    idAtendimento: {
        column: 'queueChatID',
        type: 'integer',
        references: ClienteAtendimento.fields.id,
        updated: false,
        
    },
    agente: {
        type: 'string',
        updated: false,
        methods: true
    },
    idClassificacao: {
        column: 'classificacaoID',
        type: 'integer',
        references: Classificacao.fields.id
    },
    idSubclassificacao: {
        column: 'subClassificacaoID',
        type: 'integer',
        references: Subclassificacao.fields.id
    },
    obs: 'text',
    dataRegistro: 'dateTime'
}

module.exports = AtendimentoClassificacao;