const db = require("../util/db");
const ClienteGrupo = require("./ClienteGrupo");

const request = require("request");
const fs = require("fs");
const log = require("../util/Log");
class Cliente extends db.orm.Model {}

Cliente.downloadImageNew = (url, cliente) => {
  try {
    if (!url) return;
    var dir = `/gravacoes/clientes`;
    var stream = function () {
      fs.mkdirSync(dir, { recursive: true });
      const req = request.get(url).on("response", function (res) {
        if (res.statusCode === 200) {
          req.pipe(fs.createWriteStream(`${dir}/${cliente.id}.jpg`));
        } else {
          console.error(`ERRO AO BAIXAR IMAGEM`, res);
        }
      });
    };
    stream();
    return `${dir}/${cliente.id}.jpg`;
  } catch (error) {
    console.error("ERRRO AO BAIXAR IMAGEM DO WHATS");
  }
};
Cliente.getClienteCall = async (msg) => {
  msg.idCliente = msg.remetente;
  try {
    if (msg.idCliente.length === 11) {
      var num = msg.idCliente.substring(3);
      var cliente = await Cliente.query
        .require(true)
        .first()
        .where(Cliente.where.like({ numero: `%${num}` }))
        .fetch();
      return cliente;
    } else if (msg.idCliente.length === 13) {
      var num = msg.idCliente.substring(5);
      var cliente = await Cliente.query
        .require(true)
        .first()
        .where(Cliente.where.like({ numero: `%${num}` }))
        .fetch();
      return cliente;
    } else {
      var cliente = await Cliente.query
        .require(true)
        .first()
        .where(Cliente.where.like({ numero: `%${msg.idCliente}` }))
        .fetch();
      return cliente;
    }
  } catch (error) {
    var cliente = await Cliente.fetchById(9999999);
    return cliente;
  }
};

Cliente.getClientFromMsg = async (msg) => {
  try {
    const numeroSemDDIeDDD = msg.idCliente.slice(-8); // Pegue os últimos 9 dígitos
    const primeiroDigito = numeroSemDDIeDDD.charAt(0); // Pegue o primeiro dígito
    const ddi = msg.idCliente.slice(0, 2); // Extrai os primeiros 2 dígitos do número
    // Verifique se o número começa com 9 ou 8 e se o cliente não existe na base
    if (
      ddi === "55" &&
      (primeiroDigito === "9" || primeiroDigito === "8") &&
      !(await clienteExiste(msg.idCliente))
    ) {
      const numeroComNoveCompleto = `${msg.idCliente.substring(
        0,
        4
      )}9${numeroSemDDIeDDD}`;

      console.log("NUMERO COM 9 COMPLETO", numeroComNoveCompleto);
      // Não existe um cliente com este número, crie um novo
      const novoCli = await new Cliente({
        numero: numeroComNoveCompleto,
        isBusiness: false,
        nome: msg.nomeCliente,
        idGrupo: msg.idGrupo,
      }).save();
      console.log(novoCli);
      return novoCli;
    } else {
      let cliente = await Cliente.BuscaClientePorNumero(msg.idCliente);
      if (cliente.length > 0) {
        cliente = cliente[0];
        if (msg.idCliente.length - cliente.numero.length == 2) {
          cliente.numero = msg.idCliente.substring(0, 2) + cliente.numero;
          cliente = await new Cliente(cliente).save();
        }
        return cliente;
      } else {
        console.log("NAO ACHAMOS VAMOS CRIAR ");
        const novoCli = await new Cliente({
          numero: msg.idCliente,
          isBusiness: false,
          nome: msg.nomeCliente,
          idGrupo: msg.idGrupo,
        }).save();
        console.log(novoCli);
        return novoCli;
      }
    }
  } catch (error) {
    console.error(error);
  }
};

async function clienteExiste(numero) {
  // Verifique se um cliente com este número já existe na base de dados
  const cliente = await Cliente.BuscaClientePorNumero(numero);
  return cliente.length > 0;
}

/**
 * Retorna o cliente cadasreado na base pelo número contido na msg no atributo idCliente.
 * Se não encontrar cadastra e retorna o que cadastrou.
 */
// Cliente.getClientFromMsg = async (msg) => {
//     //const NumerosAdicionais = require(`./ClienteNumerosAdicionais`);
//     msg.idGrupo = msg.idGrupo ? parseInt(msg.idGrupo) : null;
//     try {
//         // var num = msg.idCliente.substr(-8);
//         // var cliente = await Cliente.query.require(true).first()
//         //     .where(Cliente.where.like({ numero: `%${num}` }))
//         //     .fetch();
//         var cliente = await Cliente.BuscaClientePorNumero(msg.idCliente);
//         if (cliente.length > 0) {
//             cliente = cliente[0];
//             //cliente = await Cliente.query.require(true).first().where({ id: cliente.id }).fetch();
//             if (msg.idCliente.length - cliente.numero.length == 2) cliente.numero = msg.idCliente.substring(0, 2) + cliente.numero
//             cliente = await new Cliente(cliente).save();
//             return cliente;
//         } else {
//             return await new Cliente({ numero: msg.idCliente, isBusiness: false, nome: msg.nomeCliente, idGrupo: msg.idGrupo }).save();
//         }

//     } catch (error) {
//         console.error(error);
//         return await new Cliente({ numero: msg.idCliente, isBusiness: false, nome: msg.nomeCliente, idGrupo: msg.idGrupo }).save();
//     }
// }
Cliente.getClienteByEmail = async (msg) => {
  try {
    const cliente = await Cliente.query
      .require(true)
      .first()
      .where({ email: msg.idCliente })
      .fetch();
    return cliente;
  } catch (error) {
    // if (msg.numero) {
    //     let msgAux = msg;
    //     msgAux.idCliente = msgAux.numero;
    //     return await Cliente.getClientFromMsg(msgAux);
    // }
    return await new Cliente({
      numero: null,
      isBusiness: false,
      nome: msg.name,
      profileImage: null,
      email: msg.idCliente,
    }).save();
  }
};
Cliente.getClienteByFacebookID = async (msg) => {
  try {
    return await Cliente.fetchByFacebookID(msg.idCliente);
  } catch (error) {
    return await new Cliente({
      numero: null,
      isBusiness: false,
      nome: msg.name,
      profileImage: null,
      facebookID: msg.idCliente,
    }).save();
  }
};

Cliente.getClienteByMsg = async (msg) => {
  console.log(`QUEUETYPE`, msg.queueTypeID);
  msg.idCliente = msg.from;
  msg.nomeCliente = msg.name;
  try {
    let cliente = null;
    if (msg.queueTypeID === 4) {
      cliente = await Cliente.getClienteByEmail(msg);
    }
    if (msg.queueTypeID === 8) {
      cliente = await Cliente.getClienteByFacebookID(msg);
    }
    if (!cliente) {
      cliente = await Cliente.getClientFromMsg(msg);
    }
    if (cliente) {
      // if (msg.queueTypeID === 3) {
      //   if (msg.image !== null) {
      //     cliente.profileImage = await Cliente.downloadImageNew(
      //       msg.image,
      //       cliente
      //     );
      //     cliente.save();
      //   }
      // }
      return cliente;
    }
  } catch (err) {
    console.error(err);
  }
};

/**
 * Usa a função find_cliente criada no Postgres para procurar o cliente pelo numero principal ou numero adicional.
 * @param {String} numero
 * @returns Array
 */
Cliente.BuscaClientePorNumero = async (numero) => {
  return await Cliente.query.execute({
    text: "select * from find_cliente($1)",
    values: [numero],
  });
};

Cliente.table = "cliente";
Cliente.fields = {
  id: { type: "integer", primary: true, updated: false, methods: true },
  numero: { type: "string", methods: true },
  isBusiness: "boolean",
  nome: { type: "string" },
  documento: { type: "string" },
  profileImage: "string",
  idGrupo: {
    type: "integer",
    references: ClienteGrupo.fields.id,
  },
  url: { type: `string` },
  email: { type: "string", methods: true },
  facebookID: { type: "string", methods: true },
};

module.exports = Cliente;
