const db = require('../util/db');
const Cliente = require('./Cliente');

class ClienteAtendimento extends db.orm.Model { }

ClienteAtendimento.table = 'queueChat';
ClienteAtendimento.fields = {
    id: { type: 'integer', primary: true, updated: false, methods: true },
    fromID: 'string',
    fromName: 'string',
    sentido: 'string',
    assunto: 'string',
    action: 'string',
    ativo: 'boolean',
    queue: 'string',
    queueFrom: 'string',
    email: 'string',
    dataIni: 'dateTime',
    dataFim: 'dateTime',
    status: 'string',
    ultimoAgente: 'string',
    dadosAdicionais: 'json',
    queueTypeID: 'integer',
    linkedid: 'string',
    newstate: 'boolean',
    idCliente: {
        type: 'integer',
        references: Cliente.fields.id
    },
    qtd_msg: 'integer',
    data_hora_last_msg: 'dateTime',
    qtd_msg_nao_lidas: 'integer',
    count: {
        column: 'qtd_msg_nao_lidas',
        type: 'integer',
    },

}

module.exports = ClienteAtendimento;