const db = require("../util/db");
const Fila = require("./Fila");
const Agente = require("./Agente");

class ListaTransmissao extends db.orm.Model {}

ListaTransmissao.table = "ListaTransmissao";

ListaTransmissao.fields = {
  id: {
    type: "integer",
    primary: true,
    updated: false,
    methods: true,
  },
  nome: "string",
  ativa: "boolean",
  idTemplate: "string",
  texto: "text",
  idAgente: {
    type: "integer",
    references: Agente.fields.id,
  },
  instancia: {
    type: "string",
    references: Fila.fields.name,
  },
  ultimaExecucao: "dateTime",
  status_atendimento: "string",
  agendaData: "dateTime",
  agendaHora: "string",
  agendaDias: "object",
  agendaMesses: "object",
  agendaDiasSemana: "object",
  status: "string",
};

module.exports = ListaTransmissao;
