const db = require('../util/db');
const Agente = require('./Agente');
const Tags = require('./Tags');
const QueueCalls = require('./QueueCalls');

class QueueCallsTags extends db.orm.Model { }

QueueCallsTags.table = "tags_atendimentos";

QueueCallsTags.fields = {
  "id": {
    "type": "integer",
    "primary": true,
    "updated": false,
    "methods": true
  },
  "id_tag": {
    type: "integer",
    references: Tags.fields.id
  },
  "agente": {
    type: "string",
    references: Agente.fields.fullname
  },
  "callid": {
    column: 'id_atendimento',
    type: "string",
    references: QueueCalls.fields.callid
  },
  "tipo_atendimento": { type: "string" },
  "data_registro": "dateTime"
}

QueueCallsTags.options = {
  query: { where: { tipo_atendimento: 'voz' } }
};

module.exports = QueueCallsTags;