
const db = require('../util/db')
const vCliente = require('./vCliente')
const QueueTypes = require('./QueueTypes')
const Fila = require('./Fila')

class QueueChat extends db.orm.Model { }

QueueChat.table = "queueChat"

QueueChat.fields = {
  "id": {
    "type": "integer",
    "primary": true,
    "updated": false,
    "methods": true
  },
  "sentido": "string",
  "fromID": "string",
  "fromName": "string",
  "assunto": "string",
  "action": "string",
  "ativo": "boolean",
  "queue": {
    type: "string",
    references: Fila.fields.name
  },
  "dataIni": "dateTime",
  "dataFim": "dateTime",
  "status": "string",
  "ultimoAgente": "string",
  "clienteConectado": "boolean",
  "dadosAdicionais": "jsonb",
  "email": "string",
  "queueTypeID": {
    type: "integer",
    references: QueueTypes.fields.id
  },
  "idCliente": {
    type: "integer",
    references: vCliente.fields.id
  },
  "queueFrom": "string",
  "newstate": "boolean",
  "linkedid": "string",
  "qtd_msg": "integer",
  "data_hora_last_msg": "dateTime",
  "qtd_msg_nao_lidas": "integer",
  "PaiId": "integer",
  "FromAgente": "string",
  "FromFila": "string",
  "FromMotivo": "string"
}

module.exports = QueueChat;
