const db = require('../util/db');
const Agente = require('./Agente');
const Tags = require('./Tags');
const QueueChat = require('./QueueChat');

class QueueChatTags extends db.orm.Model { }

QueueChatTags.table = "tags_atendimentos";

QueueChatTags.fields = {
  "id": {
    "type": "integer",
    "primary": true,
    "updated": false,
    "methods": true
  },
  "id_tag": {
    type: "integer",
    references: Tags.fields.id
  },
  "agente": {
    type: "string",
    references: Agente.fields.fullname
  },
  "id_atendimento": {
    type: "string",
    references: QueueChat.fields.id
  },
  "tipo_atendimento": { type: "string" },
  "data_registro": "dateTime"
}

QueueChatTags.options = {
  query: { where: { tipo_atendimento: 'texto' } }
};

module.exports = QueueChatTags;