define(["require", "exports", "../planning/metadata", "../constants/metadata_keys", "../constants/error_msgs"], function (require, exports, metadata_1, METADATA_KEY, ERRORS_MSGS) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function postConstruct() {
        return function (target, propertyKey, descriptor) {
            var metadata = new metadata_1.Metadata(METADATA_KEY.POST_CONSTRUCT, propertyKey);
            if (Reflect.hasOwnMetadata(METADATA_KEY.POST_CONSTRUCT, target.constructor)) {
                throw new Error(ERRORS_MSGS.MULTIPLE_POST_CONSTRUCT_METHODS);
            }
            Reflect.defineMetadata(METADATA_KEY.POST_CONSTRUCT, metadata, target.constructor);
        };
    }
    exports.postConstruct = postConstruct;
});
