/// <reference types="socket.io-client" />
declare type cb = (...data: any) => void;
interface options {
    file: File;
    data?: any;
    highWaterMark?: number;
    withStats?: boolean;
}
declare class ClientWeb {
    private socket;
    private eventNamespace;
    private isResume;
    filesize: number;
    private chunks;
    id: string | null;
    private bytesPerChunk;
    file: File;
    data: any;
    isPaused: boolean;
    event: string;
    events: Map<string, cb[]>;
    fileReader: FileReader;
    private withStats;
    private maxWait;
    private isFirst;
    private maxWaitCounter;
    private maxWaitTimer;
    constructor(socket: SocketIOClient.Socket, { file, data, highWaterMark, withStats }: options, eventNamespace?: string);
    private __getId;
    __read(start: number, end: number): void;
    __start(cb: cb): void;
    upload(event: string, cb: cb): this;
    private __maxWaitMonitor;
    private __clearMaxWaitMonitor;
    on(eventName: string, cb: cb): void;
    emit(eventName: string, data?: any): void;
    pause(): void;
    resume(): void;
    stop(): void;
    __destroy(): void;
}
export default ClientWeb;
