'use strict'

// const HapiRouter = {
// 	register: require("hapi-router"),
// 	options: {
// 		routes: "rest_api/**/routes.js"
// 	}
// };

const HapiCors = {
	register: require('hapi-cors'),
	options: {
		// Allow consumption by any host
		origins: ['*'],
		// Allows authentication to be sent by default
		allowCredentials: 'true',
		// These headers can be consumed
		exposeHeaders: ['content-type', 'content-encoding', 'content-length', 'api-version'],
		// These methods are allowed
		methods: ['POST, GET, OPTIONS, DELETE, PUT'],
		// These request headers can be sent
		headers: ['Accept', 'Content-Type', 'Authorization', 'api-version', 'Origin', 'Referer', 'User-Agent']
	}
};

const Swagger = require('./swagger');
const Inert = require('inert');
const Vision = require('vision');

module.exports = [/* HapiRouter ,*/ HapiCors, Inert, Vision, Swagger];
