'use strict'
const Joi = require('joi');

const handlers = require('./handlers');

module.exports = [
  {
    method: 'POST',
    path: '/api/v2/chatUra/',
    handler: handlers.adicionar,
    config: {
      description: 'Alimentao relatorio de ura do tipo chat para a ccr',
      tags: ['api', 'v2', 'FluxoChat'],
      auth: {
        strategy: 'bearer',
        scope: 'user' // or [ 'user', 'admin' ]
      },
      validate: {
        payload: Joi.object({
          menu: Joi.string().required().example('SAP').description('Menu escolhido'),
          opcao: Joi.string().required().description('Opcao escolhida').example('Unlock SAP'),
          id_cliente: Joi.string().allow(null).description('Quem realizou tal fluxo').example('12345'),
          data: Joi.date().required().description('Data').example(new Date()),
          resposta: Joi.string().allow(null).description('Retorno da api').example('Sucesso'),
          descricao: Joi.string().allow(null).description('Caso ocorra falha e nesse campo que a mesma ira ser registrada').example('Usuario nao encontrado')
        })
      }
    }
  }
  // {
  //   method: 'PUT',
  //   path: '/api/v2/chat/{ID}',
  //   handler: (request, reply) => {
  //     const crud = new CRUD('queueChat');
  //     crud.update(request, reply);
  //   },
  //   config: {
  //     description: 'Atualiza um chat pelo ID',
  //     tags: ['api', 'v2', 'Chat'],
  //     auth: {
  //       strategy: 'bearer',
  //       scope: 'user' // or [ 'user', 'admin' ]
  //     },
  //     validate: {
  //       params: {
  //         ID: Joi.number().integer().required().description('ID do Chat(Protocolo)')
  //       },
  //       payload: Joi.object({
  //         fromID: Joi.string().allow(null).description('fromID'),
  //         fromName: Joi.string().allow(null).description('fromName'),
  //         assunto: Joi.string().allow(null).description('Assunto'),
  //         action: Joi.string().allow(null).description('Action'),
  //         ativo: Joi.boolean().allow(null).description('Ativo'),
  //         queue: Joi.string().allow(null).description('Fila'),
  //         dataIni: Joi.date().allow(null).iso().example('2018-01-01 08:00:00').description('Data inicial'),
  //         dataFim: Joi.date().allow(null).iso().example('2018-01-01 23:59:59').description('Data final'),
  //         status: Joi.string().allow(null).description('Status'),
  //         ultimoAgente: Joi.string().allow(null).description('Nome do último agente que atendeu'),
  //         clienteConectado: Joi.boolean().allow(null).description('Cliente conectado'),
  //         dadosAdicionais: Joi.string().allow(null).description('Dados adicionais'),
  //         email: Joi.string().allow(null).description('Email'),
  //         queueTypeID: Joi.number().integer().allow(null).description('1 - Entrante, 2 - Sainte'),
  //       })
  //     }
  //   }
  // },
];
