'use strict'

const joi = require('joi');
const Boom = require('boom');
const db = require('../../../util/db');
//const squel = require("squel");
const ws = require('../../../ws');
const config = require('../../../config.json');
const moment = require('moment-timezone');
moment.tz.setDefault(config.servidor.timezone);

exports.getall = (request, reply) => {
  const max = request.query.max ? request.query.max : 15;
  const page = request.query.page ? request.query.page : 1;
  const pag = new Paginacao(max, page);
  const knex = db.knex('public.classificacoes AS a')
  .leftJoin('public.subclassificacao AS b','b.id_classificacao','a.id');

  if(request.query.nome) knex.whereRaw('LOWER(a.nome) LIKE ?', '%'+decodeURIComponent(request.query.nome).toLowerCase()+'%');
  if(request.query.filas) knex.whereRaw('a.fila::text[] && ARRAY'+JSON.stringify(request.query.filas).replace(/"/g, "'"));

  pag.order = request.query.order;
  pag.knex = knex;

  pag.getRet((ret, err) => {
    if (err) {
      console.log('Erro listando Classificações. Erro = ' + err);
      reply(Boom.badData(err));
    }
    else {
      reply(ret);
    }
  });
};