'use strict'

const md5 = require('md5');
const Boom = require('boom');
const db = require('../../../util/db');
const config = require('../../../config.json');
const moment = require('moment-timezone');
moment.tz.setDefault(config.servidor.timezone);

exports.getLicence = (request, reply) => {
  const knex = db.knex('public.licenciamento');
  knex.select("*").limit(1)
  .then(function(rows) {
    const ret = {};
    ret.error = false;
    ret.full = true;
    ret.total = rows.length;
    ret.message = 'Dados da Licença';
    ret.version = global.xcontact_version;
    ret.dados = rows[0];
    reply(ret);
  })
  .catch(function(error) {
    console.error(error);
    reply(Boom.badData(error));
  });
};
