'use strict'
const CRUD = require('../../../util/CRUD');
const Joi = require('joi');

module.exports = [
  {
    method: 'GET',
    path: '/api/v3/messages/{IDWHATS}',
    handler: (request, reply) => {
      const crud = new CRUD('queueChatMessages AS q');
      crud.knexnest_op = true;
      crud.filtros = [];
      crud.filtrosraw = [];
      crud.filtros.push({ campo: '"mailMessageID"', operador: '=', valor: request.params.IDWHATS });
      crud.leftjoin = [
        { tabela: "queueAnexos AS b", campo1: "q.id", campo2: "b.id_message" }
      ];
      crud.select = [
        'q.id as _id',
        'q.idQueueChat as _idQueueChat',
        'q.dataHora as _dataHora',
        'q.inOut as _inOut',
        'q.agente as _agente',
        'q.texto as _texto',
        'q.repliedIdMsg as _repliedIdMsg',
        'q.status as _status',
        'q.mailMessageID as _mailMessageID',
        'b.id as _queueAnexos__id',
        'b.caminho as _queueAnexos__caminho',
        'b.mimeType as _queueAnexos__mimeType'
      ];
      crud.getAll(request, reply);
    },
    config: {
      description: 'Obtem uma mensagem pelo id do whatsapp',
      tags: ['api', 'v3', 'messages'],
      auth: {
        strategy: 'bearer',
        scope: 'user' // or [ 'user', 'admin' ]
      },
      validate: {
        params: {
          IDWHATS: Joi.string().required()
        }
      }
    }
  },
];
