'use strict'

const Boom = require('boom');
const db = require('../../../util/db');
const config = require('../../../config.json');
const moment = require('moment-timezone');
const namiLib = require("nami");
const nami = require('../../../ami/index');
const pExec = require('child_process');
moment.tz.setDefault(config.servidor.timezone);


// exports.Nami = (data, reply)=>{
//   const ramal = changeFormData(data.payload);
//   //Definição do comando
//   let action = new namiLib.Actions.Command();
//   //Finalmente prepara a escrita e gestão do ramal no Asterisk
//   const knex = db.knex("public.ramais");
//   //Update
//   knex.update(ramal);
//   knex.where("id", data.params.ID)
//   .then(function(idc) {
//     //AMI Commands
//     action.command = "sip prune realtime peer " + ramal.name;
//     //Envio via AMI
//     nami.send(action, null);
//     action.command = "sip show peer " + ramal.name;
//     nami.send(action, null);
//     //Monta o Retorno Padrão
//     const ret = {};
//     ret.error = false;
//     ret.id = idc[0];
//     ret.message = 'Ramal ID = '+idc[0]+' atualizado com sucesso.';
//     reply(ret);
//   })
//   .catch(function(error) {
//     console.error(error);
//     reply(Boom.badData(error));
//   });
// };

exports.getTotalRamais = (data, reply)=>{
  const knex = db.knex("public.ramais");
  knex.count('* as total')
  .then(function(tot) {
    const ret = {};
    ret.error = false;
    ret.total = tot[0].total;
    ret.message = `Encontrados ${ret.total}, ramais.`;
    reply(ret);
  })
  .catch(function(error) {
    console.error(error);
    reply(Boom.badData(error));
  });
};

exports.getTotalAgentes = (data, reply)=>{
  const knex = db.knex("public.agentes");
  knex.count('* as total')
  .then(function(tot) {
    const ret = {};
    ret.error = false;
    ret.total = tot[0].total;
    ret.message = `Encontrados ${ret.total}, agentes.`;
    reply(ret);
  })
  .catch(function(error) {
    console.error(error);
    reply(Boom.badData(error));
  });
};

exports.getTotalSupervisores = (data, reply)=>{
  const knex = db.knex("public.supervisores");
  knex.count('* as total')
  .then(function(tot) {
    const ret = {};
    ret.error = false;
    ret.total = tot[0].total;
    ret.message = `Encontrados ${ret.total}, supervisores.`;
    reply(ret);
  })
  .catch(function(error) {
    console.error(error);
    reply(Boom.badData(error));
  });
};

exports.getStatusAsterisk = (data, reply)=>{
    const ret = {};
    ret.error = false;
    pExec.exec("/bin/ps -ef|/bin/grep '/usr/sbin/asterisk'|/bin/grep -v grep", (err, stdout, stderr) => {
        if (err) {
          ret.error = true;
          ret.dados = [{Asterisk: "FALHA" }];
          ret.message = stderr;
        }
        else
        {
          ret.dados = [{Asterisk: "OK" }];
          ret.message = stdout;
        }
        reply(ret);
    });
};

exports.getStatusXcontact = (data, reply)=>{
  const ret = {};
  ret.error = false;
  pExec("/bin/ps -ef|/bin/grep 'server.php'|/bin/grep -v grep", (err, stdout, stderr) => {
      if (err) {
        ret.error = true;
        ret.dados = [{Xcontact: "FALHA" }];
        ret.message = stderr;
      }
      else
      {
        ret.dados = [{Xcontact: "OK" }];
        ret.message = stdout;
      }
      reply(ret);
  });
};

exports.getStatusBanco = (data, reply)=>{
  const ret = {};
  ret.error = false;
  pExec("/bin/ps -ef|/bin/grep '/usr/bin/postmaster'|/bin/grep -v grep", (err, stdout, stderr) => {
      if (err) {
        ret.error = true;
        ret.dados = [{Banco: "FALHA" }];
        ret.message = stderr;
      }
      else
      {
        ret.dados = [{Banco: "FALHA" }];
        ret.message = stdout;
      }
      reply(ret);
  });
};