'use strict'

//const Joi = require('joi');
const handlers = require('./handlers');
const util = require('../../../util/restbase');

//Conjunto de dados padrão + específico
const ListaReturnSchema = util.CreateReturnSchema(null);

module.exports = [
    {
      method: 'GET',
      path: '/api/v3/monitor/totalramais',
      handler: handlers.getTotalRamais,
      config: {
        description: 'Obtém o total de ramais cadastrados',
        tags: ['api','Monitoramento'],
        auth: {
            strategy: 'bearer',
            scope: [ 'user', 'admin' ]
        },
        response: {
          schema: ListaReturnSchema
        },
      }
    },
    {
      method: 'GET',
      path: '/api/v3/monitor/totalagentes',
      handler: handlers.getTotalAgentes,
      config: {
        description: 'Obtém o total de agentes cadastrados',
        tags: ['api','Monitoramento'],
        auth: {
            strategy: 'bearer',
            scope: [ 'user', 'admin' ]
        },
        response: {
          schema: ListaReturnSchema
        },
      }
    },
    {
      method: 'GET',
      path: '/api/v3/monitor/totalsupervisores',
      handler: handlers.getTotalSupervisores,
      config: {
        description: 'Obtém o total de supervisores cadastrados',
        tags: ['api','Monitoramento'],
        auth: {
            strategy: 'bearer',
            scope: [ 'user', 'admin' ]
        },
        response: {
          schema: ListaReturnSchema
        },
      }
    },
    {
      method: 'GET',
      path: '/api/v3/monitor/statusasterisk',
      handler: handlers.getStatusAsterisk,
      config: {
        description: 'Obtém o status do controlador SIP',
        tags: ['api','Monitoramento'],
        auth: {
            strategy: 'bearer',
            scope: [ 'user', 'admin' ]
        },
        response: {
          schema: ListaReturnSchema
        },
      }
    },
    {
      method: 'GET',
      path: '/api/v3/monitor/statusxcontact',
      handler: handlers.getStatusAsterisk,
      config: {
        description: 'Obtém o status do XContact',
        tags: ['api','Monitoramento'],
        auth: {
            strategy: 'bearer',
            scope: [ 'user', 'admin' ]
        },
        response: {
          schema: ListaReturnSchema
        },
      }
    },
    {
      method: 'GET',
      path: '/api/v3/monitor/statusbanco',
      handler: handlers.getStatusBanco,
      config: {
        description: 'Obtém o status do Banco de Dados',
        tags: ['api','Monitoramento'],
        auth: {
            strategy: 'bearer',
            scope: [ 'user', 'admin' ]
        },
        response: {
          schema: ListaReturnSchema
        },
      }
    },
];