'use strict'
const Joi = require('joi');
const handlers = require('./handlers');

module.exports = [
    {
        method: 'POST',
        path: '/api/v4/2fa',
        handler: handlers.create,
        config: {
            description: 'Cria uma dupla autenticação para o usuário',
            tags: ['api', 'v4', 'Duplo Fator (2fa)'],
            auth: {
                strategy: 'bearer'
            },
            validate: {
                payload: Joi.object({
                    nome: Joi.string().required()
                })
            }
        }
    },
    {
        method: 'GET',
        path: '/api/v4/2fa',
        handler: handlers.getAll,
        config: {
            description: 'Obtem a dupla autenticação do usuário',
            tags: ['api', 'v4', 'Duplo Fator (2fa)'],
            auth: {
                strategy: 'bearer'
            }
        }
    },
    {
        method: 'DELETE',
        path: '/api/v4/2fa',
        handler: handlers.delete,
        config: {
            description: 'Remove a dupla autenticação do usuário',
            tags: ['api', 'v4', 'Duplo Fator (2fa)'],
            auth: {
                strategy: 'bearer'
            }
        }
    }
]