const Boom = require('boom')
const Tags = require('../../../models/Tags')
const TagsAtendimentos = require('../../../models/TagsAtendimentos')
const TagsGrupos = require('../../../models/TagsGrupos')
const TagsGruposAgentes = require('../../../models/TagsGruposAgentes')
const AtendimentoCamposAdicionais = require('../../../models/AtendimentoCamposAdicionais')

exports.removeCampoAdicionalById = async (request, reply) => {
    try {
          const retorno = await AtendimentoCamposAdicionais.query
            .require(true)
            .where({ id: request.params.idCampo })
            .delete();
            reply(retorno)
    } catch (error) {
        console.error(error)
        reply(Boom.badData(error))
    }
}
exports.addCampoAdicionalAtendimento = async (request, reply) => {
   try {
        let ob = await AtendimentoCamposAdicionais.save(request.payload)
        reply(ob)
    } catch (error) {
        console.error(error)
        reply(Boom.badData(error))
    }
}

exports.updateCampoAdicionalAtendimento = async (request, reply)  => {
    try {
        const dados = request.payload
        dados.id = request.params.idCampo
        let ob = await AtendimentoCamposAdicionais.save(dados)
        reply(ob)
    } catch (error) {
        console.error(error)
        reply(Boom.badData(error))
    }
}
exports.getCamposAdicionaisByIdAtendimento = async (request, reply) => {
    try {
        const query = AtendimentoCamposAdicionais.query
        query.where({ id_atendimento: request.params.idAtendimento })
        const registros = await query.require(true).fetch()
        reply(registros)
    } catch (e) {
        reply(Boom.badData(e))
    }
}
