const Joi = require('joi');
const handlers = require('./handlers');

module.exports = [
    {
        method: 'GET',
        path: '/api/v4/audios',
        handler: handlers.getAudioFile,
        config: {
            description: 'Ouviu ou fez download de áudios do sistema',
            tags: ['api', 'Audios'],
            auth: {
                strategy: 'bearer',
                scope: ['app.audios']
            },
            validate: {
                query: {
                    access_token: Joi.string().description('Token'),
                    caminho: Joi.string().required().description('Caminho do arquivo'),
                }
            }
        }
    },
];
