const Boom = require('boom');
const Autocomplete = require('../../../models/Autocomplete');
const Fila = require('../../../models/Fila');

exports.getAll = async function (request, reply) {
    try {
        const query = Autocomplete.query;
        //query.leftJoin(Fila, { fields: ['name'] });
        var registros = await query.require(false).fetch();
        reply(registros);
    } catch (error) {
        reply(Boom.badData(error));
    }
};

exports.getOne = async function (request, reply) {
    try {
        const query = Autocomplete.query;
        query.where({ id: request.params.id });
        //query.leftJoin(Fila, { fields: ['name'] });
        var registros = await query.require(true).fetch();
        reply(registros[0]);
    } catch (error) {
        reply(Boom.badData(error));
    }
};

exports.update = async (request, reply) => {
    try {
        let dados = request.payload;
        dados.id = request.params.id;
        let ret = await Autocomplete.update(dados);
        reply(ret);
    } catch (error) {
        reply(Boom.badData(error));
    }
}

exports.create = async (request, reply) => {
    try {
        let ret = await Autocomplete.save(request.payload);
        reply(ret);
    } catch (error) {
        reply(Boom.badData(error));
    }
}

exports.delete = async (request, reply) => {
    try {
        const query = Autocomplete.query;
        query.where({ id: request.params.id });
        var registros = await query.require(true).delete();
        reply(registros);
    } catch (e) {
        reply(Boom.badData(e));
    }
};