const Boom = require('boom');
const RotaGrupo = require('../../../models/RotaGrupo');
const Ami = require('../../../ami');

exports.getAll = async function (request, reply) {
    try {
        const query = RotaGrupo.query;
        query.fields(['id', 'nome', 'descricao', 'sentido']);
        //query.leftJoin(Fila, { fields: ['name'] });
        var registros = await query.require(false).fetch();
        reply(registros);
    } catch (error) {
        reply(Boom.badData(error));
    }
};

exports.getOne = async function (request, reply) {
    try {
        const query = RotaGrupo.query;
        query.fields(['id', 'nome', 'descricao', 'sentido']);
        query.where({ id: request.params.id });
        //query.leftJoin(Fila, { fields: ['name'] });
        var registros = await query.require(true).fetch();
        reply(registros[0]);
    } catch (error) {
        reply(Boom.badData(error));
    }
};

exports.update = async (request, reply) => {
    try {
        let dados = request.payload;
        dados.id = request.params.id;
        let ret = await RotaGrupo.update(dados);
        reply(ret);
    } catch (error) {
        reply(Boom.badData(error));
    }
}

exports.create = async (request, reply) => {
    try {
        let ret = await RotaGrupo.save(request.payload);
        await Ami.criaContextoConfig(request.payload.nome);
        reply(ret);
    } catch (error) {
        reply(Boom.badData(error));
    }
}

exports.delete = async (request, reply) => {
    try {
        const query = RotaGrupo.query;
        query.where({ id: request.params.id });
        var registros = await query.require(true).delete();
        await Ami.updateConfig({
            arquivo: 'extensions_custom.conf',
            categoria: registros[0].nome,
            acao: 'DelCat',
            reload: 'pbx_config.so'
        })
        reply(registros);
    } catch (e) {
        reply(Boom.badData(e));
    }
};