const Joi = require('joi');
const handlers = require('./handlers');

module.exports = [
    {
        method: 'GET',
        path: '/api/v4/logs',
        handler: handlers.getAll,
        config: {
            description: 'Retorna os Logs de acesso',
            tags: ['api', 'Logs'],
            auth: {
                strategy: 'bearer',
                scope: ['app.log']
            },
            validate: {
                query: {
                    usuarios: Joi.array().allow(null).items(Joi.string()).description('Filtra pelo nome de usuários'),
                    data_ini: Joi.date().raw().optional().allow(null).description('Data inicial'),
                    data_fim: Joi.date().raw().optional().allow(null).description('Data Final'),
                    hora_ini: Joi.string().optional().allow(null).description('Hora inicial'),
                    hora_fim: Joi.string().optional().allow(null).description('Hora final')
                }
            }
        }
    },
];
