const { number } = require('joi');
const Joi = require('joi');
const handlers = require('./handlers');

module.exports = [
    {
        method: 'POST',
        path: '/api/v4/login/supervisor',
        handler: handlers.getSupervisor,
        config: {
            description: 'Valida o login de um supervisor',
            tags: ['api', 'v4', 'Login'],
            validate: {
                payload: Joi.object({
                    nome: Joi.string().required().example('admin').description('Nome para login'),
                    senha: Joi.string().example('123456').description('Senha para login'),
                    session_id: Joi.string().optional().allow(['', null]).description('ID da sessão'),
                    duplo_fator: Joi.string().optional().allow(['', null]).description('2fa')
                })
            }
        }
    },
    {
        method: 'PUT',
        path: '/api/v4/logoff/supervisor/{id}',
        handler: handlers.logOff,
        config: {
            description: 'Efetua logoff um supervisor',
            tags: ['api', 'v4', 'Login'],
            auth: {
                strategy: 'bearer',
                scope: 'user' // or [ 'user', 'admin' ]
            },
            validate: {
                params: {
                    id: Joi.number().integer().required()
                },
            }
        }
    }
];
