const Boom = require('boom');
const Modulos = require('../../../models/Modulos');

exports.getAll = async (request, reply) => {
    try {
        let modulos = await Modulos.fetch();

        const parents = modulos.filter(pa => pa.parent == null).slice(0)
            .sort((a, b) => {
                return a.ordem > b.ordem ? 1 : -1
            });;
        const childrens = modulos.filter(pa => pa.parent != null).slice(0)
            .sort((a, b) => {
                return a.ordem > b.ordem ? 1 : -1
            });;

        const ordemm = parents.concat(childrens);

        const nest = (items, id = null, link = 'parent') =>
            items
                .filter(item => item[link] === id)
                .map(item => ({ ...item, modulos: nest(items, item.id) }));

        reply(nest(ordemm));
    } catch (e) {
        reply(Boom.badData(e));
    }
};