'use strict'
const Joi = require('joi');
const handlers = require('./handlers');

module.exports = [
    {
        method: 'GET',
        path: '/api/v4/pausas',
        handler: handlers.getAll,
        config: {
            description: 'Obtem as pausas',
            tags: ['api', 'Pausas'],
            auth: {
                strategy: 'bearer',
                scope: ['client', 'app.pausas']
            },
            validate: {
                query: {
                    filas: Joi.array().items(Joi.string()).example(['FilaA', 'FilaB']).optional().allow(null).description('Filtra por uma ou mais filas'),
                }
            }
        }
    },
]