const Boom = require('boom');
const UraFluxo = require('../../../models/UraFluxo');

exports.create = async (request, reply) => {
    try {
        reply(await new UraFluxo(request.payload).save());
    } catch (error) {
        reply(Boom.badData(error));
    }
};

exports.getAll = async (request, reply) => {
    try {
        const query = UraFluxo.query;
        const dataini = request.query.data_ini ? request.query.data_ini : new Date().toDateString();
        const datafim = request.query.data_fim ? request.query.data_fim : new Date().toDateString();
        query.where(query.sql('calldate::date BETWEEN $1 AND $2', [dataini, datafim]));
        if (request.query.hora_ini) query.where(query.sql('calldate::time >= $1', [request.query.hora_ini]));
        if (request.query.hora_fim) query.where(query.sql('calldate::time <= $1', [request.query.hora_fim]));

        var registros = await query.require(false).fetch();
        reply(registros);

    } catch (error) {
        reply(Boom.badData(error));
    }
};