'use strict'
const handlers = require('./handlers');

module.exports = [
  {
    method: 'GET',
    path: '/api/v2/checkforupdate',
    handler: handlers.checkForUpdate,
    config: {
      description: 'Verifica se ha atualização disponível',
      tags: ['api', 'v2', 'Versão'],
      auth: {
        strategy: 'bearer',
        scope: 'user' // or [ 'user', 'admin' ]
      }
    }
  },
  {
    method: 'PUT',
    path: '/api/v2/update',
    handler: handlers.update,
    config: {
      description: 'Atualiza o Xcontact e suas dependências para última versão',
      tags: ['api', 'v2', 'Versão'],
      auth: {
        strategy: 'bearer',
        scope: 'user' // or [ 'user', 'admin' ]
      }
    }
  },

];
