'use strict'
const Joi = require('joi');
const handlers = require('./handlers');


module.exports = [
    {
        method: 'POST',
        path: '/api/v2/zenvia/send',
        handler: () => { },
        config: {
            description: 'Apenas envia uma mensagem de Texto via WhatsApp para um destino, não cria atendimento.',
            tags: ['api', 'v2', 'Zenvia'],
            auth: {
                strategy: 'bearer',
                scope: 'user' // or [ 'user', 'admin' ]
            },
            validate: {
                payload: {
                    fila: Joi.string().required().description('Nome da fila do Xcontact vinculada a conta de WhatsApp').example('FilaA'),
                    destino: Joi.string().required().description('Número de destino no formato COD_PAIS COD_REGIAO NUMERO. Ex: 555130305501').example('555130305501'),
                    mensagem: Joi.string().required().description('Mensagem').example('Oi Xcontact'),
                }
            }
        }
    },
    {
        method: 'GET',
        path: '/api/v2/zenvia/getTemplates/{Fila}',
        handler: handlers.getTemplates,
        config: {
            description: 'Pega os templates zenvia',
            tags: ['api', 'v2', 'Zenvia'],
            auth: {
                strategy: 'bearer',
                scope: 'user' // or [ 'user', 'admin' ]
            },
            validate: {
                params: {
                    Fila: Joi.string().required().description('Nome da fila')
                }
            }
        }
    }

];
