const db = require('./util/db')
const _ = require('underscore')

const sqlChats = `select json_agg(chats) as chats FROM
(SELECT 
  a.*,
  ( 
    SELECT json_agg(item)
    FROM (
      SELECT b.*
      FROM cliente b where id = a."idCliente"
    ) item
  ) AS cliente,
  ( 
    SELECT json_agg(item)
    FROM (
      SELECT b.agente,b.obs,c.*
      FROM "queueChatClassificacao" b 
	  INNER JOIN "classificacoes" c on b."classificacaoID" = c.id
	  where b."queueChatID" = a.id	  
    ) item
  ) AS classificacao,
  ( 
    SELECT json_agg(item)
    FROM (
      SELECT m.*,
	  ( 
		SELECT json_agg(item)
		FROM (
		  SELECT an.*
		  FROM "queueAnexos" an
		  where an."id_message" = m.id	  
		) item
	  ) AS anexos
      FROM "queueChatMessages" m
	  where m."idQueueChat" = a.id
	  ORDER BY m."dataHora" ASC
    ) item
  ) AS mensagens
FROM "queueChat" a 
WHERE a."ultimoAgente" = $1
) as chats`

const sqlCalls = `select json_agg(calls) as calls FROM
(SELECT 
  a.*,a."calldate" as "data_hora_last_msg", 1 as "queueTypeID",
  ( 
    SELECT json_agg(item)
    FROM (
      SELECT b.*
      FROM cliente b where b.id = a."idCliente"
    ) item
  ) AS cliente,
  ( 
    SELECT json_agg(item)
    FROM (
      SELECT b."data",b.obs,b.protocolo,c.*
      FROM "cdr_classificacoes" b 
	  INNER JOIN "classificacoes" c on b."id_classificacao" = c.id
	  where b."uniqueid" = a."callid"	  
    ) item
  ) AS classificacao
FROM "queue_calls" a 
WHERE a."agent" = $1
) as calls`


async function exec() {
    const retChats = await db.query(sqlChats, ['Teste'])
    const retCall = await db.query(sqlCalls, ['Teste'])

    const ret = _.union(retChats.rows[0].chats, retCall.rows[0].calls)

    const ret2 = _.chain(ret)
            .groupBy('idCliente')
            .sortBy('data_hora_last_msg')
            .map((clientes) => {
                let ob = clientes[0].cliente ? clientes[0].cliente[0] : {naocliente: true}
                let atendimentos = clientes.map(at => {
                    const { cliente, ...dados } = at
                    return dados
                })
                ob.data_hora_last_msg = atendimentos.reduce((a, b) => (new Date(a.data_hora_last_msg).getTime() > new Date(b.data_hora_last_msg).getTime() ? a : b)).data_hora_last_msg;
                
                ob.atendimentos = _.groupBy(atendimentos, 'queueTypeID')
                return ob
            })
            .reverse()
            .value()

        console.log(JSON.stringify(ret2, null, 2));
}

exec()