// Imports
const log = require("../util/Log");
const ws = require("../ws");
const Agente = require("../models/Agente");
class Timer {
    constructor() {
        this.timers = [];
        this.timersEnded = [];
    }
    removeTimerAgente(agente) {
        let index = this.timers.findIndex(a => a.fullname === agente.fullname);
        if (index !== -1) {
            clearTimeout(this.timers[index].timer);
            this.timers[index].timer = null;
            let t = this.timers.splice(index, 1);
            this.timersEnded.push(t[0]);
        }
    }
    pauseTimerAgente(agente) {
        let index = this.timers.findIndex(a => a.fullname === agente.fullname);
        if (index !== -1) {
            let agente = this.timers[index];
            //Vamos limpar o interval;
            clearTimeout(agente.timer);
            agente.remainingTime = agente.remainingTime - (new Date() - agente.startTime);
            agente.pauseTimer = true;
            console.log(`AINDA TEMOS `, agente.remainingTime);
        }
    }
    resumeTimerAgente(agente) {
        let index = this.timers.findIndex(a => a.fullname === agente.fullname);
        if (index !== -1) {
            let agente = this.timers[index];
            if (!agente.pauseTimer) return;
            console.log(`ESTAVA EM PAUsa`);
            //Vamos limpar o interval;
            agente.timer = setTimeout(() => {
                //Aqui vamos fechar o client
                ws.broadcastEvent(`deslogarAgente`, agente);
                this.removeTimerAgente(agente);
            }, agente.remainingTime);
            agente.pauseTimer = false;

        }
    }
    initTimerAgente(agente) {
        //Vamos transformar as horas em ms
        let tempoAux = agente.tempo_maximo_sessao * 3600000;
        let timer = setTimeout(() => {
            //Aqui vamos fechar o client
            ws.broadcastEvent(`deslogarAgente`, agente);
            this.removeTimerAgente(agente);
        }, tempoAux);
        agente.startTime = new Date();
        agente.remainingTime = tempoAux;
        agente.timer = timer;
        agente.pauseTimer = false;
        this.timers.push(agente);
    }
    verficaTimerAgente = async (agente, event) => {
        try {
            const AGENTE = await Agente.query.require(false).first().where({ fullname: agente.fullname }).fetch();
            if (!AGENTE || !AGENTE.tempo_maximo_sessao) return;
            let findIndex = this.timersEnded.findIndex(a => a.fullname === AGENTE.fullname);
            if (findIndex !== -1) return true;
            let index = this.timers.findIndex(a => a.fullname === AGENTE.fullname);
            if (event === `login`) {
                if (index !== -1) this.resumeTimerAgente(AGENTE);
                if (index === -1) this.initTimerAgente(AGENTE);
            }
            if (event === `deslogou`) {
                this.pauseTimerAgente(agente);
            }
        } catch (error) {
            console.error(error);
        }

    }
    changeTimerProd = async (agente) => {
        try {
            const AGENTE = await Agente.query.require(false).first().where({ fullname: agente.fullname }).fetch();
            if (!AGENTE || !AGENTE.tempo_maximo_sessao) return;
            let timer = this.timers.find(a => a.fullname === AGENTE.fullname);
            if (!timer) {
                let index = this.timersEnded.findIndex(a => a.fullname === AGENTE.fullname);
                if (index !== -1)
                    this.timersEnded.splice(index, 1);
                return;
            }
            clearTimeout(timer.timer);
            let tempoAux = AGENTE.tempo_maximo_sessao * 3600000;
            timer.remainingTime = tempoAux;
            timer.pauseTimer = false;
            timer.startTime = new Date();
            timer.timer = setTimeout(() => {
                //Aqui vamos fechar o client
                ws.broadcastEvent(`deslogarAgente`, agente);
                this.removeTimerAgente(agente);
            }, tempoAux);;

        } catch (error) {
            console.error(error);
        }
    }
}
const singletonInstance = new Timer();
module.exports = singletonInstance;

