const moment = require('moment')
const EventEmitter = require('events');
class MyEmitter extends EventEmitter { }
const eventos = new MyEmitter();

exports.Log = class Log {    
    static levelDebug = 5
    static levelInfo = 4
    static levelLog = 3
    static levelWarn = 2    
    static levelError = 1

    constructor(modulo, level) {
        this.modulo = modulo || 'xcontact-server'
        this.level = level || Log.levelError
    }
    setLevel(level) {
        this.level = level
        eventos.emit('log', `[setLevel] Level de log auterado para ${level}`)
    }
    warn(msg, ...args) {
        if(this.level >= Log.levelWarn) {
            const msgLog = `${moment().format('DD-MM-YYYY HH:mm:ss.SSS')} [${this.modulo}] - ${msg}`
            console.log(msgLog, ...args)
            eventos.emit('log', `[warn] ${msgLog}`)
        }        
    }
    error(msg, ...args) {
        if(this.level >= Log.levelError) {
            const msgLog = `${moment().format('DD-MM-YYYY HH:mm:ss.SSS')} [${this.modulo}] - ${msg}`
            console.log(msgLog, ...args)
            eventos.emit('log', `[error] ${msgLog}`)
        }
    }
    info(msg, ...args) {
        if(this.level >= Log.levelInfo) {
            const msgLog = `${moment().format('DD-MM-YYYY HH:mm:ss.SSS')} [${this.modulo}] - ${msg}`
            console.log(msgLog, ...args)
            eventos.emit('log', `[info] ${msgLog}`)
        }
    }
    debug(msg, ...args) {
        if(this.level >= Log.levelDebug) {
            const msgLog = `${moment().format('DD-MM-YYYY HH:mm:ss.SSS')} [${this.modulo}] - ${msg}`
            console.log(msgLog, ...args)
            eventos.emit('log', `[debug] ${msgLog}`)
        }
    }
    log(msg, ...args) {
        if(this.level >= Log.levelLog) {
            const msgLog = `${moment().format('DD-MM-YYYY HH:mm:ss.SSS')} [${this.modulo}] - ${msg}`
            console.log(msgLog, ...args)
            eventos.emit('log', `[log] ${msgLog}`)
        }
    }
}

exports.LogEventos = eventos