'use strict'
const config = require('../config.json');
const db = require('../util/db');
const log = require('simple-node-logger').createSimpleLogger(config.log_ops);
log.setLevel(config.log ? config.log : 'error');
const Ami = require('../ami/index');
const Cliente = require('../models/Cliente');
const ClienteGrupo = require('../models/ClienteGrupo');
const ClienteAtendimento = require('../models/ClienteAtendimento');
const AtendimentoMensagem = require('../models/AtendimentoMensagem');
const MensagemAnexos = require('../models/MensagemAnexos');
const Agente = require('../models/Agente');
const Pesquisa = require('../models/Pesquisa');
const PesquisaNota = require('../models/PesquisaNota');
const moment = require('moment');
const Turnos = require('../models/Turno');
const ws = require('../ws/index');
const preAtendimento = require('../bots/preAtendimento/index');
const Interconexoes = require('../models/Interconexoes');
const QueueInterconexoes = require('../models/QueueInterconexoes');
module.exports = class Omni {
    constructor() {
        this.aux = [];
    }
    async AutoReply(socket, email, fila, tipo, trocas, xcontactID, protocolo, atendimento) {
        try {
            log.info(`Buscando AutoReply NO Omni tipo ${tipo} para fila ${fila} `);
            var Query = await db.query('SELECT texto FROM public."queueRespostasAutomaticas" where fila = $1 AND "idRespostaTipo" = $2', [fila, tipo]);
            if (Query.rowCount > 0) {
                log.info(` AutoReply do tipo ${tipo} ENCONTRADO ${Query.rows[0].texto}`);
                var texto = Query.rows[0].texto;
                if (typeof trocas === 'object') {
                    Object.entries(trocas).forEach(([key, value]) => {
                        //console.log('Trocando '+key+' por '+value+' no Texto, se tiver...');                    
                        texto = texto.split(key).join(value);
                    });
                }
                log.info(xcontactID);
                log.info(protocolo);
                socket.emit('message', JSON.stringify({ queue: fila, email: email, resposta: texto, xcontactID: xcontactID, protocolo: protocolo, event: 'QueueSemAgentes' }));
                this.saveMsg({ idAtendimento: atendimento.id, texto: Query.rows[0].texto, inOut: 3, agente: 'Xcontact', mailMessageID: 'Xcontact' }, null);

            } else {
                log.info(`AutoReply do tipo ${tipo} NAO ENCONTRADO`);
            }
        } catch (e) {
            log.error(e);
        }
    }

    async AutoReplyWhats(socket, remetente, filaAtendimento, tipo, trocas, filaRedir, atendimento) {
        try {
            const fila = filaRedir ? filaRedir : filaAtendimento;
            log.info(`Buscando AutoReply Whats tipo ${tipo} para fila ${filaAtendimento}, redirecionada por  ${fila}`);
            var Query = await db.query('SELECT texto FROM public."queueRespostasAutomaticas" where fila = $1 AND "idRespostaTipo" = $2', [filaAtendimento, tipo]);
            if (Query.rowCount > 0) {
                var texto = Query.rows[0].texto;
                if (typeof trocas === 'object') {
                    Object.entries(trocas).forEach(([key, value]) => {
                        //console.log('Trocando '+key+' por '+value+' no Texto, se tiver...');                    
                        texto = texto.split(key).join(value);
                    });
                }
                socket.emit('newWhatsMsg', { instanceID: fila, chatId: remetente, msg: texto }, (retorno) => {
                    log.info(`AutoReply Whats para ${remetente} retornou:`);
                    log.info(retorno);
                    this.saveMsg({ idAtendimento: atendimento.id, texto: texto, inOut: 3, agente: 'Xcontact', mailMessageID: 'Xcontact' }, null);
                });

            }
        } catch (e) {
            log.error(e);
        }
    }

    async AddAguardando(fila, atendimento) {
        console.log('AddAguardando no Ommi');
        if (!fila.Aguardando) fila.Aguardando = [];
        fila.Aguardando = await fila.Aguardando.filter((a) => {
            if (atendimento.id !== a.id) {
                return a
            }
        })
        fila.Aguardando.push(atendimento);
    }
    async getInterconexaoTypeWatsonByQueue(fila) {
        var queueInter = await QueueInterconexoes.query.require(false)
            .where({ queue: fila })
            .fetch();
        if (queueInter && queueInter.length > 0) {
            var intercon = [];
            for (let i = 0; i < queueInter.length; i++) {
                var aux = await Interconexoes.fetchById(queueInter[i].idInterconexao);
                if (aux.tipo === 'watson') intercon.push(aux);
            }
            if (intercon.length > 0) {
                console.log('TEMOS CONFIG §§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§')
                return intercon[0];
            } else {
                return undefined;
            }

        } else {
            return undefined
        }

    }

    async AddAguardandoOld(fila, atendimento) {
        console.log('AddAguardando no Ommi');
        if (!fila.Aguardando) fila.Aguardando = [];
        // atendimento.posicao = fila.Aguardando.length + 1;
        var pesquisa = await fila.Aguardando.filter((a) => {

            if (atendimento.id === a.id) {
                return a
            }
        })
        if (pesquisa.length === 0) {
            console.log('=====================*************************8*8 Add no AddAguardando')
            fila.Aguardando.push(atendimento);
            console.log(fila.Aguardando);
        }
        // for (let i = 0; i < fila.Aguardando.length; i++) {
        //     if (fila.Aguardando[i].id === atendimento.id) {
        //         console.log('Não add AddAguardando')
        //         return // caso ja esteja na fila n vamos por na fila
        //     }
        // }

        //fila.Aguardando.push(atendimento);
        console.log(fila.Aguardando);
    }

    async RemoveAguardando(fila, atendimento) {
        if (!fila.Aguardando) fila.Aguardando = [];
        // atendimento.posicao = fila.Aguardando.length + 1;
        // var pesquisa = await fila.Aguardando.filter((a, i) => {

        //     if (atendimento.id === a.id) {
        //         return i
        //     }
        // })
        var pesquisa = fila.Aguardando.findIndex((a) => {
            if (atendimento.id === a.id) {
                console.log('OLHA AQUI O ATENDIMENTO NO AGUARDANDO')
                return a
            }
        });
        if (pesquisa !== -1) {
            console.log('ACHAMOS O INDEX DO MEDONHO 8888888888888888888888888888888888888');
            fila.Aguardando.splice(pesquisa, 1);
        }

    }

    async PauseOmni(dados) {
        Ami.QueuePause(dados);
    }
    async UnpauseOmni(dados) {
        Ami.QueueUnpause(dados);
    }
    async validaHorario(filaTurnos) {
        console.log('TEMOS TURNOS NESTA FILA');
        console.log(filaTurnos);
        var verificaHorario = false;
        for (let i = 0; i < filaTurnos.length; i++) {
            console.log('TURNO ID');
            console.log(filaTurnos[i].TurnoID);
            var turnos = await Turnos.fetchById(filaTurnos[i].TurnoID);
            var date = moment();
            var mes = date.format('MMM');
            var diaNum = date.format('DD');
            var diaSemana = date.format('ddd');
            var hora = date.format('HH:mm:ss');
            hora = hora.replace(':', '');
            hora = parseInt(hora);

            console.log(mes);
            console.log(hora);
            console.log(diaSemana);
            console.log(diaNum);
            if (turnos) {
                console.log(turnos);
                var t = turnos;
                if (t.diasSemana && t.diasSemana.length > 0) {
                    var aux = t.diasSemana.indexOf(diaSemana);
                    if (aux !== -1) {
                        var horaI = t.horaIni.replace(':', '');
                        var horaF = t.horaFim.replace(':', '');
                        horaI = parseInt(horaI);
                        horaF = parseInt(horaF);
                        console.log(hora);
                        console.log(horaI);
                        console.log(horaF);
                        if (hora >= horaI && hora <= horaF) {
                            verificaHorario = true;
                        }
                    }
                }

                if (t.meses && t.meses.length > 0) { // VERIFICANDO SE TEM ALGUM MES CUJO NAO HA TURNOS NA BASE
                    var aux = t.meses.indexOf(mes);
                    if (aux !== -1) {
                        log.info('NAO VAI SER DISTRIBUIDO POIS O MES E IGUAL DO CADASTRADO NOS TURNOS');
                        verificaHorario = false; // CASO TENHA DIA ESPECIFICO E NAO ESTEJA VAMOS RETORNAR FALSO
                    }
                }
                if (t.dias && t.dias.length > 0) {
                    // VERIFICANDO SE TEM ALGUM DIA NA BASE
                    var aux = t.dias.indexOf(diaNum);
                    if (aux !== -1) {
                        verificaHorario = false;
                    }
                    // var aux = [];
                    // aux = await t.dias.filter((d) => {
                    //     if (parseInt(d) === parseInt(diaNum)) {
                    //         return d;
                    //     }
                    // });
                    // if (aux.length > 0) {
                    //     console.log('PELO JEITO ESTAMOS NO DIA DO TURNO ESPECIAL')
                    //     var horaI = t.horaIni.replace(':', '');
                    //     var horaF = t.horaFim.replace(':', '');
                    //     horaI = parseInt(horaI);
                    //     horaF = parseInt(horaF);
                    //     console.log('HORAS DO DIA ESPECIAL');
                    //     console.log('ATUAL', hora);
                    //     console.log('INICIAL T', horaI);
                    //     console.log('FINAL T', horaF);
                    //     if (hora >= horaI && hora <= horaF) {
                    //         verificaHorario = true;
                    //     } else {
                    //         log.info('NAO ESTA ENTRE OS HORARIOS DO DIA')
                    //         verificaHorario = false;
                    //     }
                    // }
                }
            }
        }

        return verificaHorario;
    }

    async ProcessPesquisa(socket, dados) {
        var fila = Ami.getFila(dados.fila);
        if (fila.id_pesquisa && fila.id_pesquisa > 0) {
            // Pega a pesquisa
            var pesquisa = await Pesquisa.fetchById(fila.id_pesquisa);
            // Muda status do atendimento para Pesquisa
            var atendimento = await new ClienteAtendimento({ id: dados.atendimento, status: 'Pesquisa' }).save();
            // Envia msg de pesquisa
            socket.emit('newWhatsMsg', { instanceID: dados.fila, chatId: dados.destinatario, msg: pesquisa.descricao }, (retorno) => {
                log.info(`Envio de pesquisa para ${dados.destinatario} retornou:`);
                log.info(retorno);
            });
        }
    }

    atualizaStatusFila(fila) {
        // atualiza a filas para o painel online!
        const FilasStatus = { event: 'FilasStatus' };
        FilasStatus.filas = [];
        FilasStatus.filas.push(fila);
        ws.broadcast(FilasStatus);
    }

    async verificaClienteGrupo(agente) {
        try {
            var clienteGrupo = await ClienteGrupo.query
                .where({ rota: agente.nome })
                .fetch();
            console.log('#################', clienteGrupo[0].id)

            return parseInt(clienteGrupo[0].id);
        } catch (error) {
            console.log(error);
            console.log("PARECE QUE NAO TEMOS NENHUM GRUPO AINDA PARA ESTE AGENTE VAMOS CRIAR");
            var clienteGrupo = await new ClienteGrupo({ nome: `Grupo de clientes do ${agente.nome}`, rota: agente.nome }).save();
            console.log('#################', clienteGrupo.id)
            return parseInt(clienteGrupo.id);
        }

    }

    async processaUltimoAgente(atendimento, msg, xcMsg, file) {
        if (!msg.body) msg.body = msg.message;
        if (atendimento.ultimoAgente && atendimento.ultimoAgente !== null) {
            var socketAgente = ws.getSocketAgenteByFullName(atendimento.ultimoAgente);
            if (socketAgente) {
                log.info(`Quem bom!! O agente ${atendimento.ultimoAgente} tá onLine se vai seguir tratando as msg do cliente ${msg.idCliente}`);
                // Salvando Msg ja com agente
                var m = await this.saveMsg({ idAtendimento: atendimento.id, texto: msg.body, agente: atendimento.ultimoAgente, inOut: 1 }, file);
                xcMsg.mensagemID = m.id;
                msg.messageID = m.id;
                msg.agente = atendimento.ultimoAgente;
                xcMsg.agente = atendimento.ultimoAgente;
                if (atendimento.queueTypeID == 2) {
                    console.log(xcMsg);
                    socketAgente.emit('message', JSON.stringify(msg));
                } else {
                    socketAgente.emit('message', JSON.stringify(xcMsg.X5Clientv1Format()));
                }
                return true;
            } else {
                return true;
            }
        }
        return false

    }
    async processaSemAgentes(socket, cliente, atendimento, msg, Ativo, xcMsg, fila, FilasStatus, file) {
        if (!msg.body) msg.body = msg.message;
        if ((!fila.agentes || fila.agentes.length === 0) && !Ativo) {
            log.info(`Não temos agentes da fila ${fila.nome}`);
            // Salva Msg sem agente..
            var m = await this.saveMsg({ idAtendimento: atendimento.id, texto: msg.body, inOut: 1, agente: null }, file);
            // Add Atendimento nos aguardando
            if (!fila.Aguardando) fila.Aguardando = [];
            this.AddAguardando(fila, atendimento);
            FilasStatus.filas = [];
            FilasStatus.filas.push(fila);
            ws.broadcast(FilasStatus);
            if (atendimento.queueTypeID == 2) {
                this.AutoReply(socket, cliente.email, fila.nome, 1, undefined, msg.xcontactID, xcMsg.protocolo, atendimento);

            } else {
                this.AutoReplyWhats(socket, msg.idCliente, fila.nome, 1, undefined, msg.instanceID, atendimento);
            }

            return true
        }
        return false

    }

    async processaAguardando(atendimento, msg, xcMsg, Ativo, fila, socket, filaTurnos, file, ft, cliente, FilasStatus) {
        if (!msg.body) msg.body = msg.message;
        if (fila.Aguardando && fila.Aguardando.length > 0) {
            if (filaTurnos && filaTurnos.length > 0) {
                var verificaHorario = await this.validaHorario(filaTurnos);
                if (!verificaHorario) {
                    log.info('NAO PASSOU NA VERIFICACAO DE HORARIOS');
                    this.RemoveAguardando(fila, atendimento);
                    // await this.AddAguardando(fila, atendimento);
                    var m = await this.saveMsg({ idAtendimento: atendimento.id, texto: msg.body, inOut: 1, agente: null }, file);
                    await new ClienteAtendimento({ id: xcMsg.protocolo, status: 'Encerrado', dataFim: new Date(moment.tz(config.servidor.timezone)) }).save({ require: false });
                    if (atendimento.queueTypeID == 2) {
                        this.AutoReply(socket, cliente.email, fila.nome, 5, { "$NOME_CLIENTE": cliente.nome }, msg.xcontactID, xcMsg.protocolo, atendimento);
                    } else {
                        this.AutoReplyWhats(socket, msg.idCliente, fila.nome, 5, { "$NOME_CLIENTE": cliente.nome }, msg.instanceID, atendimento);

                    }
                    return true
                }
            }
            log.info('TEM FILA AGUARDANDO', fila.Aguardando.length);
            await this.AddAguardando(fila, atendimento);
            FilasStatus.filas = [];
            FilasStatus.filas.push(fila);
            ws.broadcast(FilasStatus);
            var p = fila.Aguardando.findIndex((at) => {
                return at.id == atendimento.id;
            });
            var m = await this.saveMsg({ idAtendimento: atendimento.id, texto: msg.body, inOut: 1, agente: null }, file);
            if (p !== undefined) {
                if (p < 0) {
                    p = 0;
                }
                if (atendimento.queueTypeID == 2) {
                    this.AutoReply(socket, cliente.email, fila.nome, 3, { "$POSICAO": (p + 1), "$NOME_CLIENTE": cliente.nome }, msg.xcontactID, xcMsg.protocolo, atendimento);

                } else {
                    this.AutoReplyWhats(socket, msg.idCliente, fila.nome, 3, { "$POSICAO": (p + 1), "$NOME_CLIENTE": cliente.nome }, msg.instanceID, atendimento);
                }

                return true
            }
        }
        return false

    }

    async processaRota(cliente, atendimento, xcMsg, msg, file) {
        if (!msg.body) msg.body = msg.message;
        if (cliente.idGrupo && cliente.idGrupo !== null) {
            console.log('ENTROU AQUI NO IF DO PROCESSA ROTA WTF');
            console.log(cliente.idGrupo);
            var clienteGrupo = await ClienteGrupo.fetchById(cliente.idGrupo);
            var m = await this.saveMsg({ idAtendimento: atendimento.id, texto: msg.body, inOut: 1, agente: clienteGrupo.rota }, file);
            atendimento.ultimoAgente = clienteGrupo.rota;
            await new ClienteAtendimento(atendimento).save();
            var socketAgente = await ws.getSocketAgenteByFullName(clienteGrupo.rota);
            xcMsg.mensagemID = m.id;
            msg.messageID = m.id;
            msg.agente = clienteGrupo.rota;
            xcMsg.agente = clienteGrupo.rota;
            if (socketAgente) {
                if (atendimento.queueTypeID == 2) {
                    socketAgente.emit('message', JSON.stringify(msg));
                } else {
                    socketAgente.emit('message', JSON.stringify(xcMsg.X5Clientv1Format()));
                }
                return true
            } else {
                return true
            }
        }
        return false;
    }

    async sortearAgente(agentes, atendimento, msg, xcMsg, file) {
        log.info("VAMOS SORTEAR ALGUM AGENTE", atendimento.queueTypeID);
        if (!msg.body) msg.body = msg.message;
        const sorteado = agentes[Math.floor(Math.random() * agentes.length)];
        if (sorteado) {
            log.info(`agente ${sorteado.nome} para atendder o atendimento ${atendimento.id}`);
            console.log('Agente sorteado ' + sorteado.nome + ' para atender ' + atendimento.id);
            // Salvando Msg pro agente sorteado
            var m = await this.saveMsg({ idAtendimento: atendimento.id, texto: msg.body, inOut: 1, agente: sorteado.fullname }, file);
            var socketAgente = await ws.getSocketAgenteByFullName(sorteado.nome);
            xcMsg.mensagemID = m.id;
            xcMsg.agente = sorteado.fullname;
            msg.messageID = m.id;
            msg.agente = sorteado.fullname;
            atendimento.ultimoAgente = sorteado.nome;
            await new ClienteAtendimento(atendimento).save();
            if (atendimento.queueTypeID == 2) {
                socketAgente.emit('message', JSON.stringify(msg));
            } else {
                socketAgente.emit('message', JSON.stringify(xcMsg.X5Clientv1Format()));
            }
            return true
        }
        return false
    }

    async saveMsg(msg, file) {
        var m = await new AtendimentoMensagem(msg).save();
        if (file) {
            new MensagemAnexos({ idMensagem: m.id, caminho: file.caminho, mimeType: file.mimeType }).save();
        }
        return m;
    }

}   