'use strict'
const db = require('../util/db');
module.exports = class XClients {
    constructor() {
        this.Clientes = [];
    }
    async ProtocoloEmAtendimento(protocolo) {
        var query = await db.query('SELECT * from "queueChat" WHERE id = $1 AND "status" = $2', [protocolo, 'Entrou']);
        return query.rowCount;
    }
    async geraProtocolo(dados) {
        const queueTypeID = dados.queueTypeID ? dados.queueTypeID : 2;
        var query = await db.query('INSERT INTO "queueChat"("socketID","fromID","fromName","assunto","action","ativo","queue","status","email", "queueTypeID","dadosAdicionais") VALUES($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11) returning id',
            [dados.socketID, dados.fromID, dados.fromName, dados.assunto, dados.action, dados.ativo, dados.queue, dados.status, dados.email, queueTypeID, dados.dados_adicionais]);
        return query.rows[0].id;
    }
    async geraProtocoloEmail(dados) {
        var query = await db.query('INSERT INTO "queueChat"("socketID","fromID","fromName","assunto","action","ativo","queue","status","email", "queueTypeID") VALUES($1,$2,$3,$4,$5,$6,$7,$8,$9,$10) returning id',
            [dados.socketID, dados.fromID, dados.email, dados.assunto, dados.action, dados.ativo, dados.queue, dados.status, dados.email, 4]);
        return query.rows[0].id;
    }
    async addEmail(dados) {
        var query = await db.query('INSERT INTO "queueChat"("fromID","fromName","assunto","action","ativo","queue","status","email", "queueTypeID","ultimoAgente") VALUES($1,$2,$3,$4,$5,$6,$7,$8,$9,$10) returning id',
            [dados.fromID, dados.email, dados.assunto, dados.action, dados.ativo, dados.queue, 'Entrou', dados.email, 4, dados.agente]);
        return query.rows[0].id;
    }
    async gravaAnexo(anexo) {
        var query = await db.query('INSERT INTO "queueAnexos"("caminho","id_message","mimeType") VALUES($1,$2,$3) returning id',
            [anexo.caminho, anexo.id_message, anexo.mimeType]);
        return query.rows[0].id;
    }
    async getProtocoloByEmail(email, assunto, fila) {
        var query = await db.query('SELECT id from "queueChat" WHERE "email" = $1 AND "assunto" = $2 AND "queue" = $3 AND "status" = $4', [email, assunto, fila, 'Entrou']);
        return query.rowCount > 0 ? query.rows[0].id : null;
    }
    async getMaxChatAtende(ramal) {
        var query = await db.query('SELECT "max_chat_atende" from "agentes" WHERE "ramal" = $1', [ramal]);
        return query.rowCount > 0 ? query.rows[0].max_chat_atende : null;
    }
    async getAssinatura(agente) {
        var query = await db.query('SELECT "assinatura" from "agentes" WHERE "fullname" like $1 ', ['%' + agente + '%']);
        return query.rows[0].assinatura ? query.rows[0].assinatura : null;
    }
    async getChatsAtivosByRamal(name) {
        var query = await db.query('SELECT DISTINCT id AS protocolo from "queueChat" WHERE "ultimoAgente" = $1 AND "status" = $2 ', [name, 'Entrou']);
        return query.rowCount > 0 ? query.rows : null;
    }
    async getChatSemAgente() {

        var query = await db.query('SELECT  *, m.id AS "messageID" from "queueChat" AS c JOIN "queueChatMessages" AS m ON c.id = m."idQueueChat" LEFT JOIN "queueAnexos" AS a ON a.id_message = m.id  WHERE c."ultimoAgente" IS NULL AND c.status <> $1  ORDER by m."id"', ['Encerrado']);
        var retorno = null;
        return query.rowCount > 0 ? query.rows : retorno;
    }
    async getConfigEmail() {
        var query = await db.query('SELECT  "emailConfig",name from queue_table WHERE queue_type = $1 ', [4]);
        return query.rowCount > 0 ? query.rows : null;
    }
    async updateStatus(dados) {
        var query = await db.query('UPDATE "queueChat" SET "status" = $1 WHERE id = $2', ['Pendente', dados.protocolo]);
        return query.rowCount;
    }
    async updateClienteConectado(dados) {
        var query = await db.query('UPDATE "queueChat" SET "clienteConectado" = $1 WHERE id = $2', [dados.clienteConectado, dados.protocolo]);
        return query.rowCount;
    }
    async updateAnexo(id, protocolo) {
        var query = await db.query('UPDATE "queueAnexos" SET "id_message" = $2 WHERE id = $1', [id, protocolo]);
        return query.rowCount;
    }

    async gravaChatMessage(dados) {
        var query = await db.query('INSERT INTO "queueChatMessages"("idQueueChat","inOut","agente","texto","mailMessageID") VALUES($1,$2,$3,$4,$5) returning id',
            [dados.protocolo, dados.inOut, dados.agente, dados.message, dados.mailMessageID]);
        return query.rows[0].id;
    }

    async updateUltimoAgente(agente, protocolo) {
        var query = await db.query('UPDATE "queueChat" SET "ultimoAgente" = $1 WHERE "id" = $2', [agente, protocolo]);
        return query.rowCount;
    }


    async updateUltimoAgenteMessages(agente, protocolo) {
        var query = await db.query('UPDATE "queueChatMessages" SET "agente" = $1 WHERE "idQueueChat" = $2 AND agente IS NULL returning id', [agente, protocolo]);
        return query.rowCount;
    }
    async inativarAtendimento(protocolo) {
        var query = await db.query('UPDATE "queueChat" set "ativo" = false WHERE id = $1', [protocolo]);
        return query.rowCount;
    }

    async ativarAtendimento(protocolo) {
        var query = await db.query('UPDATE "queueChat" set "ativo" = true WHERE id = $1', [protocolo]);
        return query.rowCount;
    }

    async encerraAtendimento(protocolo, dataFim) {
        var query = await db.query('UPDATE "queueChat" SET "status" = $3, "dataFim" = $2  WHERE id = $1', [protocolo, dataFim, 'Encerrado']);
        return query.rowCount;
    }
    async getProtocoloAtivoByFromID(fromID) {
        var query = await db.query('SELECT id from "queueChat" WHERE "fromID" = $1 AND "status" = $2', [fromID, 'Entrou']);
        return query.rowCount > 0 ? query.rows[0].id : null;
    }
    async getFilaWhatsByID(whatsID) {
        var query = await db.query('SELECT name from queue_table WHERE context = $1 ', [whatsID]);
        return query.rowCount > 0 ? query.rows[0].name : null;
    }
    async getFilaWhatsInstaceID(name) {
        var query = await db.query('SELECT context from queue_table WHERE name = $1 ', [name]);
        return query.rowCount > 0 ? query.rows[0].context : null;
    }
    set(id, cli) {
        if (!id || !cli) return;
        this.Clientes[id] = cli;
    }
    get(id) {
        return this.Clientes[id];
    }
    getAll() {
        return this.Clientes;
    }
    del(id) {
        delete this.Clientes[id];
    }
    CountAll() {
        var size = 0;
        for (var key in this.Clientes) {
            if (this.Clientes.hasOwnProperty(key)) size++;
        }
        return size;
    }
    CountAgentes() {
        let total = 0;
        for (var key in this.Clientes) {
            const cli = this.Clientes[key];
            if (cli.xcontact_agente) total++;
        }
        return total;
    }
}