const log = require('../../../util/Log');
const EventosAmi = require('../../../util/EventosAmi');
module.exports = [
    {
        method: 'QueueCallerJoin',
        handler: async (io, ev) => {

            log.debug(`[AmiAdmin] QueueCallerJoin - Emitindo Evento LigacaoEntrouFila na sala Fila.${ev.queue}`);
            io.to(`Fila.${ev.queue}`).emit('LigacaoEntrouFila', EventosAmi.Limpa(ev));
        },
        options: {
            description: 'Monitora o evento QueueCallerJoin',
        }
    },
    {
        method: 'QueueCallerLeave',
        handler: async (io, ev) => {

            log.debug(`[AmiAdmin] QueueCallerLeave - Emitindo Evento LigacaoSaiuFila na sala Fila.${ev.queue}`);
            io.to(`Fila.${ev.queue}`).emit('LigacaoSaiuFila', EventosAmi.Limpa(ev));
        },
        options: {
            description: 'Monitora o evento QueueCallerLeave',
        }
    },
    {
        method: 'QueueCallerAbandon',
        handler: async (io, ev) => {

            log.debug(`[AmiAdmin] QueueCallerAbandon - Emitindo Evento LigacaoAbandonouFila na sala Fila.${ev.queue}`);
            io.to(`Fila.${ev.queue}`).emit('LigacaoAbandonouFila', EventosAmi.Limpa(ev));
        },
        options: {
            description: 'Monitora o evento QueueCallerAbandon',
        }
    },
    {
        method: 'QueueMemberAdded',
        handler: async (io, ev) => {
            log.debug(`[AmiAdmin] QueueMemberAdded - Emitindo Evento AgenteAdicionado na sala Fila.${ev.queue}`);
            io.to(`Fila.${ev.queue}`).emit('AgenteAdicionado', EventosAmi.Limpa(ev));
        },
        options: {
            description: 'Monitora o evento QueueMemberAdded',
        }
    },
    {
        method: 'QueueMemberRemoved',
        handler: async (io, ev) => {
            log.debug(`[AmiAdmin] QueueMemberRemoved - Emitindo Evento AgenteRemovido na sala Fila.${ev.queue}`);
            io.to(`Fila.${ev.queue}`).emit('AgenteRemovido', EventosAmi.Limpa(ev));
        },
        options: {
            description: 'Monitora o evento QueueMemberRemoved',
        }
    },
    {
        method: 'QueueMemberPause',
        handler: async (io, ev) => {
            log.debug(`[AmiAdmin] QueueMemberPause - Emitindo Evento AgentePausa na sala Fila.${ev.queue}`);
            io.to(`Fila.${ev.queue}`).emit('AgentePausa', EventosAmi.Limpa(ev));
        },
        options: {
            description: 'Monitora o evento QueueMemberPause',
        }
    },
    {
        method: 'QueueMemberStatus',
        handler: async (io, ev) => {
            log.debug(`[AmiAdmin] QueueMemberStatus - Emitindo Evento AgenteStatus na sala Fila.${ev.queue}`);
            io.to(`Fila.${ev.queue}`).emit('AgenteStatus', EventosAmi.Limpa(ev));
        },
        options: {
            description: 'Monitora o evento QueueMemberStatus',
        }
    },
    {
        method: 'AgentCalled',
        handler: async (io, ev) => {
            log.debug(`[AmiAdmin] AgentCalled - Emitindo Evento AgenteTocando na sala Fila.${ev.queue}`);
            io.to(`Fila.${ev.queue}`).emit('AgenteTocando', EventosAmi.Limpa(ev));
        },
        options: {
            description: 'Monitora o evento AgentCalled',
        }
    },
    {
        method: 'AgentConnect',
        handler: async (io, ev) => {
            log.debug(`[AmiAdmin] AgentConnect - Emitindo Evento AgenteAtendeu na sala Fila.${ev.queue}`);
            io.to(`Fila.${ev.queue}`).emit('AgenteAtendeu', EventosAmi.Limpa(ev));
        },
        options: {
            description: 'Monitora o evento AgentConnect',
        }
    },
    {
        method: 'AgentRingNoAnswer',
        handler: async (io, ev) => {
            log.debug(`[AmiAdmin] AgentRingNoAnswer - Emitindo Evento AgenteNaoAtendeu na sala Fila.${ev.queue}`);
            io.to(`Fila.${ev.queue}`).emit('AgenteNaoAtendeu', EventosAmi.Limpa(ev));
        },
        options: {
            description: 'Monitora o evento AgentRingNoAnswer',
        }
    },
    {
        method: 'AgentComplete',
        handler: async (io, ev) => {
            log.debug(`[AmiAdmin] AgentComplete - Emitindo Evento AgenteDesligou na sala Fila.${ev.queue}`);
            io.to(`Fila.${ev.queue}`).emit('AgenteDesligou', EventosAmi.Limpa(ev));
        },
        options: {
            description: 'Monitora o evento AgentComplete',
        }
    },
    {
        method: 'AgentDump',
        handler: async (io, ev) => {
            log.debug(`[AmiAdmin] AgentDump - Emitindo Evento AgenteIgnorou na sala Fila.${ev.queue}`);
            io.to(`Fila.${ev.queue}`).emit('AgenteIgnorou', EventosAmi.Limpa(ev));
        },
        options: {
            description: 'Monitora o evento AgentDump',
        }
    },
    {
        method: 'VarSet',
        handler: async (io, ev) => {
            log.debug(`[AmiAdmin] VarSet - Emitindo Evento LigacaoEfetuadaFila na sala Ligacoes`);
            //console.log(ev);
            if (ev.variable && ev.variable == 'FILA_SAIDA') {
                ev.queue = ev.value;
                ev.ramal = ev.channel.split('-')[0];
                console.log(`Ramal ${ev.channel.split('-')[0]} efetuando ligação para ${ev.exten} na fila ${ev.value}`);
                io.to(`Fila.${ev.queue}`).emit('LigacaoEfetuadaFila', EventosAmi.Limpa(ev));
            }
        },
        options: {
            description: 'Monitora o evento VarSet',
        }
    }
]