const log = require('../../../util/Log');
const EventosAmi = require('../../../util/EventosAmi');
const ami = require('../../../ami/index');
module.exports = [
    {
        method: 'BlindTransfer',
        handler: async (io, ev) => {

            log.debug(`[AmiAdmin] BlindTransfer - Emitindo Evento TransferenciaDireta na sala Ligacoes`);
            io.to(`Ligacoes`).emit('TransferenciaDireta', EventosAmi.Limpa(ev));
        },
        options: {
            description: 'Monitora o evento BlindTransfer',
        }
    },
    {
        method: 'AttendedTransfer',
        handler: async (io, ev) => {

            log.debug(`[AmiAdmin] AttendedTransfer - Emitindo Evento TransferenciaConsulta na sala Ligacoes`);
            io.to(`Ligacoes`).emit('TransferenciaConsulta', EventosAmi.Limpa(ev));
        },
        options: {
            description: 'Monitora o evento AttendedTransfer',
        }
    },
    {
        method: 'Hangup',
        handler: async (io, ev) => {
            log.debug(`[AmiAdmin] Hangup - Emitindo Evento Desligou na sala Ligacoes`);
            io.to(`Ligacoes`).emit('Desligou', EventosAmi.Limpa(ev));
        },
        options: {
            description: 'Monitora o evento Hangup',
        }
    },
    {
        method: 'Newstate',
        handler: async (io, ev) => {
            log.debug(`[AmiAdmin] Newstate - Emitindo Evento Newstate na sala Ligacoes`);
            io.to(`Ligacoes`).emit('Newstate', EventosAmi.Limpa(ev));
        },
        options: {
            description: 'Monitora o evento Newstate',
        }
    },
]