const Handlers = require('./handlers');
const discador = require('../discador');
const Ami = require('../ami');
var ss = require('socket.io-stream');
var path = require('path');
var fs = require('fs');
const XClientes = require('../util/XClients');
const xc = new XClientes();
const EventEmitter = require('events');
class wsEmitter extends EventEmitter { }
const wsEvento = new wsEmitter();
const config = require('../config.json');
const log = require('simple-node-logger').createSimpleLogger({ logFilePath: "/var/log/xcontact.log", timestampFormat: "DD-MM-YYYY HH:mm:ss.SSS" });
const log_level = config.log ? config.log : 'error';
let Omni = require('../xc_modules/omni');
let timerExpediente = require('../timer_expediente');
let omniws = null
const MetodoRoute = require('../plugins/xcontact_ioroutev2/MetodoRoute');
const metodoRoute = new MetodoRoute();
const metodoRouteWebRtcNativo = new MetodoRoute();

const EventoRoute = require('../plugins/xcontact_ioroutev2/EventoRoute');
const { initListaTransmissao } = require('../lista_transmissao');
const eventoRouter = new EventoRoute();

const { LogEventos } = require('../util/LogNew')

// Modulo para gestão de ligações WebRTCNativo, precisa carregar aqui pois precisa da conexao dos agentes
const callManager = require('../xc_modules/webrtc_nativo/src/callManager')

exports.register = async (server, options, next) => {
  let io = require('socket.io')(server.select('ws').listener);

  // WebRTCNativo
  try {    
    const ioWebRTCNativo = io.of('/webrtc-nativo')
    // Registra o diretório de rotas
    await metodoRouteWebRtcNativo.register('xc_modules/webrtc_nativo/src/metodos_route')

    // Quando um cliente conecta começa a ouvir os metodos que ele chama...
    ioWebRTCNativo.on('connection', (socket) => {
      metodoRouteWebRtcNativo.start(socket)
    })

    callManager.start(ioWebRTCNativo)
  } catch (error) {
    console.log('Erro ao iniciar o WebRTCNativo')
  }

  // Admin
  try {
    // Processa os metodos do /admin
    let adminws = io.of('/admin');
    // Registra o diretório de rotas
    await metodoRoute.register('ws/ws_admin');

    // Quando um cliente conecta começa a ouvir os metodos que ele chama...
    adminws.on('connection', (socket) => {
      metodoRoute.start(socket);
    });

    LogEventos.on('log', loge => {
      adminws.emit('log', loge)
    })


    // Eventos do AMI que vão para as rotas do /admin
    await eventoRouter.register('ws/ami_admin');
    eventoRouter.start(adminws, Ami.XCeventos);

  } catch (error) {
    log.error(`Erro ao registras as rotas /admin, erro: ${error.message}`);
  }


  try {
    const WhatsApiClient = require('./WhatsApiClient');
    const WhatsApi = io.of('/whatsapi');
    if (options.config.whatsApi.ativado && options.config.whatsApi.clientID !== 'SEM') {
      const wac = new WhatsApiClient();

      WhatsApi.on('connection', (socket) => {
        wac.process(socket);
      })
    }
    //#region INICIANDO IOROUTE 
    setTimeout(async () => {
      const metodoRoute2 = new MetodoRoute();
      const eventoRouter2 = new EventoRoute();
      omniws = io.of('/omni');
      await metodoRoute2.register('xc_modules/omni/api/client');
      omniws.on('connection', (socket) => {
        console.log(`INICIAMOS O METODOROUTE`)
        metodoRoute2.start(socket);
        socket.on('disconnect', () => {
          console.log(`DESCONECTAMOS`);
          let agente = {};
          agente.status = 0;
          agente.nome = socket.agente;
          Ami.XCeventos.emit('AgentDisconnected', agente);
        });
        socket.on('reconnect', () => {
          console.log('RECONECTAMOS');
        })
        ss(socket).on('file', async function (stream, data) {
          try {
            console.log(`ENTRROU NO FILE`, data)
            let dados = data;
            let today = new Date();
            let dir = `/gravacoes/${dados.queue}/${today.getFullYear()}/${today.getMonth() + 1}/${today.getDate()}`;
            fs.mkdirSync(dir, { recursive: true });
            stream.pipe(fs.createWriteStream(dir + '/' + data.filename));
            stream.on('end', async () => {
              dados.file_name = data.filename;
              dados.file = true;
              //variavel auxiliar para saber se e o client antigo ou o novo
              dados.client = `newClient`;
              Handlers['ClientChatMessage'](socket, dados)
            })



          } catch (error) {
            console.error(`ERRO NO FILe`, error);
          }
        });
        ss(socket).on('fileOnly', async function (stream, data) {
          console.log(`ENTROU AQUI ===============================================================`, data)
          try {
            let dados = data;
            let today = new Date();
            let dir = `/gravacoes/${dados.queue}/${today.getFullYear()}/${today.getMonth() + 1}/${today.getDate()}`;
            fs.mkdirSync(dir, { recursive: true });
            stream.pipe(fs.createWriteStream(dir + '/' + data.filename));
            stream.on('end', async () => {
              console.log(`TERMINAMOS DE UPAR`);
              dados.file_name = data.filename;
              dados.file = true;
              dados.client = `newClient`;
              Handlers['ClientChatMessage'](socket, dados)
            });
          } catch (error) {
            console.error(error);
          }
        })

      })
      await eventoRouter2.register('xc_modules/omni/api/server');
      eventoRouter2.start(omniws, Omni.OmniEventos);
      initListaTransmissao()
    }, 550);

    //#endregion
    //BORA DAR START NO MODULO DO OMNI...

    //Handlers['VerificaMessage'](socket);
    // const host = socket.handshake.address;
    // const agent = socket.handshake.headers['user-agent'];
    // socket.emit('open', { status: 'conectado' });
  } catch (ex) {
    console.error('Falha ao registrar uma conexão, erro: %s', ex.toString());
  }

  // Rotas usadas pela interface Web do Xcontact para falar com a API do Whats
  // A interface WEB conecta no namespace /whatsapi que tem os metodos indendentes da estrutura atual e estão definidos no WhatsApiClient que
  // conecta na Api do WhatsApp e faz o bypass das requisições feitas pela web do Xcontact direcionando-as à API.

  io.on('connection', (socket) => {
    // Metodos com request e reply (reply deve ser uma function)
    socket.on('request', (request, reply) => {
      if (typeof reply !== 'function') return;

      var req = typeof (request) == 'object' ? request : JSON.parse(request);
      if (req.metodo) {
        try {
          Handlers.requestMetodos[req.metodo](req, reply);
        } catch (ex) {
          reply({ error: true, message: ex.message });
        }
      }
      else {
        reply({ error: true, message: "Metodo não informado." });
      }
    });

    socket.on("error", function (error) {
      console.error(error);
      console.trace(error);
      log.error(`[Socket-Server-Error] Erro! ` + error);
    });

    // Trata a requisição dos clientes
    // A mensagem do cliente deve ser um JSON no formato: message {"action":"QueueStatus","queue":"teste","dados2":"teste"}
    socket.on('message', function (message) {
      //if(!socket.auth) return;
      try {
        var obj = typeof (message) == 'object' ? obj = message : JSON.parse(message);
        if (obj && obj.action) {
          try {
            if (Handlers[obj.action]) {
              Handlers[obj.action](socket, obj, io);
            }

            else {
              console.error('O Metodo %s não existe', obj.action);
            }
          } catch (ex) {
            console.error('Falha ao chamar metodo', ex);
          }
        }
        else {
          console.error('Comando desconhecido: ');
        }
      } catch (ex) {
        console.error('Falha ao interpretar solicitação do cliente: %s', typeof (message));
      }
    });
    socket.on('authentication', function (data) {
      try {
        console.log(`Alguem esta fazendo a authentication`);
        Handlers['OnAuthentication'](socket, data);
        let aux = JSON.parse(data);
        if (!aux) return;
        aux.fullname = aux.nome;
        if (aux.fullname)
          timerExpediente.verficaTimerAgente(aux, `login`);
      } catch (ex) {
        console.error('Falha ao tratar authentication', ex);
      }
    });
    socket.on('disconnect', () => {
      try {
        console.error('O cliente %s desconectou.', socket.handshake.address);
        console.error('Xcontact: ', socket.XCliente);
        if (!socket.XCliente) return;
        socket.XCliente.fullname = socket.XCliente.nome;
        timerExpediente.verficaTimerAgente(socket.XCliente, `deslogou`);
        //if(Handlers['UserDisconnected']) {
        //    Handlers['UserDisconnected'](socket);
        //}
      } catch (e) {
        console.trace(e);
        log.error(`[WS][DISCONNECT] Erro ao tratar evento de disconnect!\n${e}`);
      }
    });
    socket.on(`reconnect`, () => {
      console.error('RECONECTOU: ', socket.XCliente);
    })

    ss(socket).on('fileOnly', async function (stream, data) {
      console.log(`ENTROU AQUI ===============================================================`, data)
      try {
        let dados = data;
        let today = new Date();
        let dir = `/gravacoes/${dados.queue}/${today.getFullYear()}/${today.getMonth() + 1}/${today.getDate()}`;
        fs.mkdirSync(dir, { recursive: true });
        stream.pipe(fs.createWriteStream(dir + '/' + data.filename));
        stream.on('end', async () => {
          console.log(`TERMINAMOS DE UPAR`);
          // //dados.file_name = data.filename;
          // dados.file = true;
          // //variavel auxiliar para saber se e o client antigo ou o novo
          // dados.client = `newClient`;
          // Handlers['ClientChatMessage'](socket, dados)
        })



      } catch (error) {
        console.error(error);
      }
    })

    ///ss(socket).on('upload', async function (stream, data) {


    //   try {
    //     var dados = JSON.parse(data);
    //     log.error(`DADOS==========================================================================================`, dados)
    //     if (dados.remetente) {
    //       Handlers['sendFileMsg'](socket, stream, dados);
    //     } else {
    //       dados.message = dados.Msg;
    //       dados.inOut = 2;
    //       let today = new Date();
    //       let dir_name = `/gravacoes/${dados.queue}/${today.getFullYear()}/${today.getMonth() + 1}/${today.getDate()}`;
    //       //var dir_name = "/var/www/html/anexos/" + dados['mailMessageID'];
    //       var dir_link = `anexos/${dados['mailMessageID']}`;
    //       if (!fs.existsSync(dir_name)) {
    //         fs.mkdirSync(dir_name);
    //       }
    //       stream.pipe(fs.createWriteStream(dir_name + '/' + dados['filename']));
    //       // var id = await xc.gravaChatMessage(dados);


    //       dados.messageID = id;
    //       var anexos = {
    //         'caminho': dir_link + "/" + dados['filename'],
    //         'id_message': id
    //       }
    //       //await xc.gravaAnexo(anexos);
    //       dados.anexo = null;
    //       dados.anexo = dir_name + '/' + dados['filename'];
    //       Handlers['ClientChatMessage'](socket, dados)

    //     }



    //   } catch (error) {
    //     log.error('erro ao streamar arquivo', error);
    //   }

    // })
  });
  exports.broadcast = (event) => {
    const ev = event.event ? event.event : event.response + ', ' + event.message;
    var msg = JSON.stringify(event);
    try {
      io.sockets.emit('message', msg);
    } catch (ex) {
      console.error('Nao consegui enviar %s, motivo: %s', ev, ex.toString());
    }
  };
  exports.broadcastEvent = (event, args) => {
    try {
      io.sockets.emit(event, args);
    } catch (ex) {
      console.error(ex);
    }
  };
  exports.SocktIDExiste = (socketID) => {
    return io.sockets.sockets[socketID] ? io.sockets.sockets[socketID] : false;
  }
  exports.sendMsgToSocketID = (msg, socketID) => {
    try {
      var so = io.sockets.sockets[socketID];
      so.emit('message', JSON.stringify(msg));
    } catch (ex) {
      console.error('Nao consegui enviar msg para o SocketID = %s, motivo: %s', socketID, ex.toString());
    }
  }

  exports.getSocketAgenteByFullName = (fullname) => {
    var allsockets = omniws.sockets;
    for (var sId in allsockets) {
      var so = allsockets[sId];
      if (so.agente) {
        if (so.agente == fullname) {
          return so;
        }
      }
    }
    return undefined;
  }

  exports.getSocketAgenteByRamal = async (ramal) => {
    var allsockets = io.sockets.sockets;
    for (var sId in allsockets) {
      var so = allsockets[sId];
      if (so.XCliente) {
        if (so.XCliente.ramal == ramal) {
          return so;
        }
      }
    }
    return undefined;
  }
  exports.getAllSockets = async () => {
    var allsockets = io.sockets.sockets;
    return allsockets;
  }
  exports.getXClienteNomeFromSocketID = (socketID) => {
    return io.sockets.sockets[socketID].XCliente ? io.sockets.sockets[socketID].XCliente.nome : undefined;
  }
  exports.getSocketAtendendoProtocolo = async (protocolo) => {
    var ramal = await Ami.getChatsAgentes(protocolo);

    if (ramal) {
      var allsockets = io.sockets.sockets;
      for (var sId in allsockets) {
        var so = allsockets[sId];
        if (so.XCliente && so.XCliente.ramal) {
          if (so.XCliente.ramal === ramal) {
            return so;
          }
        }
      }
    }
    return undefined;
  }
  exports.getDestinoSocketProtocolo = (socketOrigem, protocolo) => {
    var allsockets = io.sockets.sockets;
    for (var sId in allsockets) {
      var so = allsockets[sId];
      if (socketOrigem.id !== so.id && so.XCliente && so.XCliente.protocolos) {
        if (so.XCliente.protocolos.indexOf(protocolo) !== -1) {
          return so;
        }
      }
    }
    return undefined;
  }
  exports.getSocketNoProtocolo = (protocolo) => {
    var allsockets = io.sockets.sockets;
    for (var sId in allsockets) {
      var so = allsockets[sId];
      if (so.XCliente && so.XCliente.protocolo == protocolo) {
        return so;
      }
    }
    return undefined;
  }
  exports.sendMsg = (data) => {

    var obj = JSON.parse(data);
    var allsockets = io.sockets.sockets;
    for (var sId in allsockets) {
      var so = allsockets[sId];
      Handlers[obj.action](so, obj);
      break;
    }
  };
  exports.io = io;
  exports.Omni = Omni;
  next();
};
exports.register.attributes = {
  name: 'xcontact-io'
};

exports.wsEvento = wsEvento;