const log = require('../../../util/Log');
const Supervisores = require('../../../models/Supervisores');
const SupervisoresFilas = require('../../../models/SupervisoresFilas');
const Fila = require('../../../models/Fila')

const AdminsLogados = new Map();

exports.Login = async (socket, request) => {
    log.debug(`[AdminWS] - Recebi pedido de login adm do IP: ${socket.handshake.address}`);
    try {
        if (request.token === 'SuperAdmin8934rndsvc89yawd32ry89asdhbo3iu2r8yasfbdefJuca') {
            const filas = await Fila.query.fields('name').fetch()

            const user = { id: 1, nome: 'Super user', fullname: 'Super user' }
            socket.LoginOk = true
            socket.Admin = true
            socket.User = user

            AdminsLogados.set(socket.id, user)

            if (filas) {
                for(let fila of filas) {
                    console.log('Adicionando fila ao login do supervidor', fila.name)
                    socket.join(`Fila.${fila.name}`)                 
                }
            }            
            return user
        } else return new Error('Login inválido')
    } catch (error) {
        return error;
    }
}

exports.getAdmins = (socket) => {
    log.debug(`[AdminWS] - Recebi pedido de getAdmins do IP: ${socket.handshake.address}`);
    if (AdminsLogados.size > 0) {
        return [...AdminsLogados.values()];
    }
    else {
        return new Error('Não temos nenhum Supervisor logado');
    }
}

exports.Deslogar = (socket) => {
    log.info(`[AdminWS] - Desconectou, IP: ${socket.handshake.address}, SocketID: ${socket.id}`);
    AdminsLogados.delete(socket.id);
}