/**
 * Pega o agente que está a mais tempo sem atender para realizar o atendimento
 * @param {*} fila Objeto fila do Ami
 * @returns
 */
module.exports = (fila) => {
  try {
    // Pega agentes disponíveis
    let agentes;
    if ([1, 9].includes(fila.queue_type)) {
      agentes = fila.agentes.filter((a) => a.pausa === 0 && a.status === 1);
    } else {
      agentes = fila.agentes.filter((a) => a.pausa === 0);
    }

    if (agentes && agentes.length > 0) {
      // Verifica se existe algum agente sem DataUltimoAtendimento e o seleciona
      const agenteSemData = agentes.find((a) => !a.DataUltimoAtendimento);
      if (agenteSemData) {
        agenteSemData.DataUltimoAtendimento = new Date();
        console.log(
          `Agente ${agenteSemData.nome} sem DataUltimoAtendimento obtido por balanceamento na fila ${fila.nome} para atender`
        );
        return agenteSemData;
      }

      // Ordena os agentes pela data do último atendimento (do mais antigo para o mais recente)
      const SortedAgents = agentes.sort(
        (a, b) => a.DataUltimoAtendimento - b.DataUltimoAtendimento
      );
      console.log("AGENTES BALANCEADOS", SortedAgents);
      const sorteado = SortedAgents[0];
      sorteado.DataUltimoAtendimento = new Date();
      console.log(
        `Agente ${sorteado.nome} obtido por balanceamento na fila ${fila.nome} para atender`
      );
      return sorteado;
    } else {
      console.log(
        `Não há agentes disponíveis na fila ${fila.nome} para realizar o atendimento`
      );
      return null;
    }
  } catch (error) {
    console.error("Erro ao tentar buscar agente por balanceamento", error);
  }
};
