/**
 * Sorteia um agente para realizar o atendimento
 * @param {*} fila Objeto fila do Ami
 * @returns 
 */
module.exports = (fila) => {
    try {
        // Pega agentes disponíveis
        const agentes = fila.agentes.filter(a => a.pausa === 0 && a.status === 1)
        if (agentes && agentes.length > 0) {
            const sorteado = agentes[Math.floor(Math.random() * agentes.length)]
            console.log(`Agente ${sorteado.nome} *** SORTEADO *** na fila ${fila.nome} para atender`)
            return sorteado
        }
        else {
            console.log(`Não há agentes disponíveis na fila ${fila.nome} para realizar o atendimento`)
            return null
        }
    } catch (error) {
        console.error('ERRO NO SORTEAR AGENTE', error);
    }
}