const EventEmitter = require('events');
class MyEmitter extends EventEmitter { }

module.exports = class WhatsApi {
    WhatsEvents = [
        'message',
        `newMessageConnectus`,
        'sendMsgReturn',
    ];
    constructor(host, clientID) {
        this.host = host;
        this.clientID = clientID;
        this.emitter = new MyEmitter();
    }
    on(event, fn, fn2 = null) {
        return this.emitter.addListener(event, fn, fn2);
    }
    connect() {
        this.socket = require('socket.io-client')(this.host);
        this.socket.on('connect', () => {
            console.log(`conectou enviando login chat`, this.clientID);
            this.socket.emit('Login', { clientID: this.clientID }, (retorno) => {
                this.emitter.emit('LoginEvent', retorno);
                console.log("LOGAMOS NO CSA SMS")
            });
        });
        // Add listener for All Events in array WhatsEvents        
        this.WhatsEvents.forEach(event => this.socket.on(event, (args, args2 = null) => this.emitter.emit(event, args, args2)))
    }
    sendMessage(msg, callback = null) {
        try {
            this.socket.emit('sendMessage', msg, (retorno) => {
                if (callback !== null) {
                    callback(retorno);
                }
            });
        } catch (error) {
            console.error('ERRO NO SENDMESSAGE')
        }

    }
}