
const Omni = require('../../../../../ws/index').Omni;
let Atendimento = require('../../../../../models/ClienteAtendimento');
let vAtendimento = require('../../../../../models/vAtendimentosOmnichannel');
let Ligacao = require('../../../../../models/QueueCalls');
const Cliente = require('../../../../../models/Cliente');

const Config = require('../../../../../config.json');

let AtendimentoMensagem = require(`../../../../../models/AtendimentoMensagem`);
const Fila = require('../../../../../models/Fila');
const Agente = require('../../../../../models/Agente');
var autoEncerramento = new (require('../../../../../bots/autoEncerramento/index'));
let log = Omni.log;
let config = Omni.config;
const moment = require('moment');
const Ami = require('../../../../../ami');
const db = require('../../../../../util/db');
let MensagemAnexos = require('../../../../../models/MensagemAnexos');
let ws = require('../../../../../ws');
const namiLib = require("nami");
let fs = require('fs');
const { reject } = require('underscore');
const {enviarMensagemCanal, getCanais, criarCanalDeTexto} = require('../../../../../canais_de_texto/index')
exports.QueueAdd = async (socket, dados) => {
    try {
        console.log(`QUEUEADD`, dados);
        if (dados.queue instanceof Array) {
            for (let i = 0; i < dados.queue.length; ++i) {
                const ac = new namiLib.Actions.QueueAdd(dados.location, dados.queue[i], dados.paused, dados.membername, dados.penalty);
                Ami.nami.send(ac);
            }
        } else {
            const ac = new namiLib.Actions.QueueAdd(dados.location, dados.queue, dados.paused, dados.membername, dados.penalty);
            Ami.nami.send(ac);
        }
    } catch (error) {
        console.error(error);
    }
}
exports.QueueRemove = async (socket, dados) => {
    try {
        dados.location = dados.location ? dados.location : dados.interface;
        if (dados.queue instanceof Array) {
            for (let i = 0; i < dados.queue.length; ++i) {
                const ac = new namiLib.Actions.QueueRemove(dados.location, dados.queue[i]);
                Ami.nami.send(ac);
            }
        }
        else {
            const ac = new namiLib.Actions.QueueRemove(dados.location, dados.queue);
            Ami.nami.send(ac);
        }
    } catch (error) {
        console.error(error);
    }
}
exports.QueuePause = async (socket, dados) => {
    try {
        dados.location = dados.location ? dados.location : dados.stateinterface;
        dados.reason = dados.reason ? dados.reason : dados.motivo;
        const ac = new namiLib.Actions.QueuePause(dados.location, undefined, dados.reason);
        Ami.nami.send(ac);
    } catch (error) {
        console.error(error);
    }
}
exports.VerificaStatus = async (socket, dados) => {
    try {
        return dados()
    } catch (error) {
        console.error(error)
    }
}
exports.QueueUnpause = async (socket, dados) => {
    try {
        dados.location = dados.location ? dados.location : dados.interface;
        const ac = new namiLib.Actions.QueueUnpause(dados.location);
        Ami.nami.send(ac);
    } catch (error) {
        console.error(error);
    }
}
exports.QueueStatus = async (socket, dados) => {
    try {
        if (dados.ping) return { error: false, msg: 'Ping' }
        var ret = { event: 'FilasStatus' };
        let filas = [];
        ret.filas = [];
        if (dados && dados.queue) {
            filas.push(Ami.getFila(dados.queue));
        }
        if (filas.length == 0) filas = Ami.getFilas();
        for (let fila of filas) {
            let newfila = JSON.parse(JSON.stringify(fila));
            newfila.atendimentos = [];
            newfila.ligacoes_atendidas = [];
            newfila.agentes = newfila.agentes.map(agente => {
                if (agente) agente.atendimentos = [];
                return agente;
            })
            newfila.ligacoes = newfila.ligacoes.map(l => {

                if (l) {
                    l.origem = l.origem ? l.origem : l.fromID.split('@c.us')[0];
                    l.inicio = l.inicio ? l.inicio : l.dataIni;
                }

                return l;
            })
            ret.filas.push(newfila);
        }
        return ret;

    } catch (error) {
        console.error(error);
    }
}
exports.sendFileMsg = async (socket, data) => {
    try {
        var today = new Date();
        let dir = `/gravacoes/${data.queueFrom ? data.queueFrom : data.queue}/${today.getFullYear()}/${today.getMonth() + 1}/${today.getDate()}`;
        await fs.mkdirSync(dir, { recursive: true });
        let retorno = await fs.writeFileSync(dir + '/' + data.file_name, data.file);
        return await Omni.sendFileMsg(data);
    } catch (error) {
        console.error(error);
    }
}
exports.sendMsg = async (socket, data) => {
    return await new Promise(async (resolve, reject) => {
        try {
            let atendimento = await Atendimento.fetchById(data.protocolo);
            let cliente = await Cliente.fetchById(atendimento.idCliente);
            var fila = await Fila.query.require(true).first()
                .where({ name: data.queue })
                .fetch();
            let config = fila.emailConfig;

            var lastMsg = null;
            if (atendimento.queueTypeID == 4) {
                lastMsg = await AtendimentoMensagem.query.require(false).first()
                    .where({ idAtendimento: data.protocolo })
                    .orderBy(`id DESC`)
                    .fetch();
            }
            autoEncerramento.verificaTimer(null, atendimento);
            Omni.OmniEventos.emit('filaStatus', { atendimento: atendimento, tipo: 'enviado' });
            Omni.OmniEventos.emit('novaMensagemAgente', {fila:atendimento.queue, data:new Date(), atendimentoId:atendimento.id, agente:atendimento.ultimoAgente, tipo:'sainte'})
            if (atendimento.queueTypeID == 3) {
                let msg = await Omni.saveMsg({ idAtendimento: data.protocolo, texto: data.message, inOut: 2, agente: atendimento.ultimoAgente, status: 'pending' }, null);
                let filaredir = atendimento.queueFrom !== null ? atendimento.queueFrom : atendimento.queue;
                Omni.WhatsApp.sendMessage({ instanceID: filaredir, chatId: atendimento.fromID, msg: data.resposta }, async (retorno) => {
                    console.log(`RETORNO`, retorno);
                    if (retorno.error) {
                        resolve({ error: true, message: retorno.errorDetails });
                    }
                    if (retorno.isBoom) {
                        resolve({ error: true, message: retorno.output.payload.message });
                    }
                    msg.status = retorno.error ? 'pending' : 'sended';
                    msg.mailMessageID = !retorno.error ? retorno.msg.id : null;
                    msg.save();
                    resolve(msg);
                    console.log(Omni.OmniEventos);
                    Omni.OmniEventos.emit('SendSuccess', { atendimento: atendimento, message: msg });

                })
            }
            if (atendimento.queueTypeID === 4) {
                data.mailMessageID = lastMsg == null ? null : lastMsg.mailMessageID;
                if (!data.email) {
                    data.remetente = atendimento.fromID;
                } else {
                    data.remetente = data.email;
                }
                let agente = await Agente.query.require(false).first().where({ fullname: atendimento.ultimoAgente }).fetch();
                if (agente) {
                    data.message += agente.assinatura;
                }
                let auxEmail = {};
                auxEmail.emails = data.email;
                auxEmail.from = atendimento.ultimoAgente;
                Omni.addEmail(atendimento, auxEmail);
                if (data.encaminha) {
                    let retorno = await Omni.criaMsgParaEncaminhar(data.message, atendimento);
                    console.log(`RETORNO`, retorno);
                    data.message = retorno.texto;
                    if (retorno.files) {
                        data.anexos = retorno.files;
                    }
                }
                data.assunto = atendimento.assunto
                const retEmail = await Omni.mail.respondeEmail(data);
                let msg = await Omni.saveMsg({ idAtendimento: data.protocolo, texto: data.message, inOut: 2, agente: atendimento.ultimoAgente, status: 'seen', mailMessageID:retEmail? retEmail.id : (lastMsg ? lastMsg.mailMessageID : null), dados_adicionais: JSON.stringify(auxEmail) }, null);
                Omni.OmniEventos.emit('SendSuccess', { atendimento: atendimento, message: msg })
                resolve(msg);
            }
            if (atendimento.queueTypeID === 2) {
                data.idCliente = atendimento.fromID;
                let message = await Omni.saveMsg({ idAtendimento: data.protocolo, texto: data.message, inOut: 2, agente: atendimento.ultimoAgente, status: `seen` }, null);
                Omni.WebChat.socket.emit('sendMsgChat', { queue: fila.nome, uid: atendimento.fromID, msg: message, clientID: Config.csa.id, protocolo: atendimento.id });
                Omni.OmniEventos.emit('SendSuccess', { atendimento: atendimento, message: message })
                resolve(message);
            }

            if (atendimento.queueTypeID === 5) {
                let msg = await Omni.saveMsg({ idAtendimento: data.protocolo, texto: data.message, inOut: 2, agente: atendimento.ultimoAgente, status: 'pending' }, null);

                Omni.Zenvia.socket.emit('newWhatsMsgZenvia', { zenviaID: config.zenviaID, from: config.from, to: atendimento.fromID, text: data.resposta }, async (retorno) => {
                    if (!retorno.error) {
                        msg.status = `seen`;
                        msg.save();
                        Omni.OmniEventos.emit('SendSuccess', { atendimento: atendimento, message: msg })

                    }
                });
                resolve(msg);
            }
            if (atendimento.queueTypeID === 6) {
                let msg = await Omni.saveMsg({ idAtendimento: data.protocolo, texto: data.message, inOut: 2, agente: atendimento.ultimoAgente, status: 'pending' }, null);
                Omni.Infobip.socket.emit('newWhatsMsgInfobip', { baseurl: config.baseurl, authorization: config.authorization, to: atendimento.fromID, text: data.resposta }, async (retorno) => {
                    if (!retorno.error) {
                        msg.status = retorno.error ? 'pending' : 'seen';
                        msg.save()
                        Omni.OmniEventos.emit('SendSuccess', { atendimento: atendimento, message: msg })

                    }
                });
                resolve(msg);
            }
            if (atendimento.queueTypeID === 7) {
                // return Omni.Infobip.socket.emit('newWhatsMsgGupshup', { apikey: confige.apikey, source: confige.source, to: atendimento.fromID, text: texto, }, (retorno) => {
                // });
                console.log('---------- Caiu aqui ------------')
                let msg = await Omni.saveMsg({ idAtendimento: data.protocolo, texto: data.message, inOut: 2, agente: atendimento.ultimoAgente, status: 'pending' }, null);

                var filaGup = await Fila.query.require(true).first()
                    .where({ name: atendimento.queueFrom ? atendimento.queueFrom : atendimento.queue })
                    .fetch();
                let configGup = filaGup.emailConfig;
                const gupRequestMsg = { apikey: configGup.apikey, source: configGup.source, to: atendimento.fromID, text: data.resposta }
                console.log('----- Vai chamar gup com dados: ', gupRequestMsg)
                Omni.Gupshup.socket.emit('newWhatsMsgGupshup', gupRequestMsg, async (retorno) => {
                    console.log('------ Retorno da GUP: ', retorno)
                    if (!retorno.error) {
                        msg.status = retorno.error ? 'pending' : 'sended';
                        msg.mailMessageID = retorno.message.messageId;
                        msg.save()
                        Omni.OmniEventos.emit('SendSuccess', { atendimento: atendimento, message: msg })

                    }
                });
                resolve(msg);


            }
            if (atendimento.queueTypeID === 8) {
                // return Omni.Infobip.socket.emit('newWhatsMsgGupshup', { apikey: confige.apikey, source: confige.source, to: atendimento.fromID, text: texto, }, (retorno) => {
                // });
                let msg = await Omni.saveMsg({ idAtendimento: data.protocolo, texto: data.message, inOut: 2, agente: atendimento.ultimoAgente, status: 'pending' }, null);
                Omni.Facebook.socket.emit('sendMsg', { pagetoken: config.pagetoken, sender_psid: atendimento.fromID, text: data.resposta }, async (retorno) => {
                    if (!retorno.error) {
                        msg.status = retorno.error ? 'pending' : 'seen';
                        msg.save()
                        Omni.OmniEventos.emit('SendSuccess', { atendimento: atendimento, message: msg })

                    }
                });
                resolve(msg);
            }
            if (atendimento.queueTypeID === 10) {
                console.log('ERA DO TIPO SMS =================')
                var filaGup = await Fila.query.require(true).first()
                .where({ name: atendimento.queueFrom ? atendimento.queueFrom : atendimento.queue })
                .fetch();
                let configGup = filaGup.emailConfig;
                let msg = await Omni.saveMsg({ idAtendimento: data.protocolo, texto: data.message, inOut: 2, agente: atendimento.ultimoAgente, status: 'pending' }, null);
                console.log('QUASE ENVIANDO')
                Omni.Connectus.socket.emit('sendMsgConnectus', {
                    dst_number: atendimento.fromID,
                    src_number: configGup.dst_number,
                    id_client: configGup.id_client, 
                    sms_content: data.resposta
                  }, async (retorno) => {
                    console.log('RETORNO DO CONNECTUS', retorno)
                    if (!retorno.error) {
                        msg.status = retorno.error ? 'pending' : 'seen';
                        msg.save()
                        Omni.OmniEventos.emit('SendSuccess', { atendimento: atendimento, message: msg })

                    }
                });
                resolve(msg);
            }

        } catch (error) {
            reject(error);
            console.error(error);
        }
    })


};
exports.readMessage = async (socket, data) => {
    try {
        console.log(`READMESSAGE`, data)
        await db.query('UPDATE "queueChat" set qtd_msg_nao_lidas = 0 WHERE "idCliente" = $1', [data.id])
        return { error: false, message: 'Mensagens lidas' };
    } catch (error) {
        console.error(error);
        return { error: true, message: error };

    }
}
exports.replyMsg = async (socket, data) => {
    return await new Promise(async (resolve, reject) => {

        try {
            let atendimento = await Atendimento.fetchById(data.protocolo);
            autoEncerramento.verificaTimer(null, atendimento);
            Omni.OmniEventos.emit('filaStatus', { atendimento: atendimento, tipo: 'enviado' });
            Omni.OmniEventos.emit('novaMensagemAgente', {fila:atendimento.queue, data:new Date(), atendimentoId:atendimento.id, agente:atendimento.ultimoAgente, tipo:'sainte'})
            if (atendimento.queueTypeID == 3) {
                let filaredir = atendimento.queueFrom !== null ? atendimento.queueFrom : atendimento.queue;
                Omni.WhatsApp.socket.emit('replyMessage', { instanceID: filaredir, chatId: atendimento.fromID, msg: data.resposta, id: data.repliedIdMsg }, async (retorno) => {
                    if (!data.repliedIdMsg) return; // VAMOS DEIXAR ASSIM POR ENQUANTO ATE TERMOS ALGUMA FORMA DE RETORNO DE ERRO NO CLIENT
                    let msg = await AtendimentoMensagem.query.first().require(false).where({ mailMessageID: data.repliedIdMsg }).fetch();
                    let queueAnexos = await MensagemAnexos.query.require(false).first().where({ idMensagem: msg.id }).fetch();
                    let quotedMsg = {};
                    if (msg && msg.texto) quotedMsg.body = msg.texto;
                    if (msg && queueAnexos) quotedMsg = queueAnexos;
                    let newMsg = await Omni.saveMsg({ idAtendimento: data.protocolo, texto: data.message, inOut: 2, agente: atendimento.ultimoAgente, status: retorno.error ? 'pending' : 'seen', repliedIdMsg: null, mailMessageID: !retorno.error ? retorno.msg.id : null, quotedMsg: quotedMsg }, null);
                    Omni.OmniEventos.emit('SendSuccess', { atendimento: atendimento, message: newMsg });
                    resolve(newMsg)
                });
            }
        } catch (error) {
            console.error(error);
        }
    })
};
exports.enviarMensagemCanalDeTexto = async (socket, data) => {
    try {
       return await enviarMensagemCanal(data.texto, data.idCanal, data.agente)
    } catch (error) {
        console.error(error)
    }
}
exports.transfereAtendimento = async (socket, data) => {
    try {
        console.log(`transfereAtendimento`);
        data.fila = data.queue;
        let retorno = await Atendimento.query.first()
            .where({ id: data.protocolo })
            .fetch();
            const retornoAux = {...retorno}
        if (retorno) {
            retorno.id = data.protocolo;
            let agenteRemetente = retorno.ultimoAgente;
            retorno.queue = data.queue;
            retorno.ultimoAgente = null;
            const filaAntiga = `${retornoAux.queue}`
            console.log('FILA ANTIGA', filaAntiga)
            retorno.queueFrom = retorno.queueFrom ? retorno.queueFrom : filaAntiga;
            retorno.queue = data.queue;
            retorno.status = "Entrou";
            if (data.nome) {
                retorno.ultimoAgente = data.nome;
            }
            console.log('QUEUEFROM', retorno.queueFrom)
            retorno.agenteRemetente = agenteRemetente;
            if (typeof retorno.dadosAdicionais != 'object') retorno.dadosAdicionais = JSON.parse(retorno.dadosAdicionais);
            await retorno.save();
            Omni.removeTimerTransbordo(retorno);
            let retornoTransfer = await Omni.AddHistoricoTransferencia(retorno, 'agente');
            if (retornoTransfer)
                retorno.transfers = retornoTransfer.dadosAdicionais.transfers;
            console.log(`RETORNO`, retorno.transfers)
            var Query = await db.query('SELECT texto FROM public."queueRespostasAutomaticas" where fila = $1 AND "idRespostaTipo" = $2', [retorno.queueFrom, data.nome ? 9 : 8]);
            if (Query.rowCount > 0) {
                var texto = Query.rows[0].texto;
                let trocas = { "$AGENTEREMETENTE": agenteRemetente, "$AGENTEDESTINATARIO": retorno.ultimoAgente }
                if (trocas) {
                    if (typeof trocas === 'object') {
                        Object.entries(trocas).forEach(([key, value]) => {
                            texto = texto.split(key).join(value);
                        });
                    }
                }
                var lastMsg = await AtendimentoMensagem.query.require(false).first()
                    .where({ idAtendimento: retorno.id })
                    .orderBy(`id DESC`)
                    .fetch();
                let message = await Omni.saveMsg({ idAtendimento: retorno.id, texto: texto, inOut: 3, agente: 'Xcontact', mailMessageID: retorno.queueTypeID === 4 && lastMsg ? lastMsg.mailMessageID : 'Xcontact' }, null);

            }
            Omni.OmniEventos.emit('TransfereAtendimento', {
                atendimento: retorno
            });
            //Omni.ws.wsEvento.emit(`transferToAgente`, retorno, retorno.ultimoAgente);
            if (data.nome) {
                var faux = await Ami.getFila(data.queue);
                Omni.OmniEventos.emit(`removeAguardando`, { fila: faux, atendimento: retorno });
                Omni.OmniEventos.emit('removeAtendimentoNaFila', {fila: filaAntiga, agente: agenteRemetente, data:new Date(), atendimentoId:retorno.id, tipo:'transferencia'})
               // ws.wsEvento.emit('agenteTransferenciaAddAtendimento', {fila:retorno.queue, data:new Date(), atendimentoId:retorno.id, agente: agenteRemetente})
                ws.wsEvento.emit('transferToAgent', retorno, agenteRemetente);
                console.log(`[LOG ATENDIMENTO ${retorno.id}] Atendimento transferido de ${agenteRemetente} para ${data.nome}`)
            } else {
                Omni.OmniEventos.emit('removeAtendimentoNaFila', {fila: filaAntiga, transferTo:data.queue, agente: agenteRemetente, data:new Date(), atendimentoId:retorno.id, tipo:'transferencia'})
                ws.wsEvento.emit('transferToQueue', retorno, agenteRemetente);
                console.log(`[LOG ATENDIMENTO ${retorno.id}] Atendimento transferido de ${agenteRemetente} para fila`)
            }

        }
    } catch (error) {
        console.error(error);
    }
};
exports.addAtendimento = async (socket, data) => {
    try {
        console.log(`addAtendimento`, data);
        var fila = await Ami.getFila(data.queue);
        data.queueTypeID = fila.queue_type;
        if (data.queueTypeID === 3 || data.queueTypeID === 5 || data.queueTypeID === 6 || data.queueTypeID === 7) {
            data.idCliente = data.remetente.trim();
            data.idCliente = data.remetente.replace(/\s/g, '');
        }

        if (data.queueTypeID === 4) {
            data.idCliente = data.email;
        }
        data.nomeCliente = data.name;
        data.from = data.idCliente;
        data.nomeCliente = data.name;
        data.instanceID = data.queueFrom ? data.queueFrom : data.queue;
        var cliente = await Cliente.getClienteByMsg(data);
        console.log('CLIENTE', cliente)
        let atendimento = await Atendimento.query.require(false).first()
            .where({ idCliente: cliente.id })
            .where(Atendimento.where.or(
                Atendimento.where.equal({ queue: data.instanceID }),
                Atendimento.where.equal({ queueFrom: data.instanceID })
            ))
            .where({ status: 'Entrou' })
            .fetch();

        console.log(`TINHA UM ATENDIMENTO`, atendimento);
        if (!atendimento) {
            let fromIDAux = data.from;
            if (data.queueTypeID === 3) {
                fromIDAux += '@c.us';
            }
            atendimento = await new Atendimento(
                {
                    assunto: data.assunto,
                    linkedid: data.zenviaID,
                    fromID: fromIDAux,
                    fromName: cliente.nome,
                    queue: data.queue,
                    queueFrom: data.queueFrom,
                    idCliente: cliente.id,
                    ativo: false,
                    sentido: 'Sainte',
                    status: 'Entrou',
                    assunto: data.assunto,
                    queueTypeID: data.queueTypeID,
                    action: 'WhatsAppIn',
                    dadosAdicionais: { "nome": data.name, "remetente": data.from }
                }).save();
        }

        if (!atendimento.ultimoAgente) {
            console.log(`NAO TINHA AGENTE`)
            atendimento.ultimoAgente = data.agente;
            atendimento.queueFrom = data.queueFrom;
            atendimento.sentido = `Sainte`;
            atendimento.ativo = true;
            await atendimento.save();
            Omni.OmniEventos.emit('addAtendimento', atendimento);
            Omni.OmniEventos.emit('agenteAddAtendimento', {nome: atendimento.fromName, numero:data.idCliente,fila:atendimento.queue, agente:data.agente, atendimentoId: atendimento.id, data:new Date()})
            return atendimento;
        } else {
            //Caso ja esteja em atendimento vamos gerar um evento de erro para o client saber;
            let err = {};
            err.msg = data.agente === atendimento.ultimoAgente ? `Voce ja esta atendendo este cliente` : `Este cliente ja esta sendo atendido por ${atendimento.ultimoAgente}`;
            err.agente = data.agente;
            const idx = fila.ligacoes.findIndex((a) => a.id == atendimento.id);
            if(idx !== -1) fila.ligacoes.splice(idx, 1);      
            Omni.OmniEventos.emit('errorMsg', err);
            return err;
        }
    } catch (error) {
        console.error(error);
    }
};
exports.getTemplates = async (socket, data) => {
    try {
        console.log(`Entrou no getTemplates`, data);
        let fila = null
        if (data.protocolo) {
             const atendimento = await Atendimento.fetchById(data.protocolo)
             fila = await Fila.query.require(true).first()
            .where({ name: atendimento.queueFrom || atendimento.queue })
            .fetch();
        } else {
            fila = await Fila.query.require(true).first()
            .where({ name: data.queue })
            .fetch();
        }
       
        let config = fila.emailConfig;
        console.log(fila);
        if (fila.queue_type == 5) {
            Omni.Zenvia.socket.emit('getTemplatesZenvia', { zenviaID: config.zenviaID }, async (retorno) => {
                if (!retorno.error) {
                    Omni.OmniEventos.emit('getTemplatesZenvia', { agente: data.agente, dados: retorno });
                }
            });
        }

        if (fila.queue_type == 7) {
            console.log(`get templatwes gup`);
            Omni.Gupshup.socket.emit('getTemplatesGupshup', config, async (retorno) => {
                console.log(retorno);
                if (!retorno.error) {
                    Omni.OmniEventos.emit('getTemplatesGupshup', { agente: data.agente, dados: retorno });
                }
            });
        }
        if (fila.queue_type == 6) {
            console.log(`get templates infobip`);
            Omni.Infobip.socket.emit('getTemplatesInfobip', { baseurl: config.baseurl, authorization: config.authorization }, async (retorno) => {
                retorno = JSON.parse(retorno);
                console.log(`RETORNO`, retorno);
                if (!retorno.error) {
                    Omni.OmniEventos.emit('getTemplatesInfobip', { agente: data.agente, dados: retorno });
                }
            });
        }

    } catch (error) {
        console.error(error);
    }
};
exports.sendTemplateMsg = async (socket, data) => {
    try {
        let atendimento = await Atendimento.fetchById(data.protocolo);
        let msg = await Omni.saveMsg({ idAtendimento: parseInt(data.protocolo), texto: data.message, inOut: 2, agente: atendimento.ultimoAgente, status: 'pending' }, null);
        var fila = await Fila.query.require(true).first()
            .where({ name: data.queue })
            .fetch();
        let config = fila.emailConfig;
        if (fila.queue_type == 5) {
            Omni.Zenvia.socket.emit('newWhatsMsgZenvia', { zenviaID: config.zenviaID, from: config.from, to: atendimento.fromID, text: data.message, templateId: data.templateId, fields: data.fields }, async (retorno) => {
                if (!retorno.error) {
                    let texto = data.message;
                    for (let key in data.fields) {
                        texto = texto.replace(`{{${key}}}`, data.fields[key]);
                    }
                    msg.status = `sended`;
                    msg.texto = texto;
                    msg.save();
                    Omni.OmniEventos.emit('SendSuccess', { atendimento: atendimento, message: msg });
                }
            });
        }
        if (fila.queue_type == 6) {
            Omni.Infobip.socket.emit('newWhatsMsgInfobip', { baseurl: config.baseurl, authorization: config.authorization, to: atendimento.fromID, template: { nomeTemplate: data.name, fields: data.fields } }, async (retorno) => {
                if (!retorno.error) {
                    msg.status = retorno.error ? 'pending' : 'sended';
                    msg.save()
                    Omni.OmniEventos.emit('SendSuccess', { atendimento: atendimento, message: msg });
                }
            });
        }

        if (fila.queue_type == 7) {
            //gambi para mandar para o numero correto     
            // console.log(`DADOS`, data);
            return new Promise(async (resolve, reject) => {
                Omni.Gupshup.socket.emit('newWhatsMsgGupshup', { apikey: config.apikey, appName: config.appName, source: config.source, to: atendimento.fromID, text: data.message, template: { id: data.templateId, fields: data.fields } }, async (retorno) => {
                    console.log(`RETORNO GUP`, retorno);
                    if (!retorno.error) {
                        let texto = data.message;
                        if (Object.keys(data.fields).length > 0) {
                            for (let key in data.fields) {
                                texto = texto.replace(`{{${parseInt(key)+1}}}`, data.fields[key]);
                            }
                        }
                        msg.status = retorno.message.status;
                        msg.mailMessageID = retorno.message.messageId
                        msg.texto = texto;
                        await msg.save();
                        console.log('---------- Salvou a msg ---------', msg)
                        resolve(msg)
                        Omni.OmniEventos.emit('SendSuccess', { atendimento: atendimento, message: msg });
                    } else {
                        reject(retorno)
                    }
                });
            })
        }

    } catch (error) {
        console.error(error);
    }
}
exports.encerraAtendimento = async (socket, data) => {
    try {
            const atendimento = await Atendimento.fetchById(data.protocolo);
            var trocas = { "$PROTOCOLO": atendimento.id };
            if (atendimento.queueTypeID == 3) {
                let instance = atendimento.queueFrom ? atendimento.queueFrom : atendimento.queue;
                Omni.WhatsApp.socket.emit(`deleteChat`, { clientID: config.whatsApi.clientID, instanceID: instance, chatId: atendimento.fromID }, async retorno => {
                    console.log(`RETORNOU`, retorno);
                });
            }
            if (atendimento.ultimoAgente)
                ws.wsEvento.emit(`AtendimentoEncerradoDistribui`, atendimento.ultimoAgente);
            let fila = await Ami.getFila(atendimento.queue);
            //Bora emitir o evento de remover da fila da fila kkkk
            Omni.OmniEventos.emit('removeAguardando', { fila: fila, atendimento: atendimento });
            Omni.OmniEventos.emit('removeAtendimentoNaFila', {fila: atendimento.queue, agente: atendimento.ultimoAgente, data:new Date(), atendimentoId:atendimento.id, tipo:'encerramento'})
            //Bora emitir o evento para atualizar os dashs na respectiva fila
            Omni.OmniEventos.emit('filaStatus', { atendimento: atendimento, tipo: 'aguardando' });
            //removendo timer de transbordo ja que encerraram...
            autoEncerramento.removeTimerTransbordo(atendimento);
            Omni.OmniEventos.emit('removeAtendimentoClient', { atendimento: atendimento });
            if (atendimento.status !== 'Pesquisa') {
                Omni.ProcessPesquisa(atendimento);
                Omni.autoReply(atendimento, trocas, 2);
                console.log(`[LOG ATENDIMENTO ${atendimento.id}] Atendimento foi para pesquisa`);
                return { message: 'Atendimento encerrado com sucesso!', error: false };

            } else {
                Omni.autoReply(atendimento, trocas, 2);
                atendimento.status = 'Encerrado';
                atendimento.dataFim = new Date(moment.tz(config.servidor.timezone))
                let at = await new Atendimento({ id: atendimento.id, status: 'Encerrado', dataFim: new Date(moment.tz(config.servidor.timezone)) }).save({ require: false });
                Omni.calculosFila(fila, at);
                console.log(`[LOG ATENDIMENTO ${atendimento.id}] Atendimento encerrado`);
                return { message: 'Atendimento encerrado com sucesso!', error: false };


            }
        
    } catch (error) {
        console.error(`encerra`, error);
        log.error(`ERRO NO ENCERRAATENDIMENTO`, error);
    }

};
exports.deleteMsg = async (socket, data) => {
    try {
        let atendimento = await Atendimento.fetchById(data.protocolo);
        autoEncerramento.verificaTimer(null, atendimento);
        if (atendimento.queueTypeID == 3) {
            let filaredir = atendimento.queueFrom !== null ? atendimento.queueFrom : atendimento.queue;
            Omni.WhatsApp.socket.emit('deleteMessage', { instanceID: filaredir, chatId: atendimento.fromID, id: data.msg.mailMessageID }, async (retorno) => {
                let msg = await AtendimentoMensagem.fetchById(data.msg.id);
                if (!retorno.error) msg.status = `deleted`;
                if (retorno.error) {
                    let err = {};
                    err.msg = retorno.error;
                    err.agente = data.agente;
                    return Omni.OmniEventos.emit('errorMsg', err);
                }
                msg.save();
                Omni.OmniEventos.emit('SendSuccess', { atendimento: atendimento, message: msg });
            })
        }
    } catch (error) {
        console.error(error);
    }
};
exports.aceitarAtendimento = async (socket, data) => {
    try {
        return await Omni.aceitarAtendimento(data.protocolo,data.agente)
    } catch (error) {
        console.error(error)
    }
}
exports.recusarAtendimento = async (socket, data) => {
    try {
        return await Omni.recusarAtendimento(data.atendimento,data.agente)
    } catch (error) {
        console.error(error)
    }
}
exports.getCanais = async (socket, data) => {
    return await getCanais()
}
exports.criarCanalDeTexto = async (socket, data) => {
    return await criarCanalDeTexto(data.nome, data.agentes, data.tipo)
}