const handlers = require('./handlers')

module.exports = [
    {
        method: 'QueueAdd',
        handler: handlers.QueueAdd,
        options: {
            description: 'Loga em uma fila',
            validade: ['queue']
        }
    },
    {
        method: 'QueueRemove',
        handler: handlers.QueueRemove,
        options: {
            description: 'Desloga em uma fila',
            validade: ['queue']
        }
    },

    {
        method: 'VerificaStatus',
        handler: handlers.VerificaStatus,
        options: {
            description: 'Pega os status do agente',
        }

    },
    {
        method: 'QueueStatus',
        handler: handlers.QueueStatus,
        options: {
            description: 'Pega os status das filas',
            validade: ['action']
        }
    },
    {
        method: 'QueuePause',
        handler: handlers.QueuePause,
        options: {
            description: 'Pausa em uma fila',
            validade: ['action']
        }
    },
    {
        method: 'QueueUnpause',
        handler: handlers.QueueUnpause,
        options: {
            description: 'DesPausa em uma fila',
            validade: ['action']
        }
    },
    {
        method: 'sendMsg',
        handler: handlers.sendMsg,
        options: {
            description: 'Envia uma mensagem',
            validade: ['texto']
        }
    },
    {
        method: 'sendFileMsg',
        handler: handlers.sendFileMsg,
        options: {
            description: 'Envia uma mensagem',
            validade: ['file']
        }
    },
    {
        method: 'readMessage',
        handler: handlers.readMessage,
        options: {
            description: 'Marca como lida as mensagens',
            validade: ['id']
        }
    },
    {
        method: 'replyMessage',
        handler: handlers.replyMsg,
        options: {
            description: 'Responde uma mensagem',
            validate: ['texto']
        }
    },
    {
        method: 'TransfereAtendimentoParaFila',
        handler: handlers.transfereAtendimento,
        options: {
            description: 'Transfere um atendimento',
            validate: ['protocolo']
        }
    },
    {
        method: 'TransferenciaAtendimento',
        handler: handlers.transfereAtendimento,
        options: {
            description: 'Transfere um atendimento',
            validate: ['protocolo']
        }
    },
    {
        method: 'addAtendimento',
        handler: handlers.addAtendimento,
        options: {
            description: 'Cria um atendimento',
            validate: ['fromID']
        }
    },
    {
        method: 'EncerrarAtendimento',
        handler: handlers.encerraAtendimento,
        options: {
            description: 'Encerra um atendimento',
            validade: ['protocolo']
        }
    },
    {
        method: 'getTemplates',
        handler: handlers.getTemplates,
        options: {
            description: 'Pega os templates api oficial',
            validade: ['queue']
        }
    },
    {
        method: 'sendTemplate',
        handler: handlers.sendTemplateMsg,
        options: {
            description: 'envia os templates api oficial',
            validade: ['protocolo']
        }
    },
    {
        method: 'deleteMessage',
        handler: handlers.deleteMsg,
        options: {
            description: 'deleta uma mensagem de whats',
            validade: ['protocolo']
        }
    },
     {
        method: 'aceitarAtendimento',
        handler: handlers.aceitarAtendimento,
        options: {
            description: 'Aceita um novo atendimento da fila',
            validade: ['protocolo']
        }
    },
      {
        method: 'recusarAtendimento',
        handler: handlers.recusarAtendimento,
        options: {
            description: 'Recusar um novo atendimento da fila',
            validade: ['atendimento']
        }
    },
    {
        method: 'enviarMensagemCanalDeTexto',
        handler: handlers.enviarMensagemCanalDeTexto,
        options: {
            description: 'enviar mensagem canal de texto',
            validade: ['idCanal']
        }
    },
    {
        method: 'getCanais',
        handler: handlers.getCanais,
        options: {
            description: 'get canais de texto'
        }
    },
    {
        method: 'criarCanalDeTexto',
        handler: handlers.criarCanalDeTexto,
        options: {
            description: 'criar um novo canal de texto',
            validade: ['nome']
        }
    }   
]