let Ami = require("../../../../../ami");
const config = require("../../../../../config.json");

exports.sendSuccess = (io, data) => {
  try {
    //Bora mandar o evento de envio para a sala do agente que enviou
    io.to(`Agente.${data.atendimento.ultimoAgente}`).emit("SendSuccess", data);
  } catch (error) {
    console.error(`SENDSUCCESS`, error);
  }
};
exports.removeAguardando = async (io, data) => {
  try {
    //Bora mandar o evento sala do cients que estao na sala desta fila
    let fila = data.fila;
    let atendimento = data.atendimento;

    if (!fila.ligacoes) fila.ligacoes = [];
    if (fila.ligacoes_atendidas) {
      let ligacao = fila.atendimentos.find((l) => l.id === atendimento.id);
      if (ligacao && !ligacao.saiuAguardando)
        ligacao.saiuAguardando = new Date(moment.tz(config.servidor.timezone));
    }
    fila.ligacoes = await fila.ligacoes.filter((a) => {
      if (atendimento.id !== a.id) {
        return a;
      }
    });
  } catch (error) {
    console.error(`removeAguardando`, error);
  }
};
exports.removeAtendimentoClient = (io, data) => {
  try {
    //Bora mandar o evento de envio para a sala do agente que enviou
    io.to(`Agente.${data.atendimento.ultimoAgente}`).emit("message", {
      id: data.atendimento.id,
      idCliente: data.atendimento.idCliente,
      tipo: data.atendimento.queueTypeID,
      event: "RemoveAtendimento",
    });
  } catch (error) {
    console.error(`removeAtendimentoClient`, error);
  }
};
exports.filaStatus = async (io, data) => {
  try {
    let tipo = data.tipo;
    let atendimento = data.atendimento;
    let fila = await Ami.getFila(atendimento.queue);
    if (!fila) return console.log(`NAO ACHEI A FILA`, atendimento.queue);
    if (fila && fila.queue_type !== 1) {
      if (tipo === "enviado") {
        fila.mensagensEnviadas++;
      }
      if (tipo === "recebido") {
        fila.mensagensRecebidas++;
      }
      if (tipo === "novo") {
        fila.novosAtendimentos++;
      }
      let newfila = JSON.parse(JSON.stringify(fila));
      newfila.atendimentos = [];
      newfila.ligacoes_atendidas = [];
      newfila.agentes = newfila.agentes.map((agente) => {
        if (agente) agente.atendimentos = [];
        return agente;
      });
      if (newfila.ligacoes) {
        newfila.ligacoes = newfila.ligacoes.map((l) => {
          if (l) {
            l.origem = l.origem ? l.origem : l.fromID.split("@c.us")[0];
            l.inicio = l.inicio ? l.inicio : l.dataIni;
          }
          return l;
        });
      }
      const ret = { event: "FilasStatus" };
      ret.filas = [];
      ret.filas.push(newfila);
      //Talvez tenhamos que voltar o broadcast aqui :(
      io.to(`Fila.${data.atendimento.queue}`).emit("message", ret);
    }
  } catch (error) {
    console.error(`filaStatus`, error);
  }
};
exports.TransfereAtendimento = async (io, data) => {
  try {
    let atendimento = data.atendimento;
    if (atendimento.ultimoAgente)
      return io
        .to(`Agente.${atendimento.ultimoAgente}`)
        .emit("TransfereAtendimento", atendimento);
    io.to(`Fila.${atendimento.queue}`).emit(
      "TransfereAtendimento",
      atendimento
    );
  } catch (error) {
    console.error(error);
  }
};
exports.addAtendimento = async (io, data) => {
  try {
    io.to(`Agente.${data.ultimoAgente}`).emit(`addAtendimento`, data);
  } catch (error) {
    console.error(error);
  }
};
exports.inviteAtendimento = async (io, data) => {
  try {
    io.to(`Agente.${data.agente}`).emit(`inviteAtendimento`, data);
  } catch (error) {
    console.error(error);
  }
};
exports.errorMsg = async (io, data) => {
  try {
    io.to(`Agente.${data.agente}`).emit(`errorMsg`, data);
  } catch (error) {
    console.error(error);
  }
};
exports.getTemplatesZenvia = async (io, data) => {
  try {
    io.to(`Agente.${data.agente}`).emit(`getTemplatesZenvia`, data);
  } catch (error) {
    console.error(error);
  }
};
exports.getTemplatesGupshup = async (io, data) => {
  try {
    io.to(`Agente.${data.agente}`).emit(`getTemplatesGupshup`, data);
  } catch (error) {
    console.error(error);
  }
};
exports.newMessage = async (io, data) => {
  try {
    io.to(`Agente.${data.atendimento.ultimoAgente}`).emit(`newMessage`, data);
  } catch (error) {
    console.error(error);
  }
};
exports.newMessageCanalDeTexto = async (io, data) => {
  try {
    return io.to("canaisDeTexto").emit("newMessageCanalDeTexto", data);
  } catch (error) {
    console.error(error);
  }
};
exports.usuarioAdicionadoCanalDeTexto = async (io, data) => {
  try {
    return io.to("canaisDeTexto").emit("usuarioAdicionadoCanalDeTexto", data);
  } catch (error) {
    console.error(error);
  }
};

exports.removeInviteAgente = async (io, data) => {
  try {
    io.to(`Agente.${data.agente}`).emit(`removeInviteAgente`, data);
  } catch (error) {
    console.error(error);
  }
};
