const db = require('../util/db');
const Cliente = require('./Cliente');
const config = require('../../../config.json')
const log = require('simple-node-logger').createSimpleLogger(config.log_ops);
log.setLevel(config.log ? config.log : 'error');
class Atendimento extends db.orm.Model { }

Atendimento.table = 'queueChat';
Atendimento.fields = {
    id: { type: 'integer', primary: true, updated: false, methods: true },
    fromID: 'string',
    sentido: 'string',
    fromName: 'string',
    assunto: 'string',
    action: 'string',
    ativo: 'boolean',
    queue: 'string',
    queueFrom: 'string',
    email: 'string',
    dataIni: 'dateTime',
    dataFim: 'dateTime',
    status: 'string',
    ultimoAgente: 'string',
    dadosAdicionais: 'json',
    queueTypeID: 'integer',
    linkedid: 'string',
    newstate: 'boolean',
    idCliente: {
        type: 'integer',
        references: Cliente.fields.id
    },
    qtd_msg: 'integer',
    data_hora_last_msg: 'dateTime',
    count: {
        column: 'qtd_msg_nao_lidas',
        type: 'integer',
    },
}
//#region UTILIDADES
Atendimento.getAtendimento = async (data, cliente) => {
    try {
        log.info(`[GET ATENDIMENTO]`, data);
        //vamos ver se tem atendimento ativo nesta fila para este cliente
        let Ativo =
            await Atendimento.query.require(false).first()
                .where({ idCliente: cliente.id })
                .where(Atendimento.where.or(
                    Atendimento.where.equal({ queue: data.instanceID }),
                    Atendimento.where.equal({ queueFrom: data.instanceID })
                ))
                .where({ status: 'Entrou' })
                .fetch();
        //nao tem bora ver se esta em pesquisa
        if (!Ativo) {
            let Pesquisa = await Atendimento.query.require(false).first()
                .where({ idCliente: cliente.id })
                .where(Atendimento.where.or(
                    Atendimento.where.equal({ queue: data.instanceID }),
                    Atendimento.where.equal({ queueFrom: data.instanceID })
                ))
                .where({ status: 'Pesquisa' })
                .fetch();
            //estava em pesquisa
            if (Pesquisa) {
                Ativo = Pesquisa;
            }
        }
        //Passou aqui bora criar um atendimento
        let fromIDAux = data.from;
        if (data.queueTypeID === 3) {
            fromIDAux += '@c.us';
        }
        let atendimento = Ativo ? Ativo : await new Atendimento(
            {
                assunto: data.assunto,
                linkedid: data.zenviaID,
                fromID: fromIDAux,
                fromName: cliente.nome,
                queue: data.instanceID,
                idCliente: cliente.id,
                ativo: false,
                sentido: 'Entrante',
                status: 'Entrou',
                queueTypeID: data.queueTypeID,
                action: 'WhatsAppIn',
                dadosAdicionais: { "nome": data.name, "remetente": data.from }
            }).save();
        return atendimento;
    } catch (error) {
        log.error(' ATENDIMENTO ] erro no get atendimento', error)
    }

}
//#endregion


module.exports = Atendimento;