//#region IMPORTS
let WhatsApp = require("../whatsapi");
let Zenvia = require("../zenvia");
let Infobip = require("../infobip");
let Gupshup = require("../gupshup");
let Facebook = require("../facebook");
let WebChat = require("../webchat");
let Connectus = require("../connectus");
const Downloader = require("nodejs-file-downloader");

const Config = require("../../config.json");
const config = require("../../config.json");

let Atendimento = require("./class/Atendimento");
const Cliente = require("../../models/Cliente");
let AtendimentoMensagem = require(`../../models/AtendimentoMensagem`);
let MensagemAnexos = require("./class/MensagemAnexos");
const formataMsgWhats = require("./util/formataMsgWhats");
const formataMsgZenvia = require("./util/formataMsgZenvia");
const formataMsgFace = require("./util/formataMsgFace");
const formataMsgWebChat = require("./util/formataMsgWebChat");
const Fila = require("./class/Fila");
const Pesquisa = require("./class/Pesquisa");
const PesquisaNota = require("./class/PesquisaNota");
const preAtendimento = require("../../bots/preAtendimento/index");

const instanciasPre = new Map();
const Ami = require("../../ami/index");
const ws = require("../../ws/index");
const db = require("./util/db");
const mime = require("mime-to-extensions");
const fs = require("fs");
const FilaTemp = require("../../util/FilaTemp");
const Agente = require("./class/Agente");
const moment = require("moment");
const Horarios = require("../../models/Horarios");
const FilaPreAtendimento = require(`../../models/FilaPreAtendimento`);
const ClienteGrupo = require("../../models/ClienteGrupo");
var autoEncerramento = new (require("../../bots/autoEncerramento/index"))();
const uuid = require("uuid/v1");
const Boom = require("boom");
var files = [];
var arquivos = [];
var queue = require("queue");
var processaQueue = queue({
  autostart: true,
  concurrency: 1,
});
var processaQueueEnvia = queue({
  autostart: true,
  concurrency: 1,
});

const axios = require("axios");
const log = require("node-live-log")('xc_modules/omni')
exports.log = log;
exports.config = config;
const timers = []
exports.timers = timers
const EventEmitter = require("events");
const { initEventsOmni } = require("../../events");
class MyEmitter extends EventEmitter {}
const myEmitter = new MyEmitter();
let mail = null;
let medias = [];
const { initDistribuicao } = require("./distribui");

const AtendimentoMensagemQueue = require('./queueHelpers/AtendimentoMensagemQueue')
//#endregion
exports.register = (server, options, next) => {  
  const atendimentoMQ = new AtendimentoMensagemQueue()
  atendimentoMQ.start()

  atendimentoMQ.on('success', async result => {
    log.debug('[atendimentoMQ] [on.success] Job finalizou com sucesso, dados: ', JSON.stringify(result))
    try {
      const atendimento = await Atendimento.fetchById(result.idAtendimento);
      if(atendimento) {
        log.info(`[atendimentoMQ] [on.success] Emitindo evento SendSuccess status = ${result.status} para o atendimento ${result.idAtendimento} e mensagem ${result.id}`)
        myEmitter.emit("SendSuccess", {          
          atendimento: atendimento,
          message: result,
        });
        // ws.broadcast({
        //   atendimento: atendimento,
        //   message: result,
        //   event: "SendSuccess",
        // });
      } else {
        log.warn(`[atendimentoMQ] [on.success] Não foram encontrados dados para o atendimento = ${result.idAtendimento}`)
      }  
    } catch (error) {
      log.error(`[atendimentoMQ] [on.success] Error: `, error.toString())
    }
  })

  setTimeout(async () => {
    log.info("Modulo Omni iniciado");        
    initEventsOmni(myEmitter);
    initDistribuicao(myEmitter, ws, autoEncerramento);
    //INSTANCIAR AS MIDIAS....
    //#region listeners
    try {
      ws.wsEvento.on("Conferencia", (dados) => {
        ws.broadcast({ dados: dados, event: "ConferenciaAtt", errorMsg: null });
      });
      //Esses eventos sao emitidos como gatilho para distribuicao vamos analisar para por em pratica
      ws.wsEvento.on("transferToQueue", async (atendimento, agenteQueTransferiu) => {
          try {
            log.info(`[transferToQueue] Atendimento ${atendimento.id} transferido para fila`);
            let fila = Ami.getFila(atendimento.queue);
            var ft = new FilaTemp(fila);
            const preAux = await FilaPreAtendimento.query
              .require(false)
              .first()
              .where({ queueName: atendimento.queue })
              .fetch();
            if (!preAux) {
              let numero = atendimento.fromID
              if (atendimento.fromID.indexOf("@") !== -1) numero = atendimento.fromID.split("@")[0]
              myEmitter.emit("filaAddAtendimento", {
                fila: atendimento.queue,
                nome: atendimento.fromName,
                numero: numero,
                data: new Date(),
                atendimentoId: atendimento.id,
              });
              ft.addTopoFila(atendimento);
              myEmitter.emit("filaStatus", {
                atendimento: atendimento,
                tipo: null,
              });
            }
            //distribuiDaFila(fila);
          } catch (error) {
            log.error(`[transferToQueue] ERRO ao transferir o atendimento ${atendimento.id} vindo do agente ${agenteQueTransferiu}`, error.toString());
          }

          // setQueue(fila, 'distribuiAtendimento');
        }
      );
      ws.wsEvento.on("transferToQueueUra", async (atendimento) => {
        try {
          let numero = atendimento.fromID
          if (atendimento.fromID.indexOf("@") !== -1) numero = atendimento.fromID.split("@")[0]
           myEmitter.emit("filaAddAtendimento", {
                fila: atendimento.queue,
                data: new Date(),
                nome: atendimento.fromName,
                numero: numero,
                atendimentoId: atendimento.id,
              });
          //pegaFilasParaDistribuir();
        } catch (error) {
          log.error(`[transferToQueueUra] ERRO ao distrubuir da ura para a fila, ERRO: `, error.toString());
        }

        // setQueue(fila, 'distribuiAtendimento');
      });
      ws.wsEvento.on("transferToAgent", async (atendimento, agenteQueTransferiu) => {
          // setQueue(fila, 'distribuiAtendimento');
          try {
            log.info(`[transferToAgent] Atendimento ${atendimento.id} transferido para agente`);
            myEmitter.emit("filaStatus", {
              atendimento: atendimento,
              tipo: null,
            });
            myEmitter.emit("removeAtendimentoNaFila", {
              fila: atendimento.queue,
              agente: atendimento.ultimoAgente,
              atendimentoId: atendimento.id,
              nome: atendimento.fromName,
              numero: atendimento.fromID,
              data: new Date(),
              tipo: "atendido",
            });
            myEmitter.emit("agenteTransferenciaAddAtendimento", {
              fila: atendimento.queue,
              agente: atendimento.ultimoAgente,
              data: new Date(),
              atendimentoId: atendimento.id,
              agenteOld: agenteQueTransferiu,
            });
          } catch (error) {
            log.error(`[transferToAgent] ERRO ao transferir atendimento ${atendimento.id} vindo do agente ${agenteQueTransferiu}`, error.toString());
          }
        }
      );
      //
      //Rota que encaminha para o agente um atendimento
      ws.wsEvento.on("sendToAgent", (atendimento) => {
        enviaParaAgente(atendimento);
      });
      //Este e usado para as campanhas
      ws.wsEvento.on("getTemplates", async (data, reply) => {
        try {
          console.log(`Entrou no getTemplates`, data);
          var fila = await Fila.query
            .require(true)
            .first()
            .where({ name: data.Fila })
            .fetch();
          console.log(`FILA`, fila);
          let config = fila.emailConfig;
          if (fila.queue_type == 5) {
            console.log(`ZENVIA`);
            Zenvia.socket.emit(
              "getTemplatesZenvia",
              { zenviaID: config.zenviaID },
              async (retorno) => {
                reply(retorno);
              }
            );
          }
          if (fila.queue_type == 7) {
            console.log(`GUP`, Gupshup);
            Gupshup.socket.emit(
              "getTemplatesGupshup",
              config,
              async (retorno) => {
                console.log(retorno);
                reply(retorno);
              }
            );
          }
        } catch (error) {
          reply(Boom.badData(error));
          console.error(error);
        }
      });
      //Este e usado ao encerrar pello reatorio ponto => eu exclui o encerraAtendimetno daqui kkkkkkkkkkk
      ws.wsEvento.on("AtendimentoEncerrado", (protocolo) => {
        let data = {};
        data.protocolo = protocolo;
        encerraAtendimento(protocolo);
      });

      //Esses eventos sao emitidos como gatilho para distribuicao vamos analisar para por em pratica
      ws.wsEvento.on("AtendimentoEncerradoDistribui", async (agenteQueEncerrou) => {
          try {
            log.info(`[AtendimentoEncerradoDistribui] Atendimento ecerrado, iniciando distribuição`);
            let agente = Ami.getAgenteLogadoByFullname(agenteQueEncerrou);
            if (!agente)
              return log.warn(`[AtendimentoEncerradoDistribui] Nada para distribuir, o agente ${agenteQueEncerrou} não está logado em nenhuma fila`);
          } catch (error) {
            log.error(`[AtendimentoEncerradoDistribui] ERROR ao distribuir atendimento para agente ${agenteQueEncerrou}`, error.toString());
          }
      });
      // Tudo aqui abaixo não faz nada, não faz sentido ter isso
      // ws.wsEvento.on("AgentePausa", async (agente) => {
      //   // Que erro pode ocorrer aqui para ter um try?
      //   try {
      //     if (agente.status !== 1) return;
      //   } catch (error) {
      //     log.error(`[LOG ATENDIMENTO] ERROR AO DISTRIBUIR Atendimento para agente ${agente.nome}`, error.toString() );
      //   }
      // });
      // ws.wsEvento.on("AgenteStatus", async (agente) => {
      //   // Deus do céu, aqui tb...
      //   try {
      //     if (agente.status !== 1) return;
      //   } catch (error) {
      //     log.error(`[LOG ATENDIMENTO ] ERROR AO DISTRIBUIR Atendimento para agente ${agente.nome}`, error.toString());
      //   }
      // });
      // ws.wsEvento.on("AgenteAdicionado", async (agente) => {
      //   // Tentando distribuir com um console.log?
      //   try {
      //     console.log("TENTANDO DISTRIBUIR", agente);
      //   } catch (error) {
      //     console.error(`[LOG ATENDIMENTO] ERROR AO DISTRIBUIR Atendimento para agente ${agente.nome}`, error.toString());
      //   }
      // });

      if (Config.whatsApi.ativado && Config.whatsApi.clientID !== "SEM") {
        listenerWhatsapp();
      }
      if (Config.csa.ativado && config.csa.id !== "SEM") {
        listenerWebChat();
      }
      if (Config.email_ativo) {
        listenerEmail();
      }
      if (Config.zenvia.ativado && Config.zenvia.clientID !== "SEM") {
        listenerZenvia();
      }
      if (Config.infobip.ativado && Config.infobip.clientID !== "SEM") {
        listenerInfobip();
      }
      if (Config.gupshup.ativado && Config.gupshup.clientID !== "SEM") {
        listenerGupshup();
      }
      if (Config.connectus && Config.connectus.ativado && Config.connectus.clientID !== "SEM") {
        console.log('ATIVOU CONNECTUS')
        listenerConnectus();
      }
      if (Config.facebook.ativado && Config.facebook.clientID !== "SEM") {
        listenerFacebook();
      }
      //#region Rotina de distribuição

      setInterval(async () => {
        try {
          let filas = Ami.getFilas();
          filas = filas.filter((f) => f.queue_type !== 1);
          if (filas && filas.length > 0) {
            for (let f of filas) {
              if (f) {
                carregaAtendimentosPendentes(f);
              }
            }
          }
        } catch (error) {
          log.error("A FILA NAO POSSUIA ATENDIMENTOS PARA DISTRIBUIR");
        }
      }, 3600000);

      //#endregion
    } catch (error) {
      log.error("Erro no start do modulo OMNI", error.toString());
    }
  }, 500);
  //#endregion
  //#region LISTENERS
  listenerEmail = () => {
    mail = require("../../mail_notifier/index");
    exports.mail = mail;
    if (ws.wsEvento) {
      ws.wsEvento.on("mailMessage", async (data) => {
        routerMsg(data);
      });
    }
  };
  listeneraFacebook = () => {
    Facebook = new Facebook(Config.facebook.host, Config.facebook.clientID);
    Facebook.connect();
    exports.Facebook = Facebook;
    //NOVA MENSAGEM
    Facebook.on("LoginEvent", (dados) => {
      console.log(`LOGOU NO FACE`, dados);
    });
    Facebook.on("newFacebookMsg", (dados) => {
      let msg = new formataMsgFace(dados);
      msg = msg.xcontactFormat();
      routerMsg(msg);
    });
    //NOVO ARQUIVO
    Facebook.on("newFacebookMsgFile", (dados, chunk) => {
      try {
        if (dados.Upload === "start") {
          var today = new Date();
          var dir = `/gravacoes/${dados.instanceID}/${today.getFullYear()}/${
            today.getMonth() + 1
          }/${today.getDate()}`;
          var file = `${dir}/Whats_${dados.uid}.${mime.extension(
            dados.mimeType
          )}`;
          fs.mkdirSync(dir, { recursive: true });
          dados.file_name = file;
          arquivos[dados.uid] = {
            dados: dados,
            fs: fs.createWriteStream(file),
          };
        }
        if (dados.Upload === "sending" && chunk) {
          arquivos[dados.uid].fs.write(chunk);
        }
        if (dados.Upload === "end") {
          arquivos[dados.uid].fs.end();
          arquivos[dados.uid].fs.on("finish", () => {
            // arquivos[dados.uid].dados.queueTypeID = 8;
            let msg = new formataMsgFace(arquivos[dados.uid].dados);
            msg = msg.xcontactFormat();
            msg.file_name = arquivos[dados.uid].dados.file_name;
            msg.mimeType = arquivos[dados.uid].dados.mimeType;
            routerMsg(msg);
            delete arquivos[dados.uid];
          });
        }
      } catch (error) {
        log.error("[newFacebookMsgFile] Erro: ", error.toString());
      }
    });
  };
  listenerWebChat = () => {
    console.log("LISTENERWEBCHAT!!!!!!");
    WebChat = new WebChat(Config.csa.host, Config.csa.id);
    WebChat.connect();
    exports.WebChat = WebChat;
    WebChat.on(`newChat`, (dados) => {
      console.log(`ENTROU NO NEWCHAT+++++++++++++++++++++++++++++++++++++++`);
      let msg = new formataMsgWebChat(dados);
      msg = msg.xcontactFormat();
      setQueue(msg, "newChat");
      // routerMsg(msg);
    });
    WebChat.on(`getProtocolo`, (dados, reply) => {
      console.log(
        `ENTROU NO GET PROTOCOLO+++++++++++++++++++++++++++++++++++++++`
      );
      // getProtocolo(dados, reply);
      let obj = {};
      obj.msg = dados;
      obj.reply = reply;
      setQueue(obj, "getProtocolo");
    });
    WebChat.on("message", (dados) => {
      let msg = new formataMsgWebChat(dados);
      msg = msg.xcontactFormat();
      routerMsg(msg);
    });

    WebChat.on("newWebChatFileMsg", (dados, chunk) => {
      try {
        let file;
        dados.mimetype = mime.lookup(dados.file_name);
        dados.fileName = undefined;
        if (dados.Upload === "start") {
          var today = new Date();
          var dir = `/gravacoes/${dados.queue}/${today.getFullYear()}/${
            today.getMonth() + 1
          }/${today.getDate()}`;
          file = `${dir}/WebChat_${dados.uid}.${mime.extension(
            dados.mimetype
          )}`;

          fs.mkdirSync(dir, { recursive: true });
          files[dados.uid] = {
            dados: dados,
            fs: fs.createWriteStream(file),
          };
        }
        if (dados.Upload !== "start") dados.fileName = file;
        if (dados.Upload === "sending" && chunk) {
          files[dados.uid].fs.write(chunk);
        }
        if (dados.Upload === "end") {
          files[dados.uid].fs.end();
          files[dados.uid].fs.on("finish", () => {
            files[dados.uid].dados.msg.queueTypeID = 2;
            let msg = new formataMsgWebChat(files[dados.uid].dados.msg);
            msg = msg.xcontactFormat();
            msg.file_name = files[dados.uid].dados.msg.file_name;
            msg.mimeType = files[dados.uid].dados.msg.mimetype;
            routerMsg(msg);
            delete files[dados.uid];
          });
        }
      } catch (error) {
        log.error("ERRO AO CHEGAR MENSAGEM COM ANEXO" + error.toString());
      }
    });
  };
  listenerZenvia = () => {
    Zenvia = new Zenvia(Config.zenvia.host, Config.zenvia.clientID);
    Zenvia.connect();
    exports.Zenvia = Zenvia;
    //NOVA MENSAGEM
    Zenvia.on("LoginEvent", (dados) => {
      console.log(`ZENVIA`, dados);
    });
    Zenvia.on("newWhats", (dados) => {
      // let msg = new formataMsgZenvia(dados);
      // msg = msg.xcontactFormat();
      dados.queueTypeID = 5;
      setQueue(dados, "routerMsg");
      //  routerMsg(dados);
    });
    //NOVO ARQUIVO
    Zenvia.on("newFileMsgZenvia", (dados, chunk) => {
      try {
        if (dados.Upload === "start") {
          var today = new Date();
          var dir = `/gravacoes/${dados.instanceID}/${today.getFullYear()}/${
            today.getMonth() + 1
          }/${today.getDate()}`;
          var file = `${dir}/Whats_${dados.uid}.${mime.extension(
            dados.mimeType
          )}`;
          fs.mkdirSync(dir, { recursive: true });
          dados.file_name = file;
          arquivos[dados.uid] = {
            dados: dados,
            fs: fs.createWriteStream(file),
          };
        }
        if (dados.Upload === "sending" && chunk) {
          arquivos[dados.uid].fs.write(chunk);
        }
        if (dados.Upload === "end") {
          arquivos[dados.uid].fs.end();
          arquivos[dados.uid].fs.on("finish", () => {
            arquivos[dados.uid].dados.queueTypeID = 5;
            setQueue(arquivos[dados.uid].dados, "routerMsg");
            //routerMsg(arquivos[dados.uid].dados);
            delete arquivos[dados.uid];
          });
        }
      } catch (error) {
        log.error("erro no newfilemsg", error.toString());
      }
    });
  };
  listenerInfobip = () => {
    Infobip = new Infobip(Config.infobip.host, Config.infobip.clientID);
    Infobip.connect();
    exports.Infobip = Infobip;
    //NOVA MENSAGEM
    Infobip.on("LoginEvent", (dados) => {
      console.log(dados);
    });
    Infobip.on("newWhatsInfobip", (dados) => {
      // let msg = new formataMsgZenvia(dados);
      // msg = msg.xcontactFormat();
      dados.queueTypeID = 6;
      routerMsg(dados);
    });
    //NOVO ARQUIVO
    Infobip.on("newFileMsgInfobip", (dados, chunk) => {
      try {
        if (dados.Upload === "start") {
          var today = new Date();
          var dir = `/gravacoes/${dados.instanceID}/${today.getFullYear()}/${
            today.getMonth() + 1
          }/${today.getDate()}`;
          var file = `${dir}/Whats_${dados.uid}.${mime.extension(
            dados.mimeType
          )}`;
          fs.mkdirSync(dir, { recursive: true });
          dados.file_name = file;
          arquivos[dados.uid] = {
            dados: dados,
            fs: fs.createWriteStream(file),
          };
        }
        if (dados.Upload === "sending" && chunk) {
          arquivos[dados.uid].fs.write(chunk);
        }
        if (dados.Upload === "end") {
          arquivos[dados.uid].fs.end();
          arquivos[dados.uid].fs.on("finish", () => {
            arquivos[dados.uid].dados.queueTypeID = 6;
            routerMsg(arquivos[dados.uid].dados);
            delete arquivos[dados.uid];
          });
        }
      } catch (error) {
        log.error("erro no newfilemsg", error.toString());
      }
    });
  };
  async function downloadAnexo(url, dados) {
    try {
      return new Promise(async (resolve, reject) => {
        try {
          let data = dados;
          let lastFile = {};
          //let retorno = await axios.get(`https://10.11.31.6/clientes/teta.txt`, { responseType: "arraybuffer", httpsAgent: agent });
          const downloader = new Downloader({
            url: url,
            directory: dados.diretorio,
            maxAttempts: 10,
            timeout: 20000,
            onResponse: (response) => {
              //Now you can do something with the response, like check the headers
              if (response.headers["content-length"] == 0) {
                console.log("File is zero bytes");
                lastFile.size = response.headers["content-length"];
                console.log(`resposta`, response);
                //throw new Error('Arquivo zerado');
                return true; //If you return false, the download process is stopped, and downloader.download() is resolved.
              }

              //Returning any other value, including undefined, will tell the downloader to proceed as usual.
            },
            onBeforeSave: (name) => {
              console.log(`The file name is: ${name}`);
              lastFile.name = name;
              data.file_name = `${dados.diretorio}/${name}`;
              data.name = name;
              let split = name.split(".");
              data.ext = split[split.length - 1];
              data.mimeType = mime.lookup(data.ext);
              if (!data.mimeType) data.mimeType = "application/octet-stream";
              //If you return a string here, it will be used as the name(that includes the extension!).
            },
            shouldStop: function (e) {
              if (e.statusCode && e.statusCode === 404) {
                console.log(`DEU 404`);
                return true;
              }
            },
          });
          await downloader.download();
          if (lastFile.size == 0) {
            //downloader.maxAttempts = 3;
            setTimeout(async () => {
              console.log(`VAMOS BAIXAR DNV`);
              await downloader.download();
              resolve(data);
            }, 20000);
          } else {
            resolve(data);
          }
        } catch (error) {
          console.error(`DEU PAU`, error);
          reject(error);
        }
      });
    } catch (error) {
      console.error(error);
      reject(error);
    }

    let lastFile = {};
  }
  listenerConnectus = () => {
    Connectus = new Connectus(Config.connectus.host, Config.connectus.clientID);
    Connectus.connect();
    exports.Connectus = Connectus;
    Connectus.on("LoginEvent", (dados) => {
      console.log("CONECTAMOS NA CONNECTUS", dados);
    });
    Connectus.on("newMessageConnectus", (dados) => {
      console.log('DADOS', dados)
      dados.queueTypeID = 10;
      setQueue(dados, "routerMsg");
    });
  }
  listenerGupshup = () => {
    Gupshup = new Gupshup(Config.gupshup.host, Config.gupshup.clientID);
    Gupshup.connect();
    exports.Gupshup = Gupshup;
    //NOVA MENSAGEM
    Gupshup.on("LoginEvent", (dados) => {
      console.log("CONECTAMOS NA GUP", dados);
    });
    Gupshup.on("message_ack", async (dados) => {
      try {
        log.debug(`[listenerGupshup] [message_ack] Dados: `, JSON.stringify(dados))
        let status = dados.payload.type;
        if (dados.payload.type === "sent") status = "sended";
        if (dados.payload.type === "read") status = "seen";

        // Em caso de falha a gup envia o código do erro que estou gravando nos dados_adicionais para depois notificar o agente
        let dados_adicionais = (dados.payload.payload && dados.payload.payload.code) ? 'gup:'+dados.payload.payload.code : undefined

        const MsgUpdate = { status: status, dados_adicionais }
        const MsgWhere = { mailMessageID: dados.payload.messageId }
        atendimentoMQ.add(MsgUpdate, MsgWhere)        

        // Essa parte foi movida para o listener atendimentoMQ.on('success')
        // Fiz dessa forma pois mesmo com async acontecia de um ack que vinha depois era salvo antes na base deixando o status da mensagem errado
        // const msgUpdate = await AtendimentoMensagem.query
        //   .require(false)
        //   .where({ mailMessageID: dados.payload.messageId })
        //   .update({ status: status, dados_adicionais })

        // if(msgUpdate && msgUpdate.length > 0) {
        //   const msg = msgUpdate[0]
        //   log.info(`[listenerGupshup] [message_ack] Mensagem ${msg.id} do atendimento ${msg.idAtendimento} status atualizado para = ${status}`)
        //   const atendimento = await Atendimento.fetchById(msg.idAtendimento);
        //   myEmitter.emit("SendSuccess", {
        //     atendimento: atendimento,
        //     message: msg,
        //   });
        // } else {
        //   log.warn(`[listenerGupshup] [message_ack] Nenhuma mensagem encontrada para o ID = ${dados.payload.messageId}`)
        // }        
      } catch (error) {
        log.error(`[listenerGupshup] [message_ack] Erro: `, error.toString());
      }
    });
    Gupshup.on("error_gupshup", async (dados) => {
      try {
        console.log("error_gupshup", dados);

        let msg = await AtendimentoMensagem.query
          .first()
          .require(true)
          .where({ mailMessageID: dados.payload.messageId })
          .fetch();

        const atendimento = await Atendimento.fetchById(msg.idAtendimento);
        myEmitter.emit("SendSuccess", {
          errorMsg:
            "Ocorreu um erro ao enviar a mensagem:\nJanela de 24h não está aberta",
          atendimento: atendimento,
          message: msg,
        });
      } catch (error) {
        console.error("ERROR error_gupshup", error);
      }
    });

    Gupshup.on("newWhatsGupshup", async (dados) => {
      // let msg = new formataMsgZenvia(dados);
      // msg = msg.xcontactFormat();
      dados.mailMessageID = dados.gupshupID;
      if (dados.repliedIdMsg) {
        dados.quotedMsg = {};
        let msg = await AtendimentoMensagem.query
          .first()
          .require(false)
          .where({ mailMessageID: dados.repliedIdMsg })
          .fetch();
        console.log(`msg==============`, msg);
        if (msg) {
          dados.quotedMsg.body = msg.texto;
          let anexo = await MensagemAnexos.query
            .first()
            .require(false)
            .where({ idMensagem: msg.id })
            .fetch();
          if (anexo) {
            dados.quotedMsg.caminho = anexo.caminho;
            dados.quotedMsg.mimeType = anexo.mimeType;
          }
        }
      }
      console.log(`NEWGUPSHUP`, dados);
      dados.queueTypeID = 7;
      setQueue(dados, "routerMsg");
      //routerMsg(dados)

    });
    //NOVO ARQUIVO
    Gupshup.on("newFileMsgGupshup", async (dados, chunk) => {
      try {
        var today = new Date();
        var dir = `/gravacoes/${dados.instanceID}/${today.getFullYear()}/${
          today.getMonth() + 1
        }/${today.getDate()}`;
        dados.diretorio = dir;
        console.log(dados);

        if (dados.Upload === "start") {
          dados.nomeArquivo =
            dados.url.split("=")[dados.url.split("=").length - 1];
          // if (dados.mailMessageID == 'audio') dados.nomeArquivo = dados.url.split('/')[dados.url.split('/').length - 1];
          dados.mailMessageID = dados.gupshupID;
          //dados.extOld = dados.ext;
          // if (dados.ext == 'opus') {
          //     dados.mimeType = 'audio/ogg; codecs=opus';
          //     dados.ext = `ogg`;
          // }
          const aux = Config.gupshup.host.split("//");
          const url = aux[1].split(":")[0];
          try {
            let retorno = await downloadAnexo(
              `http://${url}/download/${dados.name}`,
              dados
            );
            if (retorno) {
              dados.queueTypeID = 7;
              dados.name = dados.fromName;
              return setQueue(dados, "routerMsg");
            }
          } catch (error) {
            console.error(`ERRO AO BAIXAR OU ESCREVER ARQUIVO`, error);
          }
        }
      } catch (error) {
        log.error("erro no newfilemsg", error.toString());
      }
    });
  };
  listenerWhatsapp = () => {
    let msgs = [];
    WhatsApp = new WhatsApp(Config.whatsApi.host, Config.whatsApi.clientID);
    WhatsApp.connect();
    exports.WhatsApp = WhatsApp;
    //NOVA MENSAGEM
    WhatsApp.on("LoginEvent", (dados) => {
      console.log(dados);
    });
    WhatsApp.on("message_ack", async (dados) => {
      try {
        console.log(`ack`, dados.message.id._serialized);
        let status = null;
        if (dados.ack === 1) status = "sended";
        if (dados.ack === 2) status = "delivered";
        if (dados.ack === 3) status = "seen";
        let msg = await AtendimentoMensagem.query
          .first()
          .require(true)
          .where({ mailMessageID: dados.message.id._serialized })
          .where(AtendimentoMensagem.where.not({ status: "deleted" }))
          .update({ status: status });
        // msg.save();
        const atendimento = await Atendimento.fetchById(msg.idAtendimento);
        // const { verificaAtendimentoAgente } = require('../../redis');
        // verificaAtendimentoAgente(atendimento.ultimoAgente, atendimento.id)
        myEmitter.emit("SendSuccess", {
          atendimento: atendimento,
          message: msg,
        });
      } catch (error) {
        console.error(error);
      }
    });
    WhatsApp.on("newFileMsgQuoted", async (dados, chunk) => {
      if (dados.Upload !== `end`) {
        ProcessaNewFileMsgQuoted(dados, chunk);
      } else {
        let index = msgs.findIndex((m) => m.uid == dados.msg.uid);
        if (index == -1) return console.log(`NAO ACHEI PREULA`);
        let msg = msgs.splice(index, 1)[0];
        if (!msg) return console.log(`NAO ACHEI PREULA2`);
        let anexo = await ProcessaNewFileMsgQuoted(dados, chunk);
        msg.quotedMsg = {};
        msg.quotedMsg.caminho = anexo.file_name;
        msg.quotedMsg.type = anexo.type;
        msg.quotedMsg.mimeType = anexo.mimeType;
        msg.quotedMsg.legenda = anexo.caption;
        console.log(`VAMOS VER O msg`, msg);
        setQueue(msg, "routerMsg");
      }
    });
    WhatsApp.on("newWhats", async (dados) => {
      try {
        let msg = new formataMsgWhats(dados);
        msg = msg.xcontactFormat();
        if (msg.repliedIdMsg) {
          msg.quotedMsg = {};
          let msg1 = await AtendimentoMensagem.query
            .first()
            .require(false)
            .where({ mailMessageID: dados.repliedIdMsg })
            .fetch();
          if (msg1) {
            msg.quotedMsg.body = msg1.texto;
            let anexo = await MensagemAnexos.query
              .first()
              .require(false)
              .where({ idMensagem: msg1.id })
              .fetch();
            if (anexo) {
              msg.quotedMsg.caminho = anexo.caminho;
              msg.quotedMsg.mimeType = anexo.mimeType;
            }
            setQueue(msg, "routerMsg");
          } else {
            setQueue(msg, "routerMsg");
          }
        } else {
          setQueue(msg, "routerMsg");
        }
        // if (msg.quotedMsg) {
        //     console.log(`TINHA QUOTED`);
        //     if (msg.quotedMsg.type == 'chat') {
        //         console.log(`TINHA QUOTED ERA TEXTO`);
        //         setQueue(msg, 'routerMsg');
        //     } else {
        //         console.log(`TINHA QUOTED ERA ARQUIVO`);
        //         msgs.push(msg);
        //     }
        // } else {
        //     setQueue(msg, 'routerMsg');
        // }
        // routerMsg(msg);
      } catch (error) {
        console.error(error);
      }
    });
    //NOVO ARQUIVO

    WhatsApp.on("newFileMsg", (dados, chunk) => {
      try {
        console.log(`ENTROU AQUI NO ARQUIVO`);
        if (dados.Upload === "start") {
          dados.msg.idCliente = dados.msg.sender
            ? dados.msg.sender.split("@")[0]
            : dados.msg.from;
          dados.msg.nomeCliente = dados.msg.from.verifiedName
            ? dados.msg.from.verifiedName
            : dados.msg.from.pushname;
          WhatsApp.socket.emit("read", {
            instanceID: dados.msg.instanceID,
            chatId: dados.msg.sender.split("@")[0],
            id: dados.msg.id,
          });
          console.log(`vamos ver`, dados);
          var today = new Date();
          var dir = `/gravacoes/${
            dados.msg.instanceID
          }/${today.getFullYear()}/${today.getMonth() + 1}/${today.getDate()}`;
          var file = `${dir}/Whats_${dados.uid}.${mime.extension(
            dados.msg.mimetype
          )}`;
          fs.mkdirSync(dir, { recursive: true });
          dados.msg.file_name = file;
          files[dados.uid] = {
            dados: dados,
            fs: fs.createWriteStream(file),
          };
        }
        if (dados.Upload === "sending" && chunk) {
          files[dados.uid].fs.write(chunk);
        }
        if (dados.Upload === "end") {
          files[dados.uid].fs.end();
          let that = this;
          files[dados.uid].fs.on("finish", async function () {
            let msg = new formataMsgWhats(files[dados.uid].dados.msg);
            msg = msg.xcontactFormat();
            msg.file_name = files[dados.uid].dados.msg.file_name;
            msg.mimeType = files[dados.uid].dados.msg.mimetype;
            console.log("AQUIIII", msg);
            //routerMsg(msg);

            // routerMsg(msg);
            if (msg.repliedIdMsg) {
              console.log(`tinha replied--------------------`);
              msg.quotedMsg = {};
              let msg1 = await AtendimentoMensagem.query
                .first()
                .require(false)
                .where({ mailMessageID: msg.repliedIdMsg })
                .fetch();
              console.log(`msg==============`, msg);
              if (msg1) {
                msg.quotedMsg.body = msg1.texto;
                let anexo = await MensagemAnexos.query
                  .first()
                  .require(false)
                  .where({ idMensagem: msg1.id })
                  .fetch();
                if (anexo) {
                  msg.quotedMsg.caminho = anexo.caminho;
                  msg.quotedMsg.mimeType = anexo.mimeType;
                }
                setQueue(msg, "routerMsg");
              } else {
                setQueue(msg, "routerMsg");
              }
            } else {
              setQueue(msg, "routerMsg");
            }

            delete files[dados.uid];
          });
        }
      } catch (error) {
        log.error("erro no newfilemsg", error.toString());
      }
    });
  };

  //#endregion

  //#region METODOS AUXILIARES
  exports.AddHistoricoTransferencia = async (atendimento, tipo) => {
    try {
      let dados = atendimento.dadosAdicionais;
      console.log(`DADOS`, dados);
      if (!dados) dados = {};
      if (typeof dados != "object")
        dados = JSON.parse(atendimento.dadosAdicionais);
      console.log(`DADOS PARSE`, dados);
      if (dados) {
        console.log(`aquiiiii`, dados);
        if (!dados.transfers) dados.transfers = [];
        dados.transfers.push({
          tipo: tipo,
          remetente: atendimento.agenteRemetente,
          destino:
            tipo == "fila" ? atendimento.queue : atendimento.ultimoAgente,
          data: new Date(),
        });
        new Atendimento(atendimento).save();
        return atendimento;
      }
    } catch (error) {
      log.error('[AddHistoricoTransferencia] Erro: ', error.toString());
    }
  };
  ProcessaNewFileMsgQuoted = async (dados, chunk) => {
    return new Promise(async (resolve, reject) => {
      try {
        if (dados.Upload === "start") {
          var today = new Date();
          var dir = `/gravacoes/${
            dados.msg.instanceID
          }/${today.getFullYear()}/${today.getMonth() + 1}/${today.getDate()}`;
          var file = `${dir}/Whats_${dados.uid}.${mime.extension(
            dados.msg.mimetype
          )}`;
          fs.mkdirSync(dir, { recursive: true });
          dados.msg.file_name = file;
          files[dados.uid] = {
            dados: dados,
            fs: fs.createWriteStream(file),
          };
        }
        if (dados.Upload === "sending" && chunk) {
          files[dados.uid].fs.write(chunk);
        }
        if (dados.Upload === "end") {
          files[dados.uid].fs.end();
          let that = this;
          files[dados.uid].fs.on("finish", function () {
            if (!files[dados.uid]) reject(`nao tem mais o arquivo`);
            let msg = files[dados.uid].dados.msg;
            msg.file_name = files[dados.uid].dados.msg.file_name;
            msg.mimeType = files[dados.uid].dados.msg.mimetype;
            console.log("AQUIIII", msg);
            resolve(msg);
            delete files[dados.uid];
          });
        }
      } catch (error) {
        console.error(error);
        reject(error);
      }
    });
  };
  pegaFilasParaDistribuir = async () => {
    try {
      let filas = Ami.getFilas();
      filas = filas.filter((f) => f.queue_type !== 1);
      if (filas && filas.length > 0) {
        for (let f of filas) {
          if (f) {
            await distribuiAtendimento(f);
          }
        }
      }
    } catch (error) {
      log.error("A FILA NAO POSSUIA ATENDIMENTOS PARA DISTRIBUIR");
    }
  };
  distribuiDaFila = async (fila) => {
    try {
      await distribuiAtendimento(fila);
    } catch (error) {
      console.error(error);
    }
  };
  distribuiParaAgente = async (agente) => {
    try {
      let filas = Ami.getFilasLogadasDoAgente(agente.ramal);
      if (filas && filas.length > 0) {
        const fila = filas.find((f) => f.nome == agente.fila);
        if (!fila) return;
        if (fila.queue_type !== 1) {
          let atendimentos = fila.ligacoes.sort((a, b) => a.id - b.id);
          let atendimento = atendimentos[atendimentos.length - 1];
          if (!atendimento) return;
          // myEmitter.emit('removeAguardando', { fila: fila, atendimento: atendimento });
          // myEmitter.emit('filaStatus', { atendimento: atendimento, tipo: null });
          // atendimento.ultimoAgente = agente.nome;
          // await new Atendimento(atendimento).save();
          // console.log(`VAMOS ENVIAR PARA O AGENTE`, atendimento);
          const socketAgente = ws.getSocketAgenteByFullName(agente.nome);
          if (socketAgente && socketAgente.web) {
            await enviaInviteParaAgente(atendimento, agente.nome);
          } else {
            await distribuiAtendimentoOld(agente, atendimento);
          }
          //addArrayMedias(atendimento, fila);
          // log.error("CONSEGUIMOS DISTRIBUIR", fila.ligacoes.length)
          //log.error(atendimento.id)
          return atendimento;
        }
      }
      return;
    } catch (error) {
      console.error(error);
    }
  };
  getAgenteStatus = async (agente) => {
    //let ag = await Agente.fetchByFullname(agente.nome);
    //agente.max_chat_atende = ag.max_chat_atende;
    // O Atendimento Ativo pode ter sido redirecionado pela URA ou Bot
    var atendimentos = await Atendimento.query
      .require(false)
      .where({ ultimoAgente: agente.nome })
      .where({ status: "Entrou" })
      .fetch();
    if (!atendimentos) atendimentos = [];
    var qtd = agente.max_chat_atende - atendimentos.length;
    //Se ainda pode pegar e nao estiver em pausa vamos distribuir
    if (qtd > 0 && agente.pausa === 0) return qtd;

    return false;
  };
  carregaAtendimentosPendentes = async (fila) => {
    try {
      let atendimentoAux = await Atendimento.query
        .require(false)
        .where({ ultimoAgente: null })
        .where({ status: "Entrou" })
        .where({ queue: fila.nome })
        .fetch();
      fila.ligacoes = atendimentoAux;
    } catch (error) {
      log.error(`[ERRO AO PEGAR OS ATENDIMENTOS PENDENTES]`, error);
    }
  };
  distribuiAtendimento = async (fila) => {
    try {
      //Ordenando por protocolo
      if (!fila.ligacoes) fila.ligacoes = [];
      let atendimentos = fila.ligacoes.sort((a, b) => a.id - b.id);
      //log.error(`VAMOS DISTRIBUIR O PRIMEIRO DA FILA AINDA TEMOS`, fila.ligacoes.length)
      //Removendo o primeiro da fila
      let atendimento = atendimentos[atendimentos.length - 1];
      if (!atendimento) return;
      //log.error(atendimento.id)
      let retorno = await sortearAgente(atendimento);
    } catch (error) {
      log.error(error);
    }
  };
  addArrayMedias = (atendimento, fila) => {
    atendimento.holdtime =
      (new Date().getTime() - new Date(atendimento.dataIni).getTime()) / 1000;
    atendimento.dataDistribuicao = new Date();
    fila.ligacoes_atendidas.push(atendimento);
    myEmitter.emit("filaStatus", { atendimento: atendimento, tipo: "" });
  };
  exports.aceitarAtendimento = async (protocolo, agente) => {
    try {
      const atendimento = await Atendimento.fetchById(protocolo);
      const fila = await Ami.getFila(atendimento.queue);
      if (atendimento.ultimoAgente)
        return {
          error: true,
          message: "Atendimento ja admitido por outro agente",
        };
      atendimento.ultimoAgente = agente;
      await atendimento.save();
      if (!fila.ligacoes) fila.ligacoes = [];
      console.log("VAMOS ACEITAR O ATENDIMENTO", fila.ligacoes);
      const idx = fila.ligacoes.findIndex((a) => a.id == atendimento.id);
      fila.ligacoes.splice(idx, 1);
      myEmitter.emit("filaStatus", { atendimento: atendimento, tipo: null });
      myEmitter.emit("removeAguardando", {
        fila: fila,
        atendimento: atendimento,
      });
      myEmitter.emit("removeAtendimentoNaFila", {
        fila: atendimento.queue,
        agente: agente,
        atendimentoId: atendimento.id,
        nome: atendimento.fromName,
        numero: atendimento.fromID,
        data: new Date(),
        tipo: "atendido",
      });
      atendimento.ultimoAgente = agente;
      addArrayMedias(atendimento, fila);
      return atendimento;
    } catch (error) {
      console.error(error);
    }
  };
  exports.recusarAtendimento = async (atendimento, agente) => {
    try {
      const fila = await Ami.getFila(atendimento.queue);
      if (!fila.ligacoes) fila.ligacoes = [];
      // fila.ligacoes.unshift(atendimento)
      const at = fila.ligacoes.find((l) => l.id == atendimento.id);
      if (at) {
        const timer = this.timers.find(t=>t.id == at.id)
        if (timer)clearTimeout(timer.timer);
        at.processando = false;
      }
      myEmitter.emit("filaStatus", { atendimento: atendimento, tipo: null });
      return true;
    } catch (error) {
      console.error(error);
    }
  };
  enviaInviteParaAgente = (atendimento, agenteName) => {
    try {
      console.log("enviaInviteParaAgente", atendimento.id);
      myEmitter.emit("inviteAtendimento", { atendimento, agente: agenteName });
      myEmitter.emit("FilaInviteAtendimento", {
        fila: atendimento.queue,
        agente: agenteName,
        data: new Date(),
      });
    } catch (error) {
      console.error(error);
    }
  };
  distribuiAtendimentoOld = async (sorteado, atendimento) => {
    try {
      let fila = await Ami.getFila(atendimento.queue);
      myEmitter.emit("filaStatus", { atendimento: atendimento, tipo: null });
      myEmitter.emit("removeAguardando", {
        fila: fila,
        atendimento: atendimento,
      });
      atendimento.ultimoAgente = sorteado.nome;
      if (!fila.ligacoes) fila.ligacoes = [];
      const idx = fila.ligacoes.findIndex((a) => a.id === atendimento.id);
      fila.ligacoes.splice(idx, 1);
      await new Atendimento(atendimento).save();
      addArrayMedias(atendimento, fila);
      await enviaParaAgente(atendimento);
      return;
    } catch (error) {
      log.error("ERRO NO distribuiAtendimentoOld AGENTE", error);
    }
  };
  sortearAgente = async (atendimento) => {
    try {
      console.log("SORTEAR AGENTE", atendimento.id);
      let fila = await Ami.getFila(atendimento.queue);
      let ft = new FilaTemp(fila);
      let agentes = await ft.getAgentesDisponiveis();
      agentes = await agentes.filter((a) => {
        if (a.pausa === 0 && a.status !== 0) {
          return a;
        }
      });
      if (agentes.length > 0) {
        const sorteado = await agentes[
          Math.floor(Math.random() * agentes.length)
        ];
        console.log("SORTEADO", atendimento.id);
        let auxA = [];
        auxA = await Atendimento.query
          .require(false)
          .where({ ultimoAgente: sorteado.nome })
          .where({ status: "Entrou" })
          .where(Atendimento.where.notEqual({ queueTypeID: 1 }))
          .fetch();
        let count = sorteado.max_chat_atende - auxA.length;
        console.log("NOME", sorteado.nome);
        console.log("QTDMSG", count);
        if (sorteado && count > 0) {
          const socketAgente = ws.getSocketAgenteByFullName(sorteado.nome);
          if (socketAgente && socketAgente.web) {
            await enviaInviteParaAgente(atendimento, sorteado.nome);
          } else {
            await distribuiAtendimentoOld(sorteado, atendimento);
          }
        }
        myEmitter.emit("filaStatus", { atendimento: atendimento, tipo: null });
        if (!fila.ligacoes) fila.ligacoes = [];
        return;
      }
      myEmitter.emit("filaStatus", { atendimento: atendimento, tipo: null });
      if (!fila.ligacoes) fila.ligacoes = [];
      return;
    } catch (error) {
      console.error("ERRO NO SORTEAR AGENTE", error);
    }
  };
  votaPesquisa = async (atendimento, cliente, msg) => {
    try {
      let fila = await Ami.getFila(atendimento.queue);
      atendimento.status = "Encerrado";
      atendimento.dataFim = new Date(moment.tz(config.servidor.timezone));
      let at = await new Atendimento({
        id: atendimento.id,
        status: "Encerrado",
        dataFim: atendimento.dataFim,
      }).save({ require: false });
      this.calculosFila(fila, at);
      let auxFromID = atendimento.fromID.split(`@`)[0];
      console.log(`AQUI`, atendimento.id);
      await new PesquisaNota({
        idPesquisa: fila.id_pesquisa,
        nota: msg.texto,
        fila: fila.nome,
        agente: atendimento.ultimoAgente,
        src: auxFromID,
        uniqueid: JSON.stringify(atendimento.id),
      }).save({ require: false });
      this.autoReply(atendimento, undefined, 6);
      if (atendimento.queueTypeID === 2) {
        var aux = {
          protocolo: atendimento.id,
          uid: atendimento.fromID,
          event: "EncerrarAtendimento",
          xcontactID: config.csa.id,
          action: "ClientChatMessage",
          Msg: "O seu atendimento foi encerrado!",
          queue: atendimento.queue,
        };
        setTimeout(() => {
          WebChat.socket.emit("message", JSON.stringify(aux));
        }, 5000);
      }
      if (atendimento.queueTypeID === 3) {
        let instance = atendimento.queueFrom
          ? atendimento.queueFrom
          : atendimento.queue;
        WhatsApp.socket.emit(
          `deleteChat`,
          {
            clientID: config.whatsApi.clientID,
            instanceID: instance,
            chatId: atendimento.fromID,
          },
          async (retorno) => {
            console.log(`RETORNOU`, retorno);
          }
        );
      }
    } catch (error) {
      log.error("Erro ao votar pesquisa", error);
    }
  };
  verificaTurno = async (cliente, atendimento) => {
    //metodo para verificar turno
    try {
      let fila = await Ami.getFila(atendimento.queue);
      let ft = new FilaTemp(fila);
      ft.fila.filaTurnos = await ft.verificaTurno();

      if (!fila.filaTurnos) fila.filaTurnos = [];
      if (fila.filaTurnos.length > 0) {
        let filaTurnosAux = [];
        for (let t of fila.filaTurnos) {
          filaTurnosAux.push(t.TurnoID);
        }
        let verificaHorario = await Horarios.verificarTurnos(filaTurnosAux);
        if (!verificaHorario) {
          let fila = await Ami.getFila(atendimento.queue);
          myEmitter.emit("removeAguardando", {
            fila: fila,
            atendimento: atendimento,
          });
          await new Atendimento({
            id: atendimento.id,
            status: "Encerrado",
            dataFim: new Date(moment.tz(config.servidor.timezone)),
          }).save({ require: false });
          this.autoReply(atendimento, { $NOME_CLIENTE: cliente.nome }, 5);
          return false;
        } else {
          return true;
        }
      } else {
        return true;
      }
    } catch (error) {
      log.error("Erro no verifica turnos", error);
    }
    return true;
  };
  exports.saveMsg = async (msg, files) => {
    try {
      delete msg.dataHora
      var m = await new AtendimentoMensagem(msg).save();
      console.log(`MENSAGEM2`, m);
      if (files) {
        for (let file of files) {
          if (!m.anexos) m.anexos = [];
          let anexo = await new MensagemAnexos({
            idMensagem: m.id,
            caminho: file.caminho,
            mimeType: file.mimeType,
          }).save();
          m.anexos.push(anexo);
        }
      }
      return m;
    } catch (error) {
      console.error("erro ao salvar msg", error);
    }
  };

  exports.addAguardando = async (fila, atendimento) => {
    try {
      myEmitter.emit("filaStatus", { atendimento: atendimento, tipo: null });
      if (!fila.ligacoes) fila.ligacoes = [];
      let index = await fila.ligacoes.findIndex(
        (value) => value.id === atendimento.id
      );
      if (index !== -1) {
        fila.ligacoes.splice(index, 1, atendimento);
        fila.ligacoes.sort((a, b) => a.id - b.id);
      } else {
        let numero = atendimento.fromID
        if (atendimento.fromID.indexOf("@") !== -1) numero = atendimento.fromID.split("@")[0]
        myEmitter.emit("filaAddAtendimento", {
          fila: atendimento.queue,
          data: new Date(),
          nome: atendimento.fromName,
          numero: numero,
          atendimentoId: atendimento.id,
        });
        atendimento.posicao = fila.ligacoes.length + 1;
        fila.ligacoes.push(atendimento);
        fila.ligacoes.sort((a, b) => a.id - b.id);
      }
      autoEncerramento.addTransbordo(atendimento);
      // pegaFilasParaDistribuir();
    } catch (error) {
      log.error("erro ao adicionar no aguardando", error);
    }
  };
  addAtendimentoFila = (fila, atendimento) => {
    if (!fila.ligacoes) fila.ligacoes = [];
    fila.ligacoes.push(atendimento);
  };
  exports.calculosFila = (fila, atendimento) => {
    try {
      if (!fila.ligacoes_atendidas) fila.ligacoes_atendidas = [];
      if (!fila.atendimentos) return;
      let ligacao = fila.ligacoes_atendidas.find(
        (a) => a.id === atendimento.id
      );
      if (!ligacao) return;
      // ligacao.holdtime = (atendimento.dataFim.getTime() - ligacao.saiuAguardando.getTime()) / 1000;
      ligacao.talktime =
        (atendimento.dataFim.getTime() - ligacao.dataDistribuicao.getTime()) /
        1000;
      //fila.ligacoes_atendidas.push(ligacao);
      myEmitter.emit("filaStatus", { atendimento: atendimento, tipo: "" });
    } catch (error) {
      log.error(`erro ao calcular`, error);
    }
  };
  enviaParaAgenteNew = (atendimento, msg = null) => {
    let obj = {};
    obj.atendimento = atendimento;
    obj.msg = msg;
    setQueue(obj, "enviaParaAgente");
  };
  enviaParaAgente = (atendimento, msg = null) => {
    return new Promise((resolve, reject) => {
      try {
        console.log(`ENVIAPARAAGENTE`, atendimento);
        if (msg) {
          let aux = {};
          aux.message = msg;
          aux.atendimento = atendimento;
          myEmitter.emit("newMessage", aux);
          autoEncerramento.verificaTimer(null, atendimento);
          resolve();
        } else {
          autoEncerramento.verificaTimer(null, atendimento);
          myEmitter.emit("addAtendimento", atendimento);
          resolve();
        }
      } catch (error) {
        log.error(`[ENVIAPARAAGENTE ERROR]`, error);
        reject();
      }
    });
  };
  exports.autoReply = async (atendimento, trocas, tipo) => {
    //Este metodo e responsavel pelas respostas automaticas do omni...
    var Query = await db.query(
      'SELECT texto FROM public."queueRespostasAutomaticas" where fila = $1 AND "idRespostaTipo" = $2',
      [atendimento.queue, tipo]
    );
    if (Query.rowCount > 0) {
      var texto = Query.rows[0].texto;
      if (trocas) {
        if (typeof trocas === "object") {
          Object.entries(trocas).forEach(([key, value]) => {
            texto = texto.split(key).join(value);
          });
        }
      }
      var fila = await Fila.query
        .require(true)
        .first()
        .where({ name: atendimento.queue })
        .fetch();
      let confige = fila.emailConfig;

      var filaGup = await Fila.query
        .require(true)
        .first()
        .where({
          name: atendimento.queueFrom
            ? atendimento.queueFrom
            : atendimento.queue,
        })
        .fetch();
      let configGup = filaGup.emailConfig;
      var lastMsg = null;
      if (atendimento.queueTypeID === 4) {
        lastMsg = await AtendimentoMensagem.query
          .require(true)
          .first()
          .where({ idAtendimento: atendimento.id })
          .orderBy(`id DESC`)
          .fetch();
      }

      let auxEmail = {};
      auxEmail.emails = atendimento.email;
      auxEmail.from = atendimento.ultimoAgente;
      let message = await this.saveMsg(
        {
          idAtendimento: atendimento.id,
          texto: texto,
          inOut: 3,
          agente: "Xcontact",
          mailMessageID:
            atendimento.queueTypeID === 4 && lastMsg
              ? lastMsg.mailMessageID
              : "Xcontact",
          dados_adicionais:
            atendimento.queueTypeID === 4 ? JSON.stringify(auxEmail) : null,
        },
        null
      );
      if (atendimento.queueTypeID === 3) {
        WhatsApp.sendMessage({
          instanceID:
            atendimento.queueFrom !== null
              ? atendimento.queueFrom
              : atendimento.queue,
          chatId: atendimento.fromID,
          msg: texto,
        });
      }
      if (atendimento.queueTypeID === 5) {
        return Zenvia.socket.emit(
          "newWhatsMsgZenvia",
          {
            zenviaID: confige.zenviaID,
            from: confige.from,
            to: atendimento.fromID,
            text: texto,
          },
          (retorno) => {}
        );
      }
      if (atendimento.queueTypeID === 6) {
        return Infobip.socket.emit(
          "newWhatsMsgInfobip",
          {
            baseurl: confige.baseurl,
            authorization: confige.authorization,
            to: atendimento.fromID,
            text: texto,
          },
          (retorno) => {}
        );
      }
      if (atendimento.queueTypeID === 7) {
        return Gupshup.socket.emit(
          "newWhatsMsgGupshup",
          {
            apikey: configGup.apikey,
            source: configGup.source,
            to: atendimento.fromID,
            text: texto,
          },
          (retorno) => {
            log.error(`GUPSHUP MSG`, retorno);
          }
        );
      }
      if (atendimento.queueTypeID === 10) {
        return this.Connectus.socket.emit("sendMsgConnectus", 
        {
          dst_number: atendimento.fromID,
          src_number: configGup.dst_number,
          id_client: configGup.id_client, 
          sms_content: texto
        })
      }
      if (atendimento.queueTypeID === 8) {
        return Facebook.socket.emit(
          "sendMsg",
          {
            pagetoken: confige.pagetoken,
            sender_psid: atendimento.fromID,
            text: texto,
          },
          (retorno) => {
            console.log(`SEND FACE MSG RETORNO `, retorno);
          }
        );
      }
      if (atendimento.queueTypeID === 2) {
        if (tipo === 2) {
          return WebChat.socket.emit("sendMsgChat", {
            queue: fila.nome,
            uid: atendimento.fromID,
            msg: message,
            clientID: config.csa.id,
            protocolo: atendimento.id,
            event: "EncerrarAtendimento",
          });
        }
        return WebChat.socket.emit("sendMsgChat", {
          queue: fila.nome,
          uid: atendimento.fromID,
          msg: message,
          clientID: config.csa.id,
          protocolo: atendimento.id,
        });
      }
      if (atendimento.queueTypeID === 4) {
        this.addEmail(atendimento, auxEmail);

        return mail.respondeEmail({
          queue: atendimento.queue,
          remetente: atendimento.fromID,
          message: texto,
          protocolo: atendimento.id,
          mailMessageID: lastMsg ? lastMsg.mailMessageID : null,
          assunto: atendimento.assunto,
          event: "QueueSemAgentes",
        });
      }
      
    }
  };
  exports.removeTimerTransbordo = async (atendimento) => {
    autoEncerramento.removeTimerTransbordo(atendimento);
  };

  exports.ProcessPesquisa = async (atendimento) => {
    try {
      var fila = await Ami.getFila(
        atendimento.queueFrom !== null
          ? atendimento.queueFrom
          : atendimento.queue
      );
      var f = await Fila.query
        .require(true)
        .first()
        .where({ name: atendimento.queue })
        .fetch();
      let confige = f.emailConfig;

      var filaGup = await Fila.query
        .require(true)
        .first()
        .where({
          name: atendimento.queueFrom
            ? atendimento.queueFrom
            : atendimento.queue,
        })
        .fetch();
      let configGup = filaGup.emailConfig;
      if (f.PesquisaID && f.PesquisaID > 0) {
        // Pega a pesquisa
        var pesquisa = await Pesquisa.fetchById(f.PesquisaID);
        // Muda status do atendimento para Pesquisa
        atendimento.status = "Pesquisa";
        await new Atendimento({ id: atendimento.id, status: "Pesquisa" }).save({
          require: false,
        });

        // Envia msg de pesquisa
        if (atendimento.queueTypeID === 5) {
          return Zenvia.socket.emit(
            "newWhatsMsgZenvia",
            {
              zenviaID: confige.zenviaID,
              from: confige.from,
              to: atendimento.fromID,
              text: pesquisa.descricao,
            },
            (retorno) => {}
          );
        }
        if (atendimento.queueTypeID === 6) {
          return Infobip.socket.emit(
            "newWhatsMsgInfobip",
            {
              baseurl: confige.baseurl,
              authorization: confige.authorization,
              to: atendimento.fromID,
              text: pesquisa.descricao,
            },
            (retorno) => {}
          );
        }
        if (atendimento.queueTypeID === 3) {
          return WhatsApp.socket.emit("newWhatsMsg", {
            instanceID: fila.nome,
            chatId: atendimento.fromID,
            msg: pesquisa.descricao,
          });
        }
        if (atendimento.queueTypeID === 2) {
          return WebChat.socket.emit(
            "message",
            JSON.stringify({
              queue: fila.nome,
              email: atendimento.fromID,
              resposta: pesquisa.descricao,
              xcontactID: config.csa.id,
              protocolo: atendimento.id,
              event: "QueueSemAgentes",
            })
          );
        }
        if (atendimento.queueTypeID === 7) {
          return Gupshup.socket.emit(
            "newWhatsMsgGupshup",
            {
              apikey: configGup.apikey,
              source: configGup.source,
              to: atendimento.fromID,
              text: pesquisa.descricao,
            },
            (retorno) => {
              log.error(`GUPSHUP RETORNO`, retorno);
            }
          );
        }
        if (atendimento.queueTypeID === 4) {
          var lastMsg = await AtendimentoMensagem.query
            .require(true)
            .first()
            .where({ idAtendimento: dados.protocolo })
            .orderBy(`id DESC`)
            .fetch();
          return mail.respondeEmail({
            queue: fila.nome,
            email: atendimento.fromID,
            Msg: pesquisa.descricao,
            protocolo: atendimento.id,
            mailMessageID: lastMsg ? lastMsg.mailMessageID : null,
            assunto: atendimento.assunto,
            event: "QueueSemAgentes",
          });
        }

        // Fecha pesquisa depois depois de 5min
      } else {
        atendimento.status = "Encerrado";
        atendimento.dataFim = new Date(moment.tz(config.servidor.timezone));
        let faux = Ami.getFila(atendimento.queue);
        let at = await new Atendimento({
          id: atendimento.id,
          status: "Encerrado",
          dataFim: new Date(moment.tz(config.servidor.timezone)),
        }).save({ require: false });
        this.calculosFila(faux, at);
      }
    } catch (error) {
      log.error("ERRO A PROCESSAR PESQUISA", error);
    }
  };

  removeChat = async (ramal, atendimento) => {
    let fila = await Ami.getFila(atendimento.queue);
    let ft = new FilaTemp(fila);
    let remove = await ft.removerAtendimento(atendimento.id, ramal);
  };
  countAguardando = async (queue) => {
    const atendimentos = await Atendimento.query
      .where({ status: "Entrou" })
      .where({ queue: queue })
      .where({ ultimoAgente: null })
      .require(false)
      .fetch();
    if (atendimentos) {
      //Caso so tenha um nao precisamos dar a mensagem de fila...
      if (atendimentos.length > 1) {
        return atendimentos.length;
      } else {
        return 0;
      }
    }
  };
  exports.criaMsgParaEncaminhar = async (msg, atendimento) => {
    try {
      let msgs = await AtendimentoMensagem.query
      .require(false)
      .where({ idAtendimento: atendimento.id })
      .fetch();
      let anexos = [];
      let html = "<br/><hr/><br/>";
      if (msgs && msgs.length > 0) {
      for (let i = msgs.length - 1; i >= 0; i--) {
        let aux = msgs[i];
        if (!aux.dados_adicionais) aux.dados_adicionais = aux.dadosAdicionais;
        html += "<div style='border: 1px solid #ccc; padding: 10px; margin-bottom: 10px;'>";
        if (aux.dados_adicionais)
        html += "<strong>De:</strong> " + JSON.parse(aux.dados_adicionais).from + "<br/>";
        html += "<strong>Data:</strong> " + aux.dataHora + "<br/>";
        html += "<br/>" + aux.texto + "<br/>";
        let anexo = await MensagemAnexos.query
        .require(false)
        .where({ idMensagem: aux.id })
        .fetch();
        if (anexo) {
        for (let a of anexo) {
          let name = a.caminho.split(`/`)[6];
          anexos.push({ filename: name, path: a.caminho });
        }
        }
        html += "</div>";
      }
      return { texto: html, files: anexos.length > 0 ? anexos : null };
      }
    } catch (error) {
      console.error(error);
    }
  };
  encerraAtendimento = async (data) => {
    try {
      let atendimento = await Atendimento.fetchById(data.protocolo);
      if (atendimento) {
        var trocas = { $PROTOCOLO: atendimento.id };
        if (atendimento.queueTypeID === 3) {
          let instance = atendimento.queueFrom
            ? atendimento.queueFrom
            : atendimento.queue;
          this.WhatsApp.socket.emit(
            `deleteChat`,
            {
              clientID: config.whatsApi.clientID,
              instanceID: instance,
              chatId: atendimento.fromID,
            },
            async (retorno) => {
              console.log(`RETORNOU`, retorno);
            }
          );
        }
        console.log(`VAMOS VER O ULTIMOAGENTE`, atendimento.ultimoAgente);
        if (atendimento.ultimoAgente)
          ws.wsEvento.emit(
            `AtendimentoEncerradoDistribui`,
            atendimento.ultimoAgente
          );

        let fila = await Ami.getFila(atendimento.queue);
        myEmitter.emit("removeAguardando", {
          fila: fila,
          atendimento: atendimento,
        });
        myEmitter.emit("removeAtendimentoNaFila", {
          fila: atendimento.queue,
          agente: atendimento.ultimoAgente,
          data: new Date(),
          atendimentoId: atendimento.id,
          tipo: "encerramento",
        });
        myEmitter.emit("removeAtendimentoClient", { atendimento: atendimento });
        if (atendimento.status !== "Pesquisa") {
          this.ProcessPesquisa(atendimento);
          this.autoReply(atendimento, trocas, 2);
          console.log(
            `[LOG ATENDIMENTO ${atendimento.id}] Atendimento foi para pesquisa`
          );
        } else {
          this.autoReply(atendimento, trocas, 2);
          atendimento.status = "Encerrado";
          atendimento.dataFim = new Date(moment.tz(config.servidor.timezone));
          let at = await new Atendimento({
            id: atendimento.id,
            status: "Encerrado",
            dataFim: new Date(moment.tz(config.servidor.timezone)),
          }).save({ require: false });
          this.calculosFila(fila, at);
          console.log(
            `[LOG ATENDIMENTO ${atendimento.id}] Atendimento encerrado`
          );
        }
        instanciasPre.delete(
          `${atendimento.queueFrom || atendimento.queue}${atendimento.fromID}`
        );
      }
    } catch (error) {
      log.error(`ERRO NO ENCERRAATENDIMENTO`, error);
    }
  };
  //#endregion

  //#region METODOS DE ENVIO

  exports.sendFileMsg = async (data) => {
    return new Promise(async (resolve, reject) => {
      try {
        let dados = data;
        dados.caption = dados.message;
        console.log("LEGENDA", dados);
        let atendimento = await Atendimento.fetchById(data.protocolo);
        myEmitter.emit("novaMensagemAgente", {
          fila: atendimento.queue,
          data: new Date(),
          atendimentoId: atendimento.id,
          agente: atendimento.ultimoAgente,
          tipo: "sainte",
        });
        myEmitter.emit("filaStatus", {
          atendimento: atendimento,
          tipo: "enviado",
        });
        let auxFromID = atendimento.fromID.split(`@`)[0];
        console.log(auxFromID);
        if (!data.toID) data.toID = auxFromID;
        var fila = await Fila.query
          .require(true)
          .first()
          .where({ name: data.queue })
          .fetch();
        let config = fila.emailConfig;

        var filaGup = await Fila.query
          .require(true)
          .first()
          .where({ name: data.queueFrom ? data.queueFrom : data.queue })
          .fetch();
        let configGup = filaGup.emailConfig;
        var lastMsg = null;
        if (atendimento.queueTypeID == 4) {
          lastMsg = await AtendimentoMensagem.query
            .require(false)
            .first()
            .where({ idAtendimento: atendimento.id })
            .orderBy(`id DESC`)
            .fetch();
        }

        var today = new Date();
        const filaRedir = atendimento.queueFrom
          ? atendimento.queueFrom
          : atendimento.queue;
        //Caso for do tipo email precisamos do remetente que vem do client.....

        autoEncerramento.verificaTimer(null, atendimento);
        var dir = `/gravacoes/${filaRedir}/${today.getFullYear()}/${
          today.getMonth() + 1
        }/${today.getDate()}`;

        if (atendimento.queueTypeID !== 4) {
          for (let anexo of data.queueAnexos) {
            anexo.filename = data.filename;
            anexo.path = dados.caminhoArquivoLista
              ? dados.caminhoArquivoLista
              : dir + "/" + anexo.filename;
            anexo.caminho = anexo.path;
          }
        }

        if (atendimento.queueTypeID !== 4) {
          dados.remetente = dados.toID;
        }
        fs.mkdirSync(dir, { recursive: true });
        if (atendimento.queueTypeID === 4) {
          let dataAux = {};
          dataAux.filename = dados.file_name;
          dataAux.anexos = [];
          console.log(data.queueAnexos);
          for (let anexo of data.queueAnexos) {
            anexo.filename = anexo.filename;
            anexo.path = dir + "/" + anexo.filename;
            anexo.caminho = anexo.path;
            dataAux.anexos.push(anexo);
          }

          if (!dados.email) {
            dataAux.remetente = atendimento.fromID;
          } else {
            dataAux.remetente = dados.email;
          }
          dataAux.cc = dados.cc;
          dataAux.cco = dados.cco;
          dataAux.message = dados.message;
          dataAux.envelope = dados.envelope;
          dataAux.queue = atendimento.queue;
          dataAux.assunto = atendimento.assunto;
          dataAux.mailMessageID =
            lastMsg != null ? lastMsg.mailMessageID : null;

          if (data.encaminha) {
            let retorno = await this.criaMsgParaEncaminhar(
              dados.message,
              atendimento
            );
            dataAux.message = retorno.texto;
            if (retorno.files) {
              for (let file of files) {
                dataAux.anexos.push(file);
              }
            }
          }
          console.log(`DEBUG RESPONDE EMAIL`, dataAux);
          const retEmail = await mail.respondeEmail(dataAux);
          let auxEmail = {};
          auxEmail.emails = dados.email;
          auxEmail.from = dados.agente;
          this.addEmail(atendimento, auxEmail);

          let msg = await this.saveMsg(
            {
              idAtendimento: dados.protocolo,
              texto: dados.message,
              inOut: 2,
              agente: dados.agente,
              status: "seen",
              mailMessageID: retEmail ? retEmail.id : (lastMsg ? lastMsg.mailMessageID : null),
              dados_adicionais: JSON.stringify(auxEmail),
            },
            dados.queueAnexos
          );
          if (msg) {
            ws.broadcast({ protocolo: dados.protocolo, event: "SendSuccess" });
          }
          resolve(msg);
        }

        dados.mimeType = dados.type;
        dados.mimetype = dados.type;
        dados.Upload = "start";
        dados.legenda = dados.Msg;
        dados.caminho = dir + "/" + dados.file_name;
        dados.uid = uuid();

        if (dados.legenda == null) dados.legenda = " ";
        const { file, ...d } = dados;

        if (atendimento.queueTypeID === 5) {
          Zenvia.socket.emit("sendMsgFileZenvia", {
            zenviaID: config.zenviaID,
            from: config.from,
            to: dados.toID,
            dados: d,
          });
        }
        if (atendimento.queueTypeID === 6) {
          Infobip.socket.emit("sendMsgFileInfobip", {
            baseurl: config.baseurl,
            authorization: config.authorization,
            to: dados.toID,
            dados: d,
          });
        }
        if (atendimento.queueTypeID === 7) {
          Gupshup.socket.emit("sendMsgFileGupshup", {
            apikey: configGup.apikey,
            source: configGup.source,
            to: dados.toID,
            dados: d,
          });
        }
        if (atendimento.queueTypeID === 8) {
          Facebook.socket.emit("sendMsgFile", {
            pagetoken: config.pagetoken,
            sender_psid: dados.toID,
            dados: d,
          });
        }
        if (atendimento.queueTypeID === 3) {
          let filaredir =
            atendimento.queueFrom !== null
              ? atendimento.queueFrom
              : atendimento.queue;
          WhatsApp.socket.emit("sendMsgFile", {
            instanceID: filaredir,
            chatId: atendimento.fromID,
            dados: d,
          });
        }
        if (atendimento.queueTypeID === 2) {
          WebChat.socket.emit("sendMsgFileChat", {
            queue: atendimento.queue,
            uid: atendimento.fromID,
            clientID: Config.csa.id,
            dados: d,
          });
        }
        if (dados.client !== `newClient`) {
          var write = fs.createWriteStream(dir + "/" + dados.file_name);
          write.write(file);
        }

        var stream = fs.createReadStream(
          dados.caminhoArquivoLista
            ? dados.caminhoArquivoLista
            : dir + "/" + dados.file_name
        );
        try {
          stream.on("data", (chunk) => {
            d.Upload = "sending";
            try {
              if (atendimento.queueTypeID === 5) {
                Zenvia.socket.emit(
                  "sendMsgFileZenvia",
                  {
                    zenviaID: config.zenviaID,
                    from: config.from,
                    to: dados.toID,
                    dados: d,
                  },
                  null,
                  chunk
                );
              }
              if (atendimento.queueTypeID === 6) {
                Infobip.socket.emit(
                  "sendMsgFileInfobip",
                  {
                    baseurl: config.baseurl,
                    authorization: config.authorization,
                    to: dados.toID,
                    dados: d,
                  },
                  null,
                  chunk
                );
              }
              if (atendimento.queueTypeID === 7) {
                Gupshup.socket.emit(
                  "sendMsgFileGupshup",
                  {
                    apikey: configGup.apikey,
                    source: configGup.source,
                    to: dados.toID,
                    dados: d,
                  },
                  null,
                  chunk
                );
              }
              if (atendimento.queueTypeID === 8) {
                Facebook.socket.emit(
                  "sendMsgFile",
                  {
                    pagetoken: config.pagetoken,
                    sender_psid: dados.toID,
                    dados: d,
                  },
                  null,
                  chunk
                );
              }
              if (atendimento.queueTypeID === 3) {
                let filaredir =
                  atendimento.queueFrom !== null
                    ? atendimento.queueFrom
                    : atendimento.queue;
                WhatsApp.socket.emit(
                  "sendMsgFile",
                  {
                    instanceID: filaredir,
                    chatId: atendimento.fromID,
                    dados: d,
                  },
                  null,
                  chunk
                );
              }
              if (atendimento.queueTypeID === 2) {
                WebChat.socket.emit(
                  "sendMsgFileChat",
                  {
                    queue: atendimento.queue,
                    uid: atendimento.fromID,
                    clientID: Config.csa.id,
                    dados: d,
                  },
                  null,
                  chunk
                );
              }
            } catch (error) {
              log.error("DEU PAU AO UPAR ARQUIVO", error);
            }
          });
          stream.on("end", async () => {
            d.Upload = "end";
            if (atendimento.queueTypeID === 5) {
              let msg = await this.saveMsg(
                {
                  idAtendimento: dados.protocolo,
                  texto: dados.Msg,
                  inOut: 2,
                  agente: dados.agente,
                  status: "pending",
                },
                dados.queueAnexos
              );
              Zenvia.socket.emit(
                "sendMsgFileZenvia",
                {
                  zenviaID: config.zenviaID,
                  from: config.from,
                  to: dados.toID,
                  dados: d,
                },
                async (retorno) => {
                  //var socketAgente = ws.getSocketAgenteByFullName(dados.agente);
                  try {
                    ws.broadcast({
                      protocolo: data.protocolo,
                      event: "SendSuccess",
                    });
                    myEmitter.emit("SendSuccess", {
                      atendimento: atendimento,
                      message: msg,
                    });
                    msg.status = retorno.response.error ? "pending" : "seen";
                    msg.save();
                    console.log('ENTROU AQUIIIIIIIIIII', msg);
                    resolve(msg);
                    if (msg) {
                      ws.broadcast({
                        protocolo: dados.protocolo,
                        event: "SendSuccess",
                      });
                      myEmitter.emit("SendSuccess", {
                        atendimento: atendimento,
                        message: msg,
                      });
                    }
                  } catch (error) {
                    log.error("ERRO AO UPAR ANEXO", error);
                  }
                }
              );
            }
            if (atendimento.queueTypeID === 6) {
              let msg = await this.saveMsg(
                {
                  idAtendimento: dados.protocolo,
                  texto: dados.Msg,
                  inOut: 2,
                  agente: dados.agente,
                  status: "pending",
                },
                dados.queueAnexos
              );
              Infobip.socket.emit(
                "sendMsgFileInfobip",
                {
                  baseurl: config.baseurl,
                  authorization: config.authorization,
                  to: dados.toID,
                  dados: d,
                },
                async (retorno) => {
                  //var socketAgente = ws.getSocketAgenteByFullName(dados.agente);
                  try {
                    ws.broadcast({
                      protocolo: data.protocolo,
                      event: "SendSuccess",
                    });
                    msg.status = retorno.error ? "pending" : "seen";
                    msg.save();
                    if (msg) {
                      myEmitter.emit("SendSuccess", {
                        atendimento: atendimento,
                        message: msg,
                      });
                      resolve(msg);
                    }
                  } catch (error) {
                    log.error("ERRO AO UPAR ANEXO", error);
                  }
                }
              );
            }

            if (atendimento.queueTypeID === 7) {
              let msg = await this.saveMsg(
                {
                  idAtendimento: dados.protocolo,
                  texto: dados.Msg,
                  inOut: 2,
                  agente: dados.agente,
                  status: "pending",
                },
                dados.queueAnexos
              );
              Gupshup.socket.emit(
                "sendMsgFileGupshup",
                {
                  apikey: configGup.apikey,
                  source: configGup.source,
                  to: dados.toID,
                  dados: d,
                },
                async (retorno) => {
                  //var socketAgente = ws.getSocketAgenteByFullName(dados.agente);
                  try {
                    msg.mailMessageID = retorno.messageId;
                    ws.broadcast({
                      protocolo: data.protocolo,
                      event: "SendSuccess",
                    });
                    msg.status = retorno.error ? "pending" : "sended";
                    msg.save();
                    if (msg) {
                      myEmitter.emit("SendSuccess", {
                        atendimento: atendimento,
                        message: msg,
                      });
                      resolve(msg);
                    }
                  } catch (error) {
                    log.error("ERRO AO UPAR ANEXO", error);
                  }
                }
              );
            }

            if (atendimento.queueTypeID === 8) {
              let msg = await this.saveMsg(
                {
                  idAtendimento: dados.protocolo,
                  texto: dados.Msg,
                  inOut: 2,
                  agente: dados.agente,
                  status: "pending",
                },
                dados.queueAnexos
              );
              Facebook.socket.emit(
                "sendMsgFile",
                {
                  pagetoken: config.pagetoken,
                  sender_psid: dados.toID,
                  dados: d,
                },
                async (retorno) => {
                  //var socketAgente = ws.getSocketAgenteByFullName(dados.agente);
                  try {
                    ws.broadcast({
                      protocolo: data.protocolo,
                      event: "SendSuccess",
                    });
                    msg.status = retorno.error ? "pending" : "seen";
                    msg.save();
                    if (msg) {
                      myEmitter.emit("SendSuccess", {
                        atendimento: atendimento,
                        message: msg,
                      });
                      resolve(msg);
                    }
                  } catch (error) {
                    log.error("ERRO AO UPAR ANEXO", error);
                  }
                }
              );
            }

            if (atendimento.queueTypeID === 3) {
              let filaredir =
                atendimento.queueFrom !== null
                  ? atendimento.queueFrom
                  : atendimento.queue;
              let msg = await this.saveMsg(
                {
                  idAtendimento: dados.protocolo,
                  texto: dados.Msg,
                  inOut: 2,
                  agente: dados.agente,
                },
                dados.queueAnexos
              );
              console.log("PAZJUSTICAELIBERDADE", msg);

              WhatsApp.socket.emit(
                "sendMsgFile",
                { instanceID: filaredir, chatId: atendimento.fromID, dados: d },
                async (retorno) => {
                  try {
                    msg.status = retorno.error ? "pending" : "delivered";
                    msg.mailMessageID = !retorno.error ? retorno.msg.id : null;
                    msg.save();
                    if (msg) {
                      console.log(`MESSAGE`, msg);
                      myEmitter.emit("SendSuccess", {
                        atendimento: atendimento,
                        message: msg,
                      });
                      resolve(msg);
                    }
                    console.log(retorno);
                  } catch (error) {
                    console.error("ERRO AO UPAR ANEXO", error);
                  }
                }
              );
            }

            if (atendimento.queueTypeID === 2) {
              let msg = await this.saveMsg(
                {
                  idAtendimento: dados.protocolo,
                  texto: dados.Msg,
                  inOut: 2,
                  agente: dados.agente,
                },
                dados.queueAnexos
              );
              WebChat.socket.emit(
                "sendMsgFileChat",
                {
                  queue: atendimento.queue,
                  uid: atendimento.fromID,
                  clientID: Config.csa.id,
                  dados: d,
                },
                async (retorno) => {
                  try {
                    msg.status = retorno.error ? "pending" : "delivered";
                    msg.mailMessageID = !retorno.error ? retorno.msg.id : null;
                    msg.save();
                    if (msg) {
                      console.log(`MESSAGE`, msg);
                      myEmitter.emit("SendSuccess", {
                        atendimento: atendimento,
                        message: msg,
                      });
                      resolve(msg);
                    }
                    console.log(retorno);
                  } catch (error) {
                    console.error("ERRO AO UPAR ANEXO", error);
                  }
                }
              );
            }
          });
          stream.on("error", (err) => {
            console.error("Erro no Reader", err);
          });
          stream.on("close", (err) => {});
        } catch (error) {
          console.error("ERRRO AO PROCESSAR STREAM", error);
          reject(error);
        }
      } catch (error) {
        reject(error);
        console.error("Erro ao procesar sendMsgFile", error);
      }
    });
  };
  retryMsg = async (data) => {
    try {
      let atendimento = await Atendimento.fetchById(data.protocolo);
      autoEncerramento.verificaTimer(null, atendimento);
      if (atendimento.queueTypeID == 3) {
        let filaredir =
          atendimento.queueFrom !== null
            ? atendimento.queueFrom
            : atendimento.queue;
        WhatsApp.socket.emit(
          "deleteMessage",
          {
            instanceID: filaredir,
            chatId: atendimento.fromID,
            id: data.msg.mailMessageID,
          },
          async (retorno) => {
            let msg = await AtendimentoMensagem.fetchById(data.msg.id);
            msg.status = `deleted`;
            msg.save();
            ws.broadcast({ protocolo: data.protocolo, event: "SendSuccess" });
          }
        );
      }
    } catch (error) {
      console.error(error);
    }
  };
  getProtocolo = async (msg, reply) => {
    try {
      let cliente = await Cliente.getClienteByMsg(msg);
      if (cliente) {
        let pre = await FilaPreAtendimento.query
          .require(false)
          .first()
          .where({ queueName: msg.instanceID })
          .fetch();
        let tem = false;
        config.ura_arquivo.forEach((ura) => {
          if (ura.fila == msg.instanceID) tem = ura;
        });
        if (tem) pre = tem;
        if (pre) {
          let atendimento = await Atendimento.query
            .require(false)
            .first()
            .where({ idCliente: cliente.id })
            .where(
              Atendimento.where.or(
                Atendimento.where.equal({ queue: msg.instanceID }),
                Atendimento.where.equal({ queueFrom: msg.instanceID })
              )
            )
            .where({ status: "PreAtendimento" })
            .fetch();
          if (!atendimento) {
            atendimento = await new Atendimento({
              assunto: msg.assunto,
              linkedid: msg.zenviaID,
              fromID: msg.from,
              fromName: msg.name,
              queue: msg.instanceID,
              idCliente: cliente.id,
              ativo: false,
              sentido: "Entrante",
              status: "PreAtendimento",
              queueTypeID: msg.queueTypeID,
              action: "WhatsAppIn",
              dadosAdicionais: { nome: msg.name, remetente: msg.from },
            }).save();
            let fila = await Ami.getFila(msg.instanceID);
            addAtendimentoFila(fila, atendimento);
            reply(atendimento);
          }
          reply(atendimento);
          return;
        }
        let atendimento = await Atendimento.getAtendimento(msg, cliente);
        console.log(`AQUI+++++++++`, atendimento.id);
        reply(atendimento);
      }
    } catch (error) {
      log.error(`deu pau no get protocolo`, error);
    }
  };
  exports.addEmail = async (atendimento, data) => {
    try {
      console.log(`ADDEMAIL`, data);
      let emails = data.emails;
      if (atendimento.email) {
        atendimento.email = JSON.parse(atendimento.email);
      } else {
        atendimento.email = [];
      }
      if (data.emails) {
        for (let email of emails) {
          if (!atendimento.email.find((v) => v === email))
            atendimento.email.push(email);
        }
      }
      atendimento.email = atendimento.email
        ? JSON.stringify(atendimento.email)
        : null;
      new Atendimento(atendimento).save();
    } catch (error) {
      console.error(error);
    }
  };
  getAtendimentoEmail = async (data) => {
    let cliente = await Cliente.getClienteByMsg(data);
    if (data.references && data.references.length > 0) {
      let messages = await AtendimentoMensagem.query.require(false).where(AtendimentoMensagem.where.in('mailMessageID', data.references)).fetch();
      if (messages && messages.length > 0) {
        console.log(`ACHAMOS O ATENDIMENTO`, messages[0].idAtendimento)
        let atendimento = await Atendimento.fetchById(messages[0].idAtendimento);
        if (atendimento) {
          return atendimento;
        }
      }
    }
    if (data.protocolo) {
      let atendimento = await Atendimento.fetchById(JSON.parse(data.protocolo));
      if (atendimento) return atendimento;
    }
    return await new Atendimento({
      assunto: data.assunto,
      linkedid: data.zenviaID,
      fromID: data.from,
      fromName: cliente.nome,
      queue: data.instanceID,
      idCliente: cliente.id,
      ativo: false,
      sentido: "Entrante",
      status: "Entrou",
      queueTypeID: data.queueTypeID,
      action: "WhatsAppIn",
      dadosAdicionais: { nome: data.name, remetente: data.from },
    }).save();
  };
  setQueue = async (data, metodo) => {
    let that = this;
    let job = async function () {
      try {
        if (metodo === "routerMsg") await routerMsg(data);
        if (metodo === "enviaParaAgente")
          enviaParaAgenteNew(data.atendimento, data.msg);
        if (metodo === "newChat") await routerMsg(data);
        if (metodo === "getProtocolo") await getProtocolo(data.msg, data.reply);
      } catch (error) {
        console.log(error);
      }
    };
    //job.id = metodo;
    if (metodo === "routerMsg") processaQueue.push(job);
    if (metodo === "newChat") processaQueue.push(job);
    if (metodo === "getProtocolo") processaQueue.push(job);
    if (metodo === "enviaParaAgente") processaQueueEnvia.push(job);
  };
  readMessage = (msg) => {
    let obj = {
      instanceID: msg.instanceID,
      chatId: msg.from,
      id: msg.mailMessageID,
    };
    console.log(`READ===========`, obj);
    WhatsApp.socket.emit("readMessage", obj, (retorno) => {
      console.log(`RETORNO SEEEN`, retorno);
    });
  };
  verificaSeVeioDeLista = async (msg) => {
    try {
      let cliente = await Cliente.BuscaClientePorNumero(msg.from);
      if (cliente && cliente.length > 0) {
        cliente = cliente[0];
        let atendimento = await Atendimento.query
          .require(false)
          .first()
          .where({ idCliente: cliente.id })
          .where(
            Atendimento.where.or(
              Atendimento.where.equal({ queue: msg.instanceID }),
              Atendimento.where.equal({ queueFrom: msg.instanceID })
            )
          )
          .where({ status: "lista_transmissao" })
          .fetch();
        if (!atendimento) return false;
        msg.idAtendimento = atendimento.id;
        msg.fromID = atendimento.fromID;
        // msg.dataHora = new Date();
        msg.agente = atendimento.ultimoAgente;
        let m = await this.saveMsg(msg, msg.queueAnexos);
        atendimento.status = "Entrou";
        await atendimento.save();
        myEmitter.emit("updateAtendimentoAgente", atendimento);
        await enviaParaAgente(atendimento, m);
        return atendimento;
      } else {
        return false;
      }
    } catch (error) {}
  };
  //ESTE METODO E O RESPONSAVEL POR 'ROTEAR' AS NOVAS MENSAGENS PS: ELE E BRABO
  routerMsg = async (msg) => {
    try {
      console.log(`ROUTER MSG`, msg);
      //#region VERIFICANDO
      //pegaFilasParaDistribuir();
      msg.idCliente = msg.from;
      msg.nomeCliente = msg.name;
      let file = null;
      if (msg.queueAnexos && msg.queueAnexos.length > 0) {
        file = msg.queueAnexos;
      } else {
        file = msg.file_name
          ? { caminho: msg.file_name, mimeType: msg.mimeType }
          : undefined;
        msg.queueAnexos = [];
        if (file) {
          msg.queueAnexos.push(file);
        }
      }
      const eraListaTransmissao = await verificaSeVeioDeLista(msg);
      if (eraListaTransmissao) return;
      console.log(`ANEXOS`, msg.queueAnexos);
      var ura = null;
      //Vamos verificar se ja temos uma instancia para esta fila e numero de cliente caso contrario criamos uma no nosso map
      let pre = instanciasPre.get(`${msg.instanceID}${msg.from}`);
      if (!pre) {
        instanciasPre.set(`${msg.instanceID}${msg.from}`, new preAtendimento());
        pre = instanciasPre.get(`${msg.instanceID}${msg.from}`);
      }

      if (msg.queueTypeID === 3) {
        readMessage(msg);
        let socket = WhatsApp.socket;
        var ura = await pre.routerUra(socket, msg);
      }
      if (msg.queueTypeID === 5) {
        let socket = Zenvia.socket;
        var ura = await pre.routerUra(socket, msg);
      }
      if (msg.queueTypeID === 6) {
        let socket = Infobip.socket;
        var ura = await pre.routerUra(socket, msg);
      }
      if (msg.queueTypeID === 7) {
        let socket = Gupshup.socket;
        var ura = await pre.routerUra(socket, msg);
      }
      if (msg.queueTypeID === 2) {
        let socket = WebChat.socket;
        var ura = await pre.routerUra(socket, msg);
      }
      let cliente = await Cliente.getClienteByMsg(msg);

      console.log(`CLIENTE`, cliente);
      if (ura && ura !== null) {
        let auxAtendimento = await Atendimento.query
          .require(false)
          .first()
          .where({ idCliente: cliente.id })
          .where(
            Atendimento.where.or(
              Atendimento.where.equal({ queue: msg.instanceID }),
              Atendimento.where.equal({ queueFrom: msg.instanceID })
            )
          )
          .where({ status: "PreAtendimento" })
          .fetch();
        if (auxAtendimento)
          autoEncerramento.verificaTimer(null, auxAtendimento);
        return;
      }
      //#endregion
      //#region VERIFICANDO CLIENTE E ATENDIMENTO
      let atendimento = msg.queueTypeID === 4 ? await getAtendimentoEmail(msg) : await Atendimento.getAtendimento(msg, cliente);
      atendimento.count++;
      if (atendimento.queueTypeID == 7) atendimento.fromID = msg.from;
      atendimento.save();
      msg.idAtendimento = atendimento.id;
      msg.fromID = atendimento.fromID;
      let fila = await Ami.getFila(atendimento.queue);
      if (!cliente.profileImage && msg.queueTypeID === 3) {
        console.log("ENTROU NO BAIXAR IMAGEM DO CLIUENTE");
        try {
          WhatsApp.socket.emit(
            "getProfileImg",
            {
              clientID: config.whatsApi.clientID,
              instanceID: msg.instanceID,
              chatId: atendimento.fromID,
            },
            async (retorno) => {
              if (!retorno.error) {
                cliente.profileImage = await Cliente.downloadImageNew(
                  retorno.msg,
                  cliente
                );
                await new Cliente(cliente).save();
              }
            }
          );
        } catch (error) {
          console.error("ERRO AO BAIXAR IMAGEM", error);
        }
      }
      //#endregion
      //#region VOTAPESQUISA
      if (atendimento.status == "Pesquisa") {
        log.info(
          `[LOG ATENDIMENTO ${atendimento.id}] Estava na pesquisa bora computar o voto`
        );

        myEmitter.emit("VotaPesquisa", atendimento);
        votaPesquisa(atendimento, cliente, msg);
        return;
      }
      if (atendimento.queueTypeID === 4) {
        this.addEmail(atendimento, JSON.parse(msg.dados_adicionais));
      }
      msg.agente = atendimento.ultimoAgente;
      console.log('ANTES DE ENTRAR NO SAVE MSG', msg)
      let m = await this.saveMsg(msg, msg.queueAnexos);
      if (!atendimento.ultimoAgente) {
        myEmitter.emit("filaNovaMensagem", {
          fila: atendimento.queue,
          data: new Date(),
          atendimentoId: atendimento.id,
          agente: atendimento.ultimoAgente,
        });
      }
      if (atendimento.ultimoAgente) {
        myEmitter.emit("novaMensagemAgente", {
          fila: atendimento.queue,
          data: new Date(),
          atendimentoId: atendimento.id,
          agente: atendimento.ultimoAgente,
          tipo: "entrante",
        });
      }
       
      console.log('MENSAGEM', m);
      msg.messageID = m.id;
      msg.dadosAdicionais = msg.dados_adicionais;
      //#endregion
      //#region BOAS VINDAS
      myEmitter.emit("filaStatus", {
        atendimento: atendimento,
        tipo: "recebido",
      });
      if (!atendimento.ativo) {
        atendimento.ativo = true;
        atendimento = await atendimento.save();
        //Bora verificar se esta dentro do horario..
        let verificarTurno = await verificaTurno(cliente, atendimento);
        if (!verificarTurno) return;
        let trocas = {
          $PROTOCOLO: atendimento.id,
          $NOME_CLIENTE: cliente.nome,
        };
        this.autoReply(atendimento, trocas, 4);
        myEmitter.emit("BoasVindas", atendimento);
        myEmitter.emit("filaNovoAtendimento", {
          fila: atendimento.queue,
          numero: cliente.numero,
          nome: cliente.nome,
          atendimentoId: atendimento.id,
          data: new Date(),
        });
        myEmitter.emit("filaStatus", {
          atendimento: atendimento,
          tipo: "novo",
        });
        console.log(
          `[LOG ATENDIMENTO ${atendimento.id}] Bora dar a mensagem inicial`
        );

        // addAguardando(fila, atendimento);
        //return;
      }
      //#endregion
      //#region envia para rota e retorna
      if (cliente.idGrupo) {
        let grupo = await ClienteGrupo.fetchById(cliente.idGrupo);
        if (
          grupo.roteia &&
          grupo.rota !== atendimento.queue &&
          !atendimento.queueFrom
        ) {
          atendimento.queueFrom = atendimento.queue;
          atendimento.queue = grupo.rota;
          atendimento.save();
          let filaRota = await Ami.getFila(grupo.rota);
          //tem grupo vamos mandar para rota e retornar
          this.addAguardando(filaRota, atendimento);
          console.log(
            `[LOG ATENDIMENTO ${atendimento.id}] Enviamos para a rota ${grupo.rota}`
          );

          myEmitter.emit("TinhaRota", atendimento);
          return;
        }
      }
      //#endregion
      //#region processa ultimo agente e retorna
      if (atendimento.ultimoAgente !== null) {
        //vamos mandar para o agente e retornar

        await enviaParaAgente(atendimento, msg);
        myEmitter.emit("TinhaUltimoAgente", atendimento);
        console.log(
          `[LOG ATENDIMENTO ${atendimento.id}] Tinha agente atendendo`
        );

        return;
      }
      //#endregion
      //#region verifica turno e retorna
      let verificarTurno = await verificaTurno(cliente, atendimento);
      if (!verificarTurno) {
        console.log(`[LOG ATENDIMENTO ${atendimento.id}] Nao estava no turno`);
        return;
      }
      //#endregion
      //#region processa sem agentes e retorna
      if (fila.agentes.length === 0) {
        //nao tem agente bora fazer algo e retornar
        this.autoReply(atendimento, { $NOME_CLIENTE: cliente.nome }, 1);
        this.addAguardando(fila, atendimento);
        console.log(`[LOG ATENDIMENTO ${atendimento.id}] Sem agentes na fila`);

        myEmitter.emit("SemAgentes", atendimento);
        return;
      }
      //#endregion
      //#region processa aguardando e retorna
      let retorno = await countAguardando(atendimento.queue);
      if (retorno > 0) {
        await this.addAguardando(fila, atendimento);
        let p = fila.ligacoes.findIndex((at) => {
          return at.id == atendimento.id;
        });
        if (p && p !== -1) {
          if (p < 0) {
            p = 0;
          }
          this.autoReply(
            atendimento,
            { $POSICAO: p + 1, $NOME_CLIENTE: cliente.nome },
            3
          );
        }
        console.log(`[LOG ATENDIMENTO ${atendimento.id}] Tem fila`);

        myEmitter.emit("TinhaAguardando", atendimento);
        return;
      }
      //#endregion processa aguardando
      //PASSOU POR TUDO ADICIONAMOS NO AGUARDANDO
      await this.addAguardando(fila, atendimento);
      this.autoReply(
        atendimento,
        { $POSICAO: 1, $NOME_CLIENTE: cliente.nome },
        3
      );
      console.log(`[LOG ATENDIMENTO ${atendimento.id}] Primeiro da fila`);

      myEmitter.emit("PrimeiroDaFila", atendimento);
      //addAguardando(fila, atendimento);
    } catch (error) {
      console.error("ERRO NO ROUTERMSG DO OMNI", error);
    }
  };
  //#endregion
  next();
};
exports.register.attributes = {
  name: "xcontact-omni",
};
exports.OmniEventos = myEmitter;
