const AtendimentoMensagem = require('../../../models/AtendimentoMensagem')
const queue = require("queue")
const EventEmitter = require("events")
const myEmitter = new EventEmitter()

function makeJob (MensagemData, MensagemWhere) {
    const job = async function () {
        //log.debug(`JOB para dados ${JSON.stringify(InstanceData)}`)
        try {
            if(MensagemWhere) {
                const m = await AtendimentoMensagem.query
                .require(false)
                .where(MensagemWhere)
                .update(MensagemData)
                if(m && m.length > 0) {
                    return m[0]
                } else {
                    job.reject = new Error('Nenhum registro encontrado')
                }                
            } else {
                return await new AtendimentoMensagem(MensagemData).update();
            }
        } catch (e) {
            //log.error(`[makeJob] ${e}`);
            job.reject = e;
        }
    };

    job.cancel = function () {
        if (job.reject) {
            job.reject({ canceled: true });
        }
    };
    // job.id = MensagemData.id;
    return job;
}

module.exports = class AtendimentoMensagemQueue {
    constructor() {

    }
    start () {
        this.q = queue({
            timeout: 30 * 1000,
            autostart: true,
            concurrency: 1
        });

        this.q.on("timeout", function (next, job) {
            //log.warn(`job [${job.id}] timed out.`);
            next();
        });

        this.q.on("success", function (result, job) {
            myEmitter.emit('success', result)
            //log.debug(`job [${job.id}] completed. ${JSON.stringify(result)}`);
            //log.debug(`job [${job.id}] completed.`);
        });

        // this.q.on("error", function (err, job) {
        //     if (err.canceled) {
        //         log.warn(`job [${job.id}] was canceled.`);
        //     } else {
        //         log.error(`job [${job.id}] failed with error [${err}].`);
        //     }
        // });

        // this.q.on("start", function (job) {
        //     log.debug(`job [${job.id}] started.`);
        // });
    }
    on(event, listener) {
        return myEmitter.on(event, listener)
    }
    add (MensagemData, MensagemWhere) {
        this.q.push(makeJob(MensagemData, MensagemWhere));
    }
}