'use strict'

const { Pool, Client } = require('pg');
const config = require('../../../config.json');
const dotenv = require('dotenv');
dotenv.config();
//const pgDefaults = require('pg').defaults;
//const pgTypes = require('pg').types;


if (process.env && process.env.DEV_HOST) {
  config.database.host = process.env.DEV_HOST;
}

const pool = new Pool({
  connectionString: config.database.server + '://' + config.database.usuario + ':' + config.database.senha + '@' + config.database.host + ':' + config.database.porta + '/' + config.database.base
})

const knex = require('knex')({
  client: 'pg',
  connection: {
    host: config.database.host,
    port: config.database.porta,
    user: config.database.usuario,
    password: config.database.senha,
    database: config.database.usuario,
  },
  pool: {
    min: config.database.min,
    max: config.database.max,
  }
});

const connection = {
  host: config.database.host,
  port: config.database.porta,
  user: config.database.usuario,
  password: config.database.senha,
  database: config.database.usuario
}

// https://knorm.netlify.com/getting-started.html
const { knorm } = require('@knorm/knorm');
const { knormPostgres } = require('@knorm/postgres');
const { knormRelations } = require('@knorm/relations');
const { knormPaginate } = require('@knorm/paginate');
const orm = knorm().use(knormPostgres({ connection })).use(knormRelations()).use(knormPaginate());

module.exports = {
  query: (text, params) => pool.query(text, params),
  knex: knex,
  orm: orm
}
