const AgentesSocket = new Map()
const Ami = require('../../../../../ami/index')
const Agente = require('../../../../../models/Agente')

exports.Login = async (socket, request) => {
    console.log(`[WebRTCNativo] - Recebi pedido de login do IP: ${socket.handshake.address}`);
    try {
        const ret = await Agente.query
            .where({ token: request.token })
            .fields(['id', 'nome', 'fullname', 'token', 'token_create'])
            .first()
            .require(true)
            .fetch();
        socket.LoginOk = true;
        socket.User = ret
        AgentesSocket.set(ret.id, socket)
        return ret
    } catch (error) {
        return error;
    }
}

exports.status = async (socket) => {
    console.log(`[WebRTCNativo] - Recebi pedido de status do IP: ${socket.handshake.address}`);
    try {
        const ret = Ami.getAgentePeloID(socket.User.id)
        console.log('Ami retornou status = ', ret)
        return ret
    } catch (error) {
        return error;
    }
}

exports.getAgenteSocketByAgenteId = (id) => {
    console.log(`Chamou getAgenteSocketByAgenteId para id = ${id}`)
    return AgentesSocket.get(id)
}

exports.getAllSockets = (socket) => {
    console.log(`[WebRTCNativo] - Recebi pedido de getAllSockets do IP: ${socket.handshake.address}`);
    if (AgentesSocket.size > 0) {
        return [...AgentesSocket.values()];
    }
    else {
        return null;
    }
}

exports.Deslogar = (socket) => {
    console.log(`[WebRTCNativo] - Desconectou, IP: ${socket.handshake.address}, SocketID: ${socket.id}`);
    if (socket.User) {
        AgentesSocket.delete(socket.User.id)
    }    
}