const { client, atender, desligar, rejeitar } = require('../../callManager')


exports.msg = async (socket, request) => {
    console.log(`[WebRTCNativo] - Processando msg solicitada pelo agente ${socket.User}`);

    try {
        request.agente = {
            id: socket.User.id,
            nome: socket.User.fullname
        }
        client.emit('msg', request)
        return 'Comando enviado em async'
    } catch (error) {
        console.log('Erro ao processar msg, ', error)
        return error
    }
}

exports.atender = async (socket, request) => {
    console.log('[WebRTCNativo] Agente chamando atender: ', request)
    // Agente entra na sala que os dados da ligacao vao trafegar        
    socket.join(request.call.room)
    try {
        // Envia msg de atendimento pro CSA
        request.agente = {
            id: socket.User.id,
            nome: socket.User.fullname
        }
        atender(request)
        // console.log('[WebRTCNativo] Enviando msg para CSA: ', request)
        //client.emit('msg', request)
        return 'Comando enviado sem async'        
    } catch (error) {
        console.log('Erro ao processar atender, ', error)
        return error
    }
}

exports.rejeitar = async (socket, request) => {
    console.log('[WebRTCNativo] Agente chamando REJEITAR: ', request)
    try {
        // Envia msg de atendimento pro CSA
        request.agente = {
            id: socket.User.id,
            nome: socket.User.fullname
        }
        return rejeitar(request)
    } catch (error) {
        console.log('Erro ao processar rejeitar, ', error)
        return error
    }
}

exports.desligar = async (socket, request) => {
    console.log('[WebRTCNativo] Agente chamando desligar: ', request)
    try {
        request.agente = {
            id: socket.User.id,
            nome: socket.User.fullname
        }
        desligar(request)
        return 'Comando enviado sem async'        
    } catch (error) {
        console.log('Erro ao processar atender, ', error)
        return error
    }
}