/**
 * O objetivo deste teste é interagir com os agentes atravez do websocket criado no serviço do xcontact-server
 */
const agentes = new Map()

exports.start = (ioWebRTCNativo) => {
    console.log('Iniciando WebRTC Nativo')
    ioWebRTCNativo.on('connection', (socket) => {
        console.log(`Nova conexao de agente /webrtc-nativo, IP: ${socket.handshake.address}, SocketID: ${socket.id}`)
        console.log('handshake: ', socket.handshake)
        // console.log('Request:', socket.request)

        socket.on(`msg`, (request) => {
            console.log('Query: ', socket.handshake.query)
            console.log('Agente chamando msg: ', request)
        })

        socket.on(`login`, (request) => {
            console.log('Query: ', socket.handshake.query)
            console.log('Agente chamando login: ', request)
            // Super login
            socket.XcAgente = request.agente
            agentes.set(request.agente.id, socket)
        })

        socket.on('disconnect', () => {
            console.log(`DISCONNECT de /webrtc-nativo, IP: ${socket.handshake.address}, SocketID: ${socket.id}`)
            if(socket.XcAgente) {
                console.log('Opa, foi um agente que desconctou')
                console.log(socket.XcAgente)
                agentes.delete(socket.XcAgente.id)
            }
        })
    });
}