const io = require('socket.io-client')
const readline = require('readline')

const rl = readline.createInterface({
    input: process.stdin,
    output: process.stdout,
    prompt: 'Xcontact agente CLI> '
})

const id = new Date().getMilliseconds()+ Math.floor(Math.random()*1000)
const agente = {
    id, 
    name: `Agente_${id}`, 
    status: 1
}


const client = io('ws://localhost:8000')

client.on('connect', () => {
    console.log('Opa...conectou')
    rl.prompt();
})

client.on('disconnect', (e) => {
    console.log(e);
    console.log('Desconectou do servidor');
    rl.prompt();
});

client.on('msg', (msg) => {    
    console.log('Mensagem do servidor: ', msg);
    rl.prompt();
});

rl.on('line', (line) => {
    let pars = line.trim().split(' ');

    switch (pars[0]) {
        case 'sair':
        case 'quit':
        case 'q':
            rl.close();
            break;
        case '':
            break;
        case 'getFilas':
            client.emit(`getFilas`, { agente }, response => {
                //console.log(`Retorno de getFilas ${JSON.stringify(response, null, 2)}`);
                console.log(`Retorno de getFilas: `, response);
                rl.prompt();
            })
            break;
        case 'joinFila':
            client.emit(`joinFila`, { agente, fila: pars[1] }, response => {
                console.log(`Retorno de joinFila ${JSON.stringify(response, null, 2)}`);
                rl.prompt();
            })
            break;
        case 'atender':
            client.emit(`atender`, { agente, room: pars[1], type: 'atender' }, response => {
                console.log(`Retorno de atender ${JSON.stringify(response, null, 2)}`);
                rl.prompt();
            })
            break;
        case 'msg':
            client.emit(`msg`, { agente, room: pars[1], type: 'teste', data_msg: pars[2] }, response => {
                console.log(`Retorno de msg ${JSON.stringify(response, null, 2)}`);
                rl.prompt();
            })
            break;
        default:
            break;
    }
    rl.prompt();
}).on('close', () => {
    console.log('Até logo!');
    process.exit(0);
});